# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from logicmonitor_sdk.models.report_base import ReportBase  # noqa: F401,E501

class AuditLogReport(ReportBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'filter': 'str',
        'sorted_by': 'str',
        'date_range': 'str',
        'columns': 'list[DynamicColumn]',
        'username': 'str'
    }
    if hasattr(ReportBase, "swagger_types"):
        swagger_types.update(ReportBase.swagger_types)

    attribute_map = {
        'filter': 'filter',
        'sorted_by': 'sortedBy',
        'date_range': 'dateRange',
        'columns': 'columns',
        'username': 'username'
    }
    if hasattr(ReportBase, "attribute_map"):
        attribute_map.update(ReportBase.attribute_map)

    def __init__(self, filter=None, sorted_by=None, date_range=None, columns=None, username=None, *args, **kwargs):  # noqa: E501
        """AuditLogReport - a model defined in Swagger"""  # noqa: E501
        self._filter = None
        self._sorted_by = None
        self._date_range = None
        self._columns = None
        self._username = None
        self.discriminator = None
        if filter is not None:
            self.filter = filter
        if sorted_by is not None:
            self.sorted_by = sorted_by
        if date_range is not None:
            self.date_range = date_range
        if columns is not None:
            self.columns = columns
        if username is not None:
            self.username = username
        ReportBase.__init__(self, *args, **kwargs)

    @property
    def filter(self):
        """Gets the filter of this AuditLogReport.  # noqa: E501

        The filter setting for the report  # noqa: E501

        :return: The filter of this AuditLogReport.  # noqa: E501
        :rtype: str
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this AuditLogReport.

        The filter setting for the report  # noqa: E501

        :param filter: The filter of this AuditLogReport.  # noqa: E501
        :type: str
        """

        self._filter = filter

    @property
    def sorted_by(self):
        """Gets the sorted_by of this AuditLogReport.  # noqa: E501

        The sort option for the repor  # noqa: E501

        :return: The sorted_by of this AuditLogReport.  # noqa: E501
        :rtype: str
        """
        return self._sorted_by

    @sorted_by.setter
    def sorted_by(self, sorted_by):
        """Sets the sorted_by of this AuditLogReport.

        The sort option for the repor  # noqa: E501

        :param sorted_by: The sorted_by of this AuditLogReport.  # noqa: E501
        :type: str
        """

        self._sorted_by = sorted_by

    @property
    def date_range(self):
        """Gets the date_range of this AuditLogReport.  # noqa: E501

        The Time Range configured for the report: Last 2 hours | Last 24 hours | Last calendar day | Last 7 days | Last 14 days | Last 30 days | Last calendar month | Last 365 days | Any custom date range in this format: YYYY-MM-dd hh:mm TO YYYY-MM-dd hh:mm  # noqa: E501

        :return: The date_range of this AuditLogReport.  # noqa: E501
        :rtype: str
        """
        return self._date_range

    @date_range.setter
    def date_range(self, date_range):
        """Sets the date_range of this AuditLogReport.

        The Time Range configured for the report: Last 2 hours | Last 24 hours | Last calendar day | Last 7 days | Last 14 days | Last 30 days | Last calendar month | Last 365 days | Any custom date range in this format: YYYY-MM-dd hh:mm TO YYYY-MM-dd hh:mm  # noqa: E501

        :param date_range: The date_range of this AuditLogReport.  # noqa: E501
        :type: str
        """

        self._date_range = date_range

    @property
    def columns(self):
        """Gets the columns of this AuditLogReport.  # noqa: E501

        The columns displayed in the report  # noqa: E501

        :return: The columns of this AuditLogReport.  # noqa: E501
        :rtype: list[DynamicColumn]
        """
        return self._columns

    @columns.setter
    def columns(self, columns):
        """Sets the columns of this AuditLogReport.

        The columns displayed in the report  # noqa: E501

        :param columns: The columns of this AuditLogReport.  # noqa: E501
        :type: list[DynamicColumn]
        """

        self._columns = columns

    @property
    def username(self):
        """Gets the username of this AuditLogReport.  # noqa: E501

        The user name of the user filter setting for the report  # noqa: E501

        :return: The username of this AuditLogReport.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this AuditLogReport.

        The user name of the user filter setting for the report  # noqa: E501

        :param username: The username of this AuditLogReport.  # noqa: E501
        :type: str
        """

        self._username = username

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AuditLogReport, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AuditLogReport):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
