# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from logicmonitor_sdk.models.auto_discovery_method import AutoDiscoveryMethod  # noqa: F401,E501

class AzureDimensionDiscoveryMethod(AutoDiscoveryMethod):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'period': 'str',
        'metric_name': 'str',
        'dimension_name': 'str'
    }
    if hasattr(AutoDiscoveryMethod, "swagger_types"):
        swagger_types.update(AutoDiscoveryMethod.swagger_types)

    attribute_map = {
        'period': 'period',
        'metric_name': 'metricName',
        'dimension_name': 'dimensionName'
    }
    if hasattr(AutoDiscoveryMethod, "attribute_map"):
        attribute_map.update(AutoDiscoveryMethod.attribute_map)

    def __init__(self, period=None, metric_name=None, dimension_name=None, *args, **kwargs):  # noqa: E501
        """AzureDimensionDiscoveryMethod - a model defined in Swagger"""  # noqa: E501
        self._period = None
        self._metric_name = None
        self._dimension_name = None
        self.discriminator = None
        self.period = period
        if metric_name is not None:
            self.metric_name = metric_name
        self.dimension_name = dimension_name
        AutoDiscoveryMethod.__init__(self, *args, **kwargs)

    @property
    def period(self):
        """Gets the period of this AzureDimensionDiscoveryMethod.  # noqa: E501


        :return: The period of this AzureDimensionDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._period

    @period.setter
    def period(self, period):
        """Sets the period of this AzureDimensionDiscoveryMethod.


        :param period: The period of this AzureDimensionDiscoveryMethod.  # noqa: E501
        :type: str
        """
        if period is None:
            raise ValueError("Invalid value for `period`, must not be `None`")  # noqa: E501

        self._period = period

    @property
    def metric_name(self):
        """Gets the metric_name of this AzureDimensionDiscoveryMethod.  # noqa: E501


        :return: The metric_name of this AzureDimensionDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._metric_name

    @metric_name.setter
    def metric_name(self, metric_name):
        """Sets the metric_name of this AzureDimensionDiscoveryMethod.


        :param metric_name: The metric_name of this AzureDimensionDiscoveryMethod.  # noqa: E501
        :type: str
        """

        self._metric_name = metric_name

    @property
    def dimension_name(self):
        """Gets the dimension_name of this AzureDimensionDiscoveryMethod.  # noqa: E501


        :return: The dimension_name of this AzureDimensionDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._dimension_name

    @dimension_name.setter
    def dimension_name(self, dimension_name):
        """Sets the dimension_name of this AzureDimensionDiscoveryMethod.


        :param dimension_name: The dimension_name of this AzureDimensionDiscoveryMethod.  # noqa: E501
        :type: str
        """
        if dimension_name is None:
            raise ValueError("Invalid value for `dimension_name`, must not be `None`")  # noqa: E501

        self._dimension_name = dimension_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AzureDimensionDiscoveryMethod, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AzureDimensionDiscoveryMethod):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
