# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CellData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'alert_status': 'str',
        'forecast_day': 'int',
        'instance_id': 'int',
        'instance_name': 'str',
        'alert_severity': 'str',
        'is_property_value': 'bool',
        'days_until_alert_list': 'list[DaysUntilAlert]',
        'prop_value': 'str',
        'value': 'float'
    }

    attribute_map = {
        'alert_status': 'alertStatus',
        'forecast_day': 'forecastDay',
        'instance_id': 'instanceId',
        'instance_name': 'instanceName',
        'alert_severity': 'alertSeverity',
        'is_property_value': 'isPropertyValue',
        'days_until_alert_list': 'daysUntilAlertList',
        'prop_value': 'propValue',
        'value': 'value'
    }

    def __init__(self, alert_status=None, forecast_day=None, instance_id=None, instance_name=None, alert_severity=None, is_property_value=None, days_until_alert_list=None, prop_value=None, value=None):  # noqa: E501
        """CellData - a model defined in Swagger"""  # noqa: E501
        self._alert_status = None
        self._forecast_day = None
        self._instance_id = None
        self._instance_name = None
        self._alert_severity = None
        self._is_property_value = None
        self._days_until_alert_list = None
        self._prop_value = None
        self._value = None
        self.discriminator = None
        if alert_status is not None:
            self.alert_status = alert_status
        if forecast_day is not None:
            self.forecast_day = forecast_day
        if instance_id is not None:
            self.instance_id = instance_id
        if instance_name is not None:
            self.instance_name = instance_name
        if alert_severity is not None:
            self.alert_severity = alert_severity
        if is_property_value is not None:
            self.is_property_value = is_property_value
        if days_until_alert_list is not None:
            self.days_until_alert_list = days_until_alert_list
        if prop_value is not None:
            self.prop_value = prop_value
        if value is not None:
            self.value = value

    @property
    def alert_status(self):
        """Gets the alert_status of this CellData.  # noqa: E501


        :return: The alert_status of this CellData.  # noqa: E501
        :rtype: str
        """
        return self._alert_status

    @alert_status.setter
    def alert_status(self, alert_status):
        """Sets the alert_status of this CellData.


        :param alert_status: The alert_status of this CellData.  # noqa: E501
        :type: str
        """

        self._alert_status = alert_status

    @property
    def forecast_day(self):
        """Gets the forecast_day of this CellData.  # noqa: E501


        :return: The forecast_day of this CellData.  # noqa: E501
        :rtype: int
        """
        return self._forecast_day

    @forecast_day.setter
    def forecast_day(self, forecast_day):
        """Sets the forecast_day of this CellData.


        :param forecast_day: The forecast_day of this CellData.  # noqa: E501
        :type: int
        """

        self._forecast_day = forecast_day

    @property
    def instance_id(self):
        """Gets the instance_id of this CellData.  # noqa: E501


        :return: The instance_id of this CellData.  # noqa: E501
        :rtype: int
        """
        return self._instance_id

    @instance_id.setter
    def instance_id(self, instance_id):
        """Sets the instance_id of this CellData.


        :param instance_id: The instance_id of this CellData.  # noqa: E501
        :type: int
        """

        self._instance_id = instance_id

    @property
    def instance_name(self):
        """Gets the instance_name of this CellData.  # noqa: E501


        :return: The instance_name of this CellData.  # noqa: E501
        :rtype: str
        """
        return self._instance_name

    @instance_name.setter
    def instance_name(self, instance_name):
        """Sets the instance_name of this CellData.


        :param instance_name: The instance_name of this CellData.  # noqa: E501
        :type: str
        """

        self._instance_name = instance_name

    @property
    def alert_severity(self):
        """Gets the alert_severity of this CellData.  # noqa: E501


        :return: The alert_severity of this CellData.  # noqa: E501
        :rtype: str
        """
        return self._alert_severity

    @alert_severity.setter
    def alert_severity(self, alert_severity):
        """Sets the alert_severity of this CellData.


        :param alert_severity: The alert_severity of this CellData.  # noqa: E501
        :type: str
        """

        self._alert_severity = alert_severity

    @property
    def is_property_value(self):
        """Gets the is_property_value of this CellData.  # noqa: E501


        :return: The is_property_value of this CellData.  # noqa: E501
        :rtype: bool
        """
        return self._is_property_value

    @is_property_value.setter
    def is_property_value(self, is_property_value):
        """Sets the is_property_value of this CellData.


        :param is_property_value: The is_property_value of this CellData.  # noqa: E501
        :type: bool
        """

        self._is_property_value = is_property_value

    @property
    def days_until_alert_list(self):
        """Gets the days_until_alert_list of this CellData.  # noqa: E501


        :return: The days_until_alert_list of this CellData.  # noqa: E501
        :rtype: list[DaysUntilAlert]
        """
        return self._days_until_alert_list

    @days_until_alert_list.setter
    def days_until_alert_list(self, days_until_alert_list):
        """Sets the days_until_alert_list of this CellData.


        :param days_until_alert_list: The days_until_alert_list of this CellData.  # noqa: E501
        :type: list[DaysUntilAlert]
        """

        self._days_until_alert_list = days_until_alert_list

    @property
    def prop_value(self):
        """Gets the prop_value of this CellData.  # noqa: E501


        :return: The prop_value of this CellData.  # noqa: E501
        :rtype: str
        """
        return self._prop_value

    @prop_value.setter
    def prop_value(self, prop_value):
        """Sets the prop_value of this CellData.


        :param prop_value: The prop_value of this CellData.  # noqa: E501
        :type: str
        """

        self._prop_value = prop_value

    @property
    def value(self):
        """Gets the value of this CellData.  # noqa: E501


        :return: The value of this CellData.  # noqa: E501
        :rtype: float
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this CellData.


        :param value: The value of this CellData.  # noqa: E501
        :type: float
        """

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CellData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CellData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
