# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DatapointFilterItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'all_datapoint_ids': 'list[str]',
        'name': 'str',
        'label': 'str',
        'value': 'list[LabelValuePair]'
    }

    attribute_map = {
        'all_datapoint_ids': 'allDatapointIds',
        'name': 'name',
        'label': 'label',
        'value': 'value'
    }

    def __init__(self, all_datapoint_ids=None, name=None, label=None, value=None):  # noqa: E501
        """DatapointFilterItem - a model defined in Swagger"""  # noqa: E501
        self._all_datapoint_ids = None
        self._name = None
        self._label = None
        self._value = None
        self.discriminator = None
        if all_datapoint_ids is not None:
            self.all_datapoint_ids = all_datapoint_ids
        if name is not None:
            self.name = name
        if label is not None:
            self.label = label
        if value is not None:
            self.value = value

    @property
    def all_datapoint_ids(self):
        """Gets the all_datapoint_ids of this DatapointFilterItem.  # noqa: E501


        :return: The all_datapoint_ids of this DatapointFilterItem.  # noqa: E501
        :rtype: list[str]
        """
        return self._all_datapoint_ids

    @all_datapoint_ids.setter
    def all_datapoint_ids(self, all_datapoint_ids):
        """Sets the all_datapoint_ids of this DatapointFilterItem.


        :param all_datapoint_ids: The all_datapoint_ids of this DatapointFilterItem.  # noqa: E501
        :type: list[str]
        """

        self._all_datapoint_ids = all_datapoint_ids

    @property
    def name(self):
        """Gets the name of this DatapointFilterItem.  # noqa: E501


        :return: The name of this DatapointFilterItem.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DatapointFilterItem.


        :param name: The name of this DatapointFilterItem.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def label(self):
        """Gets the label of this DatapointFilterItem.  # noqa: E501


        :return: The label of this DatapointFilterItem.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this DatapointFilterItem.


        :param label: The label of this DatapointFilterItem.  # noqa: E501
        :type: str
        """

        self._label = label

    @property
    def value(self):
        """Gets the value of this DatapointFilterItem.  # noqa: E501


        :return: The value of this DatapointFilterItem.  # noqa: E501
        :rtype: list[LabelValuePair]
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this DatapointFilterItem.


        :param value: The value of this DatapointFilterItem.  # noqa: E501
        :type: list[LabelValuePair]
        """

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DatapointFilterItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DatapointFilterItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
