# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DeviceDataSourceInstanceAlertSetting(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'global_alert_expr': 'str',
        'parent_instance_group_alert_expr': 'InstanceGroupAlertThresholdInfo',
        'alert_for_no_data': 'int',
        'post_processor_param': 'str',
        'disable_alerting': 'bool',
        'global_alert_transition_interval': 'int',
        'data_point_description': 'str',
        'global_enable_anomaly_alert_generation': 'str',
        'enable_anomaly_alert_generation': 'str',
        'disable_dp_alert_host_groups': 'str',
        'data_point_name': 'str',
        'data_point_id': 'int',
        'global_enable_anomaly_alert_suppression': 'str',
        'device_group_id': 'int',
        'id': 'int',
        'global_alert_clear_transition_interval': 'int',
        'parent_resource_data_source_alert_expr': 'ResourceDataSourceAlertThresholdInfo',
        'device_group_full_path': 'str',
        'alert_transition_interval': 'int',
        'global_alert_for_no_data': 'int',
        'enable_anomaly_alert_suppression': 'str',
        'alert_clear_interval': 'int',
        'critical_ad_adv_setting': 'str',
        'alert_expr_note': 'str',
        'ad_adv_setting_enabled': 'bool',
        'error_ad_adv_setting': 'str',
        'data_source_instance_id': 'int',
        'warn_ad_adv_setting': 'str',
        'global_post_processor_param': 'str',
        'parent_device_group_alert_expr_list': 'list[DeviceGroupAlertThresholdInfo]',
        'alerting_disabled_on': 'str',
        'data_source_instance_alias': 'str',
        'collection_interval': 'int',
        'alert_expr': 'str'
    }

    attribute_map = {
        'global_alert_expr': 'globalAlertExpr',
        'parent_instance_group_alert_expr': 'parentInstanceGroupAlertExpr',
        'alert_for_no_data': 'alertForNoData',
        'post_processor_param': 'postProcessorParam',
        'disable_alerting': 'disableAlerting',
        'global_alert_transition_interval': 'globalAlertTransitionInterval',
        'data_point_description': 'dataPointDescription',
        'global_enable_anomaly_alert_generation': 'globalEnableAnomalyAlertGeneration',
        'enable_anomaly_alert_generation': 'enableAnomalyAlertGeneration',
        'disable_dp_alert_host_groups': 'disableDpAlertHostGroups',
        'data_point_name': 'dataPointName',
        'data_point_id': 'dataPointId',
        'global_enable_anomaly_alert_suppression': 'globalEnableAnomalyAlertSuppression',
        'device_group_id': 'deviceGroupId',
        'id': 'id',
        'global_alert_clear_transition_interval': 'globalAlertClearTransitionInterval',
        'parent_resource_data_source_alert_expr': 'parentResourceDataSourceAlertExpr',
        'device_group_full_path': 'deviceGroupFullPath',
        'alert_transition_interval': 'alertTransitionInterval',
        'global_alert_for_no_data': 'globalAlertForNoData',
        'enable_anomaly_alert_suppression': 'enableAnomalyAlertSuppression',
        'alert_clear_interval': 'alertClearInterval',
        'critical_ad_adv_setting': 'criticalAdAdvSetting',
        'alert_expr_note': 'alertExprNote',
        'ad_adv_setting_enabled': 'adAdvSettingEnabled',
        'error_ad_adv_setting': 'errorAdAdvSetting',
        'data_source_instance_id': 'dataSourceInstanceId',
        'warn_ad_adv_setting': 'warnAdAdvSetting',
        'global_post_processor_param': 'globalPostProcessorParam',
        'parent_device_group_alert_expr_list': 'parentDeviceGroupAlertExprList',
        'alerting_disabled_on': 'alertingDisabledOn',
        'data_source_instance_alias': 'dataSourceInstanceAlias',
        'collection_interval': 'collectionInterval',
        'alert_expr': 'alertExpr'
    }

    def __init__(self, global_alert_expr=None, parent_instance_group_alert_expr=None, alert_for_no_data=None, post_processor_param=None, disable_alerting=None, global_alert_transition_interval=None, data_point_description=None, global_enable_anomaly_alert_generation=None, enable_anomaly_alert_generation=None, disable_dp_alert_host_groups=None, data_point_name=None, data_point_id=None, global_enable_anomaly_alert_suppression=None, device_group_id=None, id=None, global_alert_clear_transition_interval=None, parent_resource_data_source_alert_expr=None, device_group_full_path=None, alert_transition_interval=None, global_alert_for_no_data=None, enable_anomaly_alert_suppression=None, alert_clear_interval=None, critical_ad_adv_setting=None, alert_expr_note=None, ad_adv_setting_enabled=None, error_ad_adv_setting=None, data_source_instance_id=None, warn_ad_adv_setting=None, global_post_processor_param=None, parent_device_group_alert_expr_list=None, alerting_disabled_on=None, data_source_instance_alias=None, collection_interval=None, alert_expr=None):  # noqa: E501
        """DeviceDataSourceInstanceAlertSetting - a model defined in Swagger"""  # noqa: E501
        self._global_alert_expr = None
        self._parent_instance_group_alert_expr = None
        self._alert_for_no_data = None
        self._post_processor_param = None
        self._disable_alerting = None
        self._global_alert_transition_interval = None
        self._data_point_description = None
        self._global_enable_anomaly_alert_generation = None
        self._enable_anomaly_alert_generation = None
        self._disable_dp_alert_host_groups = None
        self._data_point_name = None
        self._data_point_id = None
        self._global_enable_anomaly_alert_suppression = None
        self._device_group_id = None
        self._id = None
        self._global_alert_clear_transition_interval = None
        self._parent_resource_data_source_alert_expr = None
        self._device_group_full_path = None
        self._alert_transition_interval = None
        self._global_alert_for_no_data = None
        self._enable_anomaly_alert_suppression = None
        self._alert_clear_interval = None
        self._critical_ad_adv_setting = None
        self._alert_expr_note = None
        self._ad_adv_setting_enabled = None
        self._error_ad_adv_setting = None
        self._data_source_instance_id = None
        self._warn_ad_adv_setting = None
        self._global_post_processor_param = None
        self._parent_device_group_alert_expr_list = None
        self._alerting_disabled_on = None
        self._data_source_instance_alias = None
        self._collection_interval = None
        self._alert_expr = None
        self.discriminator = None
        if global_alert_expr is not None:
            self.global_alert_expr = global_alert_expr
        if parent_instance_group_alert_expr is not None:
            self.parent_instance_group_alert_expr = parent_instance_group_alert_expr
        if alert_for_no_data is not None:
            self.alert_for_no_data = alert_for_no_data
        if post_processor_param is not None:
            self.post_processor_param = post_processor_param
        if disable_alerting is not None:
            self.disable_alerting = disable_alerting
        if global_alert_transition_interval is not None:
            self.global_alert_transition_interval = global_alert_transition_interval
        if data_point_description is not None:
            self.data_point_description = data_point_description
        if global_enable_anomaly_alert_generation is not None:
            self.global_enable_anomaly_alert_generation = global_enable_anomaly_alert_generation
        if enable_anomaly_alert_generation is not None:
            self.enable_anomaly_alert_generation = enable_anomaly_alert_generation
        if disable_dp_alert_host_groups is not None:
            self.disable_dp_alert_host_groups = disable_dp_alert_host_groups
        if data_point_name is not None:
            self.data_point_name = data_point_name
        if data_point_id is not None:
            self.data_point_id = data_point_id
        if global_enable_anomaly_alert_suppression is not None:
            self.global_enable_anomaly_alert_suppression = global_enable_anomaly_alert_suppression
        if device_group_id is not None:
            self.device_group_id = device_group_id
        if id is not None:
            self.id = id
        if global_alert_clear_transition_interval is not None:
            self.global_alert_clear_transition_interval = global_alert_clear_transition_interval
        if parent_resource_data_source_alert_expr is not None:
            self.parent_resource_data_source_alert_expr = parent_resource_data_source_alert_expr
        if device_group_full_path is not None:
            self.device_group_full_path = device_group_full_path
        if alert_transition_interval is not None:
            self.alert_transition_interval = alert_transition_interval
        if global_alert_for_no_data is not None:
            self.global_alert_for_no_data = global_alert_for_no_data
        if enable_anomaly_alert_suppression is not None:
            self.enable_anomaly_alert_suppression = enable_anomaly_alert_suppression
        if alert_clear_interval is not None:
            self.alert_clear_interval = alert_clear_interval
        if critical_ad_adv_setting is not None:
            self.critical_ad_adv_setting = critical_ad_adv_setting
        if alert_expr_note is not None:
            self.alert_expr_note = alert_expr_note
        if ad_adv_setting_enabled is not None:
            self.ad_adv_setting_enabled = ad_adv_setting_enabled
        if error_ad_adv_setting is not None:
            self.error_ad_adv_setting = error_ad_adv_setting
        if data_source_instance_id is not None:
            self.data_source_instance_id = data_source_instance_id
        if warn_ad_adv_setting is not None:
            self.warn_ad_adv_setting = warn_ad_adv_setting
        if global_post_processor_param is not None:
            self.global_post_processor_param = global_post_processor_param
        if parent_device_group_alert_expr_list is not None:
            self.parent_device_group_alert_expr_list = parent_device_group_alert_expr_list
        if alerting_disabled_on is not None:
            self.alerting_disabled_on = alerting_disabled_on
        if data_source_instance_alias is not None:
            self.data_source_instance_alias = data_source_instance_alias
        if collection_interval is not None:
            self.collection_interval = collection_interval
        if alert_expr is not None:
            self.alert_expr = alert_expr

    @property
    def global_alert_expr(self):
        """Gets the global_alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The global alert expression for this datapoint  # noqa: E501

        :return: The global_alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._global_alert_expr

    @global_alert_expr.setter
    def global_alert_expr(self, global_alert_expr):
        """Sets the global_alert_expr of this DeviceDataSourceInstanceAlertSetting.

        The global alert expression for this datapoint  # noqa: E501

        :param global_alert_expr: The global_alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._global_alert_expr = global_alert_expr

    @property
    def parent_instance_group_alert_expr(self):
        """Gets the parent_instance_group_alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501


        :return: The parent_instance_group_alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: InstanceGroupAlertThresholdInfo
        """
        return self._parent_instance_group_alert_expr

    @parent_instance_group_alert_expr.setter
    def parent_instance_group_alert_expr(self, parent_instance_group_alert_expr):
        """Sets the parent_instance_group_alert_expr of this DeviceDataSourceInstanceAlertSetting.


        :param parent_instance_group_alert_expr: The parent_instance_group_alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: InstanceGroupAlertThresholdInfo
        """

        self._parent_instance_group_alert_expr = parent_instance_group_alert_expr

    @property
    def alert_for_no_data(self):
        """Gets the alert_for_no_data of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        alert for no data (no alert-1, warning-2, error-3, critical-4)  # noqa: E501

        :return: The alert_for_no_data of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: int
        """
        return self._alert_for_no_data

    @alert_for_no_data.setter
    def alert_for_no_data(self, alert_for_no_data):
        """Sets the alert_for_no_data of this DeviceDataSourceInstanceAlertSetting.

        alert for no data (no alert-1, warning-2, error-3, critical-4)  # noqa: E501

        :param alert_for_no_data: The alert_for_no_data of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: int
        """

        self._alert_for_no_data = alert_for_no_data

    @property
    def post_processor_param(self):
        """Gets the post_processor_param of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The post processor parameter for complex DataPoint and instance level configCheck threshold.  # noqa: E501

        :return: The post_processor_param of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._post_processor_param

    @post_processor_param.setter
    def post_processor_param(self, post_processor_param):
        """Sets the post_processor_param of this DeviceDataSourceInstanceAlertSetting.

        The post processor parameter for complex DataPoint and instance level configCheck threshold.  # noqa: E501

        :param post_processor_param: The post_processor_param of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._post_processor_param = post_processor_param

    @property
    def disable_alerting(self):
        """Gets the disable_alerting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        Whether or not alerting will be disabled for the datapoint  # noqa: E501

        :return: The disable_alerting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: bool
        """
        return self._disable_alerting

    @disable_alerting.setter
    def disable_alerting(self, disable_alerting):
        """Sets the disable_alerting of this DeviceDataSourceInstanceAlertSetting.

        Whether or not alerting will be disabled for the datapoint  # noqa: E501

        :param disable_alerting: The disable_alerting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: bool
        """

        self._disable_alerting = disable_alerting

    @property
    def global_alert_transition_interval(self):
        """Gets the global_alert_transition_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The count that the alert must exist for this many poll cycles before it will be triggered  # noqa: E501

        :return: The global_alert_transition_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: int
        """
        return self._global_alert_transition_interval

    @global_alert_transition_interval.setter
    def global_alert_transition_interval(self, global_alert_transition_interval):
        """Sets the global_alert_transition_interval of this DeviceDataSourceInstanceAlertSetting.

        The count that the alert must exist for this many poll cycles before it will be triggered  # noqa: E501

        :param global_alert_transition_interval: The global_alert_transition_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: int
        """

        self._global_alert_transition_interval = global_alert_transition_interval

    @property
    def data_point_description(self):
        """Gets the data_point_description of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The description of the datapoint the alert settings apply to  # noqa: E501

        :return: The data_point_description of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._data_point_description

    @data_point_description.setter
    def data_point_description(self, data_point_description):
        """Sets the data_point_description of this DeviceDataSourceInstanceAlertSetting.

        The description of the datapoint the alert settings apply to  # noqa: E501

        :param data_point_description: The data_point_description of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._data_point_description = data_point_description

    @property
    def global_enable_anomaly_alert_generation(self):
        """Gets the global_enable_anomaly_alert_generation of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The global enable anomaly alert generation  # noqa: E501

        :return: The global_enable_anomaly_alert_generation of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._global_enable_anomaly_alert_generation

    @global_enable_anomaly_alert_generation.setter
    def global_enable_anomaly_alert_generation(self, global_enable_anomaly_alert_generation):
        """Sets the global_enable_anomaly_alert_generation of this DeviceDataSourceInstanceAlertSetting.

        The global enable anomaly alert generation  # noqa: E501

        :param global_enable_anomaly_alert_generation: The global_enable_anomaly_alert_generation of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._global_enable_anomaly_alert_generation = global_enable_anomaly_alert_generation

    @property
    def enable_anomaly_alert_generation(self):
        """Gets the enable_anomaly_alert_generation of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        enable anomaly alert generation  # noqa: E501

        :return: The enable_anomaly_alert_generation of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._enable_anomaly_alert_generation

    @enable_anomaly_alert_generation.setter
    def enable_anomaly_alert_generation(self, enable_anomaly_alert_generation):
        """Sets the enable_anomaly_alert_generation of this DeviceDataSourceInstanceAlertSetting.

        enable anomaly alert generation  # noqa: E501

        :param enable_anomaly_alert_generation: The enable_anomaly_alert_generation of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._enable_anomaly_alert_generation = enable_anomaly_alert_generation

    @property
    def disable_dp_alert_host_groups(self):
        """Gets the disable_dp_alert_host_groups of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The group full path lists who disable alert for this datapoint on devicegroup level  # noqa: E501

        :return: The disable_dp_alert_host_groups of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._disable_dp_alert_host_groups

    @disable_dp_alert_host_groups.setter
    def disable_dp_alert_host_groups(self, disable_dp_alert_host_groups):
        """Sets the disable_dp_alert_host_groups of this DeviceDataSourceInstanceAlertSetting.

        The group full path lists who disable alert for this datapoint on devicegroup level  # noqa: E501

        :param disable_dp_alert_host_groups: The disable_dp_alert_host_groups of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._disable_dp_alert_host_groups = disable_dp_alert_host_groups

    @property
    def data_point_name(self):
        """Gets the data_point_name of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The name of the datapoint the alert settings apply to  # noqa: E501

        :return: The data_point_name of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._data_point_name

    @data_point_name.setter
    def data_point_name(self, data_point_name):
        """Sets the data_point_name of this DeviceDataSourceInstanceAlertSetting.

        The name of the datapoint the alert settings apply to  # noqa: E501

        :param data_point_name: The data_point_name of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._data_point_name = data_point_name

    @property
    def data_point_id(self):
        """Gets the data_point_id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The id of the Datapoint alert settings apply to  # noqa: E501

        :return: The data_point_id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: int
        """
        return self._data_point_id

    @data_point_id.setter
    def data_point_id(self, data_point_id):
        """Sets the data_point_id of this DeviceDataSourceInstanceAlertSetting.

        The id of the Datapoint alert settings apply to  # noqa: E501

        :param data_point_id: The data_point_id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: int
        """

        self._data_point_id = data_point_id

    @property
    def global_enable_anomaly_alert_suppression(self):
        """Gets the global_enable_anomaly_alert_suppression of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The global enable anomaly alert suppression  # noqa: E501

        :return: The global_enable_anomaly_alert_suppression of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._global_enable_anomaly_alert_suppression

    @global_enable_anomaly_alert_suppression.setter
    def global_enable_anomaly_alert_suppression(self, global_enable_anomaly_alert_suppression):
        """Sets the global_enable_anomaly_alert_suppression of this DeviceDataSourceInstanceAlertSetting.

        The global enable anomaly alert suppression  # noqa: E501

        :param global_enable_anomaly_alert_suppression: The global_enable_anomaly_alert_suppression of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._global_enable_anomaly_alert_suppression = global_enable_anomaly_alert_suppression

    @property
    def device_group_id(self):
        """Gets the device_group_id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The ID of the device group  # noqa: E501

        :return: The device_group_id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: int
        """
        return self._device_group_id

    @device_group_id.setter
    def device_group_id(self, device_group_id):
        """Sets the device_group_id of this DeviceDataSourceInstanceAlertSetting.

        The ID of the device group  # noqa: E501

        :param device_group_id: The device_group_id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: int
        """

        self._device_group_id = device_group_id

    @property
    def id(self):
        """Gets the id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The id of this alert setting  # noqa: E501

        :return: The id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DeviceDataSourceInstanceAlertSetting.

        The id of this alert setting  # noqa: E501

        :param id: The id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def global_alert_clear_transition_interval(self):
        """Gets the global_alert_clear_transition_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The count that the alert must exist for this many poll cycles before the alert will be cleared  # noqa: E501

        :return: The global_alert_clear_transition_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: int
        """
        return self._global_alert_clear_transition_interval

    @global_alert_clear_transition_interval.setter
    def global_alert_clear_transition_interval(self, global_alert_clear_transition_interval):
        """Sets the global_alert_clear_transition_interval of this DeviceDataSourceInstanceAlertSetting.

        The count that the alert must exist for this many poll cycles before the alert will be cleared  # noqa: E501

        :param global_alert_clear_transition_interval: The global_alert_clear_transition_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: int
        """

        self._global_alert_clear_transition_interval = global_alert_clear_transition_interval

    @property
    def parent_resource_data_source_alert_expr(self):
        """Gets the parent_resource_data_source_alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501


        :return: The parent_resource_data_source_alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: ResourceDataSourceAlertThresholdInfo
        """
        return self._parent_resource_data_source_alert_expr

    @parent_resource_data_source_alert_expr.setter
    def parent_resource_data_source_alert_expr(self, parent_resource_data_source_alert_expr):
        """Sets the parent_resource_data_source_alert_expr of this DeviceDataSourceInstanceAlertSetting.


        :param parent_resource_data_source_alert_expr: The parent_resource_data_source_alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: ResourceDataSourceAlertThresholdInfo
        """

        self._parent_resource_data_source_alert_expr = parent_resource_data_source_alert_expr

    @property
    def device_group_full_path(self):
        """Gets the device_group_full_path of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The full path of the device group  # noqa: E501

        :return: The device_group_full_path of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._device_group_full_path

    @device_group_full_path.setter
    def device_group_full_path(self, device_group_full_path):
        """Sets the device_group_full_path of this DeviceDataSourceInstanceAlertSetting.

        The full path of the device group  # noqa: E501

        :param device_group_full_path: The device_group_full_path of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._device_group_full_path = device_group_full_path

    @property
    def alert_transition_interval(self):
        """Gets the alert_transition_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The polling interval of alert transition (0-60)  # noqa: E501

        :return: The alert_transition_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: int
        """
        return self._alert_transition_interval

    @alert_transition_interval.setter
    def alert_transition_interval(self, alert_transition_interval):
        """Sets the alert_transition_interval of this DeviceDataSourceInstanceAlertSetting.

        The polling interval of alert transition (0-60)  # noqa: E501

        :param alert_transition_interval: The alert_transition_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: int
        """

        self._alert_transition_interval = alert_transition_interval

    @property
    def global_alert_for_no_data(self):
        """Gets the global_alert_for_no_data of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The triggered alert level if we cannot collect data for this datapoint  # noqa: E501

        :return: The global_alert_for_no_data of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: int
        """
        return self._global_alert_for_no_data

    @global_alert_for_no_data.setter
    def global_alert_for_no_data(self, global_alert_for_no_data):
        """Sets the global_alert_for_no_data of this DeviceDataSourceInstanceAlertSetting.

        The triggered alert level if we cannot collect data for this datapoint  # noqa: E501

        :param global_alert_for_no_data: The global_alert_for_no_data of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: int
        """

        self._global_alert_for_no_data = global_alert_for_no_data

    @property
    def enable_anomaly_alert_suppression(self):
        """Gets the enable_anomaly_alert_suppression of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        enable anomaly alert suppression  # noqa: E501

        :return: The enable_anomaly_alert_suppression of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._enable_anomaly_alert_suppression

    @enable_anomaly_alert_suppression.setter
    def enable_anomaly_alert_suppression(self, enable_anomaly_alert_suppression):
        """Sets the enable_anomaly_alert_suppression of this DeviceDataSourceInstanceAlertSetting.

        enable anomaly alert suppression  # noqa: E501

        :param enable_anomaly_alert_suppression: The enable_anomaly_alert_suppression of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._enable_anomaly_alert_suppression = enable_anomaly_alert_suppression

    @property
    def alert_clear_interval(self):
        """Gets the alert_clear_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The polling interval of alert clear transition (0-60)  # noqa: E501

        :return: The alert_clear_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: int
        """
        return self._alert_clear_interval

    @alert_clear_interval.setter
    def alert_clear_interval(self, alert_clear_interval):
        """Sets the alert_clear_interval of this DeviceDataSourceInstanceAlertSetting.

        The polling interval of alert clear transition (0-60)  # noqa: E501

        :param alert_clear_interval: The alert_clear_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: int
        """

        self._alert_clear_interval = alert_clear_interval

    @property
    def critical_ad_adv_setting(self):
        """Gets the critical_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501


        :return: The critical_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._critical_ad_adv_setting

    @critical_ad_adv_setting.setter
    def critical_ad_adv_setting(self, critical_ad_adv_setting):
        """Sets the critical_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.


        :param critical_ad_adv_setting: The critical_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._critical_ad_adv_setting = critical_ad_adv_setting

    @property
    def alert_expr_note(self):
        """Gets the alert_expr_note of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The note associated with the current alert threshold settings  # noqa: E501

        :return: The alert_expr_note of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._alert_expr_note

    @alert_expr_note.setter
    def alert_expr_note(self, alert_expr_note):
        """Sets the alert_expr_note of this DeviceDataSourceInstanceAlertSetting.

        The note associated with the current alert threshold settings  # noqa: E501

        :param alert_expr_note: The alert_expr_note of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._alert_expr_note = alert_expr_note

    @property
    def ad_adv_setting_enabled(self):
        """Gets the ad_adv_setting_enabled of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501


        :return: The ad_adv_setting_enabled of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: bool
        """
        return self._ad_adv_setting_enabled

    @ad_adv_setting_enabled.setter
    def ad_adv_setting_enabled(self, ad_adv_setting_enabled):
        """Sets the ad_adv_setting_enabled of this DeviceDataSourceInstanceAlertSetting.


        :param ad_adv_setting_enabled: The ad_adv_setting_enabled of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: bool
        """

        self._ad_adv_setting_enabled = ad_adv_setting_enabled

    @property
    def error_ad_adv_setting(self):
        """Gets the error_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501


        :return: The error_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._error_ad_adv_setting

    @error_ad_adv_setting.setter
    def error_ad_adv_setting(self, error_ad_adv_setting):
        """Sets the error_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.


        :param error_ad_adv_setting: The error_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._error_ad_adv_setting = error_ad_adv_setting

    @property
    def data_source_instance_id(self):
        """Gets the data_source_instance_id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The id of the DataSource instance alert settings apply to  # noqa: E501

        :return: The data_source_instance_id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: int
        """
        return self._data_source_instance_id

    @data_source_instance_id.setter
    def data_source_instance_id(self, data_source_instance_id):
        """Sets the data_source_instance_id of this DeviceDataSourceInstanceAlertSetting.

        The id of the DataSource instance alert settings apply to  # noqa: E501

        :param data_source_instance_id: The data_source_instance_id of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: int
        """

        self._data_source_instance_id = data_source_instance_id

    @property
    def warn_ad_adv_setting(self):
        """Gets the warn_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501


        :return: The warn_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._warn_ad_adv_setting

    @warn_ad_adv_setting.setter
    def warn_ad_adv_setting(self, warn_ad_adv_setting):
        """Sets the warn_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.


        :param warn_ad_adv_setting: The warn_ad_adv_setting of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._warn_ad_adv_setting = warn_ad_adv_setting

    @property
    def global_post_processor_param(self):
        """Gets the global_post_processor_param of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The post processor parameters for complex DataPoints and global level configCheck threshold.  # noqa: E501

        :return: The global_post_processor_param of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._global_post_processor_param

    @global_post_processor_param.setter
    def global_post_processor_param(self, global_post_processor_param):
        """Sets the global_post_processor_param of this DeviceDataSourceInstanceAlertSetting.

        The post processor parameters for complex DataPoints and global level configCheck threshold.  # noqa: E501

        :param global_post_processor_param: The global_post_processor_param of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._global_post_processor_param = global_post_processor_param

    @property
    def parent_device_group_alert_expr_list(self):
        """Gets the parent_device_group_alert_expr_list of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        Device group alert expression list base on the priority. The first is the highest priority and effected on this instance  # noqa: E501

        :return: The parent_device_group_alert_expr_list of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: list[DeviceGroupAlertThresholdInfo]
        """
        return self._parent_device_group_alert_expr_list

    @parent_device_group_alert_expr_list.setter
    def parent_device_group_alert_expr_list(self, parent_device_group_alert_expr_list):
        """Sets the parent_device_group_alert_expr_list of this DeviceDataSourceInstanceAlertSetting.

        Device group alert expression list base on the priority. The first is the highest priority and effected on this instance  # noqa: E501

        :param parent_device_group_alert_expr_list: The parent_device_group_alert_expr_list of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: list[DeviceGroupAlertThresholdInfo]
        """

        self._parent_device_group_alert_expr_list = parent_device_group_alert_expr_list

    @property
    def alerting_disabled_on(self):
        """Gets the alerting_disabled_on of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The datapoint is effected alert disabled by which group  # noqa: E501

        :return: The alerting_disabled_on of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._alerting_disabled_on

    @alerting_disabled_on.setter
    def alerting_disabled_on(self, alerting_disabled_on):
        """Sets the alerting_disabled_on of this DeviceDataSourceInstanceAlertSetting.

        The datapoint is effected alert disabled by which group  # noqa: E501

        :param alerting_disabled_on: The alerting_disabled_on of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._alerting_disabled_on = alerting_disabled_on

    @property
    def data_source_instance_alias(self):
        """Gets the data_source_instance_alias of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The alias (name) of the DataSource instance the alert settings apply to  # noqa: E501

        :return: The data_source_instance_alias of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._data_source_instance_alias

    @data_source_instance_alias.setter
    def data_source_instance_alias(self, data_source_instance_alias):
        """Sets the data_source_instance_alias of this DeviceDataSourceInstanceAlertSetting.

        The alias (name) of the DataSource instance the alert settings apply to  # noqa: E501

        :param data_source_instance_alias: The data_source_instance_alias of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._data_source_instance_alias = data_source_instance_alias

    @property
    def collection_interval(self):
        """Gets the collection_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        Collection Interval  # noqa: E501

        :return: The collection_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: int
        """
        return self._collection_interval

    @collection_interval.setter
    def collection_interval(self, collection_interval):
        """Sets the collection_interval of this DeviceDataSourceInstanceAlertSetting.

        Collection Interval  # noqa: E501

        :param collection_interval: The collection_interval of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: int
        """

        self._collection_interval = collection_interval

    @property
    def alert_expr(self):
        """Gets the alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501

        The thresholds that should be associated with the datapoint. Note that you need to have a space between the operator and each threshold (e.g. > 1 2 3)  # noqa: E501

        :return: The alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :rtype: str
        """
        return self._alert_expr

    @alert_expr.setter
    def alert_expr(self, alert_expr):
        """Sets the alert_expr of this DeviceDataSourceInstanceAlertSetting.

        The thresholds that should be associated with the datapoint. Note that you need to have a space between the operator and each threshold (e.g. > 1 2 3)  # noqa: E501

        :param alert_expr: The alert_expr of this DeviceDataSourceInstanceAlertSetting.  # noqa: E501
        :type: str
        """

        self._alert_expr = alert_expr

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeviceDataSourceInstanceAlertSetting, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeviceDataSourceInstanceAlertSetting):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
