# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from logicmonitor_sdk.models.netflow_data_base import NetflowDataBase  # noqa: F401,E501

class NetflowBgpTable(NetflowDataBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'percent_usage': 'float',
        'as_number': 'int',
        'usage': 'float',
        'description': 'str'
    }
    if hasattr(NetflowDataBase, "swagger_types"):
        swagger_types.update(NetflowDataBase.swagger_types)

    attribute_map = {
        'percent_usage': 'percentUsage',
        'as_number': 'asNumber',
        'usage': 'usage',
        'description': 'description'
    }
    if hasattr(NetflowDataBase, "attribute_map"):
        attribute_map.update(NetflowDataBase.attribute_map)

    def __init__(self, percent_usage=None, as_number=None, usage=None, description=None, *args, **kwargs):  # noqa: E501
        """NetflowBgpTable - a model defined in Swagger"""  # noqa: E501
        self._percent_usage = None
        self._as_number = None
        self._usage = None
        self._description = None
        self.discriminator = None
        if percent_usage is not None:
            self.percent_usage = percent_usage
        if as_number is not None:
            self.as_number = as_number
        if usage is not None:
            self.usage = usage
        if description is not None:
            self.description = description
        NetflowDataBase.__init__(self, *args, **kwargs)

    @property
    def percent_usage(self):
        """Gets the percent_usage of this NetflowBgpTable.  # noqa: E501

        percentage of traffic through this asn  # noqa: E501

        :return: The percent_usage of this NetflowBgpTable.  # noqa: E501
        :rtype: float
        """
        return self._percent_usage

    @percent_usage.setter
    def percent_usage(self, percent_usage):
        """Sets the percent_usage of this NetflowBgpTable.

        percentage of traffic through this asn  # noqa: E501

        :param percent_usage: The percent_usage of this NetflowBgpTable.  # noqa: E501
        :type: float
        """

        self._percent_usage = percent_usage

    @property
    def as_number(self):
        """Gets the as_number of this NetflowBgpTable.  # noqa: E501

        autonomous system number  # noqa: E501

        :return: The as_number of this NetflowBgpTable.  # noqa: E501
        :rtype: int
        """
        return self._as_number

    @as_number.setter
    def as_number(self, as_number):
        """Sets the as_number of this NetflowBgpTable.

        autonomous system number  # noqa: E501

        :param as_number: The as_number of this NetflowBgpTable.  # noqa: E501
        :type: int
        """

        self._as_number = as_number

    @property
    def usage(self):
        """Gets the usage of this NetflowBgpTable.  # noqa: E501

        total bytes through this asn  # noqa: E501

        :return: The usage of this NetflowBgpTable.  # noqa: E501
        :rtype: float
        """
        return self._usage

    @usage.setter
    def usage(self, usage):
        """Sets the usage of this NetflowBgpTable.

        total bytes through this asn  # noqa: E501

        :param usage: The usage of this NetflowBgpTable.  # noqa: E501
        :type: float
        """

        self._usage = usage

    @property
    def description(self):
        """Gets the description of this NetflowBgpTable.  # noqa: E501

        the description of the asNumber  # noqa: E501

        :return: The description of this NetflowBgpTable.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this NetflowBgpTable.

        the description of the asNumber  # noqa: E501

        :param description: The description of this NetflowBgpTable.  # noqa: E501
        :type: str
        """

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NetflowBgpTable, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetflowBgpTable):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
