# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from logicmonitor_sdk.models.widget import Widget  # noqa: F401,E501

class NOCWidget(Widget):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ack_checked': 'object',
        'display_error_alert': 'object',
        'display_column': 'int',
        'display_warn_alert': 'object',
        'display_critical_alert': 'object',
        'sort_by': 'str',
        'sdt_checked': 'object',
        'items': 'list[NOCItemBase]'
    }
    if hasattr(Widget, "swagger_types"):
        swagger_types.update(Widget.swagger_types)

    attribute_map = {
        'ack_checked': 'ackChecked',
        'display_error_alert': 'displayErrorAlert',
        'display_column': 'displayColumn',
        'display_warn_alert': 'displayWarnAlert',
        'display_critical_alert': 'displayCriticalAlert',
        'sort_by': 'sortBy',
        'sdt_checked': 'sdtChecked',
        'items': 'items'
    }
    if hasattr(Widget, "attribute_map"):
        attribute_map.update(Widget.attribute_map)

    def __init__(self, ack_checked=None, display_error_alert=None, display_column=None, display_warn_alert=None, display_critical_alert=None, sort_by=None, sdt_checked=None, items=None, *args, **kwargs):  # noqa: E501
        """NOCWidget - a model defined in Swagger"""  # noqa: E501
        self._ack_checked = None
        self._display_error_alert = None
        self._display_column = None
        self._display_warn_alert = None
        self._display_critical_alert = None
        self._sort_by = None
        self._sdt_checked = None
        self._items = None
        self.discriminator = None
        if ack_checked is not None:
            self.ack_checked = ack_checked
        if display_error_alert is not None:
            self.display_error_alert = display_error_alert
        if display_column is not None:
            self.display_column = display_column
        if display_warn_alert is not None:
            self.display_warn_alert = display_warn_alert
        if display_critical_alert is not None:
            self.display_critical_alert = display_critical_alert
        if sort_by is not None:
            self.sort_by = sort_by
        if sdt_checked is not None:
            self.sdt_checked = sdt_checked
        self.items = items
        Widget.__init__(self, *args, **kwargs)

    @property
    def ack_checked(self):
        """Gets the ack_checked of this NOCWidget.  # noqa: E501

        Whether or not acknowledgements are displayed in the NOC widget, the default value is true  # noqa: E501

        :return: The ack_checked of this NOCWidget.  # noqa: E501
        :rtype: object
        """
        return self._ack_checked

    @ack_checked.setter
    def ack_checked(self, ack_checked):
        """Sets the ack_checked of this NOCWidget.

        Whether or not acknowledgements are displayed in the NOC widget, the default value is true  # noqa: E501

        :param ack_checked: The ack_checked of this NOCWidget.  # noqa: E501
        :type: object
        """

        self._ack_checked = ack_checked

    @property
    def display_error_alert(self):
        """Gets the display_error_alert of this NOCWidget.  # noqa: E501

        Whether or not error alerts are displayed in the NOC widget, the default value is true  # noqa: E501

        :return: The display_error_alert of this NOCWidget.  # noqa: E501
        :rtype: object
        """
        return self._display_error_alert

    @display_error_alert.setter
    def display_error_alert(self, display_error_alert):
        """Sets the display_error_alert of this NOCWidget.

        Whether or not error alerts are displayed in the NOC widget, the default value is true  # noqa: E501

        :param display_error_alert: The display_error_alert of this NOCWidget.  # noqa: E501
        :type: object
        """

        self._display_error_alert = display_error_alert

    @property
    def display_column(self):
        """Gets the display_column of this NOCWidget.  # noqa: E501

        The maximum number columns displayed in the NOC widget  # noqa: E501

        :return: The display_column of this NOCWidget.  # noqa: E501
        :rtype: int
        """
        return self._display_column

    @display_column.setter
    def display_column(self, display_column):
        """Sets the display_column of this NOCWidget.

        The maximum number columns displayed in the NOC widget  # noqa: E501

        :param display_column: The display_column of this NOCWidget.  # noqa: E501
        :type: int
        """

        self._display_column = display_column

    @property
    def display_warn_alert(self):
        """Gets the display_warn_alert of this NOCWidget.  # noqa: E501

        Whether or not warning alerts are displayed in the NOC widget, the default value is true  # noqa: E501

        :return: The display_warn_alert of this NOCWidget.  # noqa: E501
        :rtype: object
        """
        return self._display_warn_alert

    @display_warn_alert.setter
    def display_warn_alert(self, display_warn_alert):
        """Sets the display_warn_alert of this NOCWidget.

        Whether or not warning alerts are displayed in the NOC widget, the default value is true  # noqa: E501

        :param display_warn_alert: The display_warn_alert of this NOCWidget.  # noqa: E501
        :type: object
        """

        self._display_warn_alert = display_warn_alert

    @property
    def display_critical_alert(self):
        """Gets the display_critical_alert of this NOCWidget.  # noqa: E501

        Whether or not critical alerts are displayed in the NOC widget, the default value is true  # noqa: E501

        :return: The display_critical_alert of this NOCWidget.  # noqa: E501
        :rtype: object
        """
        return self._display_critical_alert

    @display_critical_alert.setter
    def display_critical_alert(self, display_critical_alert):
        """Sets the display_critical_alert of this NOCWidget.

        Whether or not critical alerts are displayed in the NOC widget, the default value is true  # noqa: E501

        :param display_critical_alert: The display_critical_alert of this NOCWidget.  # noqa: E501
        :type: object
        """

        self._display_critical_alert = display_critical_alert

    @property
    def sort_by(self):
        """Gets the sort_by of this NOCWidget.  # noqa: E501

        How NOC items are sorted  # noqa: E501

        :return: The sort_by of this NOCWidget.  # noqa: E501
        :rtype: str
        """
        return self._sort_by

    @sort_by.setter
    def sort_by(self, sort_by):
        """Sets the sort_by of this NOCWidget.

        How NOC items are sorted  # noqa: E501

        :param sort_by: The sort_by of this NOCWidget.  # noqa: E501
        :type: str
        """

        self._sort_by = sort_by

    @property
    def sdt_checked(self):
        """Gets the sdt_checked of this NOCWidget.  # noqa: E501

        Whether or not SDTs are displayed in the NOC widget, the default value is true  # noqa: E501

        :return: The sdt_checked of this NOCWidget.  # noqa: E501
        :rtype: object
        """
        return self._sdt_checked

    @sdt_checked.setter
    def sdt_checked(self, sdt_checked):
        """Sets the sdt_checked of this NOCWidget.

        Whether or not SDTs are displayed in the NOC widget, the default value is true  # noqa: E501

        :param sdt_checked: The sdt_checked of this NOCWidget.  # noqa: E501
        :type: object
        """

        self._sdt_checked = sdt_checked

    @property
    def items(self):
        """Gets the items of this NOCWidget.  # noqa: E501

        The NOC items  # noqa: E501

        :return: The items of this NOCWidget.  # noqa: E501
        :rtype: list[NOCItemBase]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this NOCWidget.

        The NOC items  # noqa: E501

        :param items: The items of this NOCWidget.  # noqa: E501
        :type: list[NOCItemBase]
        """
        if items is None:
            raise ValueError("Invalid value for `items`, must not be `None`")  # noqa: E501

        self._items = items

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NOCWidget, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NOCWidget):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
