# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ScriptCollectorAttribute(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'groovy_script': 'str',
        'manual_connections': 'str',
        'script_type': 'str',
        'windows_script': 'str',
        'name': 'str',
        'linux_cmdline': 'str',
        'linux_script': 'str',
        'windows_cmdline': 'str',
        'properties': 'str'
    }

    attribute_map = {
        'groovy_script': 'groovyScript',
        'manual_connections': 'manualConnections',
        'script_type': 'scriptType',
        'windows_script': 'windowsScript',
        'name': 'name',
        'linux_cmdline': 'linuxCmdline',
        'linux_script': 'linuxScript',
        'windows_cmdline': 'windowsCmdline',
        'properties': 'properties'
    }

    def __init__(self, groovy_script=None, manual_connections=None, script_type=None, windows_script=None, name=None, linux_cmdline=None, linux_script=None, windows_cmdline=None, properties=None):  # noqa: E501
        """ScriptCollectorAttribute - a model defined in Swagger"""  # noqa: E501
        self._groovy_script = None
        self._manual_connections = None
        self._script_type = None
        self._windows_script = None
        self._name = None
        self._linux_cmdline = None
        self._linux_script = None
        self._windows_cmdline = None
        self._properties = None
        self.discriminator = None
        if groovy_script is not None:
            self.groovy_script = groovy_script
        if manual_connections is not None:
            self.manual_connections = manual_connections
        if script_type is not None:
            self.script_type = script_type
        if windows_script is not None:
            self.windows_script = windows_script
        self.name = name
        if linux_cmdline is not None:
            self.linux_cmdline = linux_cmdline
        if linux_script is not None:
            self.linux_script = linux_script
        if windows_cmdline is not None:
            self.windows_cmdline = windows_cmdline
        if properties is not None:
            self.properties = properties

    @property
    def groovy_script(self):
        """Gets the groovy_script of this ScriptCollectorAttribute.  # noqa: E501

        groovy script  # noqa: E501

        :return: The groovy_script of this ScriptCollectorAttribute.  # noqa: E501
        :rtype: str
        """
        return self._groovy_script

    @groovy_script.setter
    def groovy_script(self, groovy_script):
        """Sets the groovy_script of this ScriptCollectorAttribute.

        groovy script  # noqa: E501

        :param groovy_script: The groovy_script of this ScriptCollectorAttribute.  # noqa: E501
        :type: str
        """

        self._groovy_script = groovy_script

    @property
    def manual_connections(self):
        """Gets the manual_connections of this ScriptCollectorAttribute.  # noqa: E501

        manual  # noqa: E501

        :return: The manual_connections of this ScriptCollectorAttribute.  # noqa: E501
        :rtype: str
        """
        return self._manual_connections

    @manual_connections.setter
    def manual_connections(self, manual_connections):
        """Sets the manual_connections of this ScriptCollectorAttribute.

        manual  # noqa: E501

        :param manual_connections: The manual_connections of this ScriptCollectorAttribute.  # noqa: E501
        :type: str
        """

        self._manual_connections = manual_connections

    @property
    def script_type(self):
        """Gets the script_type of this ScriptCollectorAttribute.  # noqa: E501

        script type: embed | file | powershell  # noqa: E501

        :return: The script_type of this ScriptCollectorAttribute.  # noqa: E501
        :rtype: str
        """
        return self._script_type

    @script_type.setter
    def script_type(self, script_type):
        """Sets the script_type of this ScriptCollectorAttribute.

        script type: embed | file | powershell  # noqa: E501

        :param script_type: The script_type of this ScriptCollectorAttribute.  # noqa: E501
        :type: str
        """

        self._script_type = script_type

    @property
    def windows_script(self):
        """Gets the windows_script of this ScriptCollectorAttribute.  # noqa: E501

        windows script  # noqa: E501

        :return: The windows_script of this ScriptCollectorAttribute.  # noqa: E501
        :rtype: str
        """
        return self._windows_script

    @windows_script.setter
    def windows_script(self, windows_script):
        """Sets the windows_script of this ScriptCollectorAttribute.

        windows script  # noqa: E501

        :param windows_script: The windows_script of this ScriptCollectorAttribute.  # noqa: E501
        :type: str
        """

        self._windows_script = windows_script

    @property
    def name(self):
        """Gets the name of this ScriptCollectorAttribute.  # noqa: E501

        The data collector's name  # noqa: E501

        :return: The name of this ScriptCollectorAttribute.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ScriptCollectorAttribute.

        The data collector's name  # noqa: E501

        :param name: The name of this ScriptCollectorAttribute.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def linux_cmdline(self):
        """Gets the linux_cmdline of this ScriptCollectorAttribute.  # noqa: E501

        linux script command line  # noqa: E501

        :return: The linux_cmdline of this ScriptCollectorAttribute.  # noqa: E501
        :rtype: str
        """
        return self._linux_cmdline

    @linux_cmdline.setter
    def linux_cmdline(self, linux_cmdline):
        """Sets the linux_cmdline of this ScriptCollectorAttribute.

        linux script command line  # noqa: E501

        :param linux_cmdline: The linux_cmdline of this ScriptCollectorAttribute.  # noqa: E501
        :type: str
        """

        self._linux_cmdline = linux_cmdline

    @property
    def linux_script(self):
        """Gets the linux_script of this ScriptCollectorAttribute.  # noqa: E501

        linux script  # noqa: E501

        :return: The linux_script of this ScriptCollectorAttribute.  # noqa: E501
        :rtype: str
        """
        return self._linux_script

    @linux_script.setter
    def linux_script(self, linux_script):
        """Sets the linux_script of this ScriptCollectorAttribute.

        linux script  # noqa: E501

        :param linux_script: The linux_script of this ScriptCollectorAttribute.  # noqa: E501
        :type: str
        """

        self._linux_script = linux_script

    @property
    def windows_cmdline(self):
        """Gets the windows_cmdline of this ScriptCollectorAttribute.  # noqa: E501

        windows script command line  # noqa: E501

        :return: The windows_cmdline of this ScriptCollectorAttribute.  # noqa: E501
        :rtype: str
        """
        return self._windows_cmdline

    @windows_cmdline.setter
    def windows_cmdline(self, windows_cmdline):
        """Sets the windows_cmdline of this ScriptCollectorAttribute.

        windows script command line  # noqa: E501

        :param windows_cmdline: The windows_cmdline of this ScriptCollectorAttribute.  # noqa: E501
        :type: str
        """

        self._windows_cmdline = windows_cmdline

    @property
    def properties(self):
        """Gets the properties of this ScriptCollectorAttribute.  # noqa: E501

        property based  # noqa: E501

        :return: The properties of this ScriptCollectorAttribute.  # noqa: E501
        :rtype: str
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this ScriptCollectorAttribute.

        property based  # noqa: E501

        :param properties: The properties of this ScriptCollectorAttribute.  # noqa: E501
        :type: str
        """

        self._properties = properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScriptCollectorAttribute, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScriptCollectorAttribute):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
