# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AlertResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'resource_id': 'int',
        'end_epoch': 'int',
        'threshold': 'str',
        'type': 'str',
        'start_epoch': 'int',
        'enable_anomaly_alert_generation': 'str',
        'internal_id': 'str',
        'monitor_object_name': 'str',
        'data_point_name': 'str',
        'data_point_id': 'int',
        'suppressor': 'str',
        'id': 'str',
        'rule_id': 'int',
        'alert_external_ticket_url': 'JSONObject',
        'tenant': 'str',
        'alert_value': 'str',
        'sdted': 'bool',
        'sdt': 'object',
        'enable_anomaly_alert_suppression': 'str',
        'received_list': 'str',
        'monitor_object_groups': 'object',
        'chain_id': 'int',
        'resource_template_id': 'int',
        'cleared': 'bool',
        'ad_alert_desc': 'str',
        'resource_template_name': 'str',
        'anomaly': 'bool',
        'instance_name': 'str',
        'monitor_object_id': 'int',
        'rule': 'str',
        'ack_comment': 'str',
        'alert_group_entity_value': 'str',
        'instance_id': 'int',
        'suppress_desc': 'str',
        'log_partition': 'str',
        'next_recipient': 'int',
        'ad_alert': 'bool',
        'acked_by': 'str',
        'severity': 'int',
        'acked_epoch': 'int',
        'chain': 'str',
        'sub_chain_id': 'int',
        'log_meta_data': 'str',
        'monitor_object_type': 'str',
        'acked': 'bool',
        'resource_template_type': 'str',
        'clear_value': 'str',
        'instance_description': 'str',
        'dependency_routing_state': 'str',
        'dependency_role': 'str'
    }

    attribute_map = {
        'resource_id': 'resourceId',
        'end_epoch': 'endEpoch',
        'threshold': 'threshold',
        'type': 'type',
        'start_epoch': 'startEpoch',
        'enable_anomaly_alert_generation': 'enableAnomalyAlertGeneration',
        'internal_id': 'internalId',
        'monitor_object_name': 'monitorObjectName',
        'data_point_name': 'dataPointName',
        'data_point_id': 'dataPointId',
        'suppressor': 'suppressor',
        'id': 'id',
        'rule_id': 'ruleId',
        'alert_external_ticket_url': 'alertExternalTicketUrl',
        'tenant': 'tenant',
        'alert_value': 'alertValue',
        'sdted': 'sdted',
        'sdt': 'SDT',
        'enable_anomaly_alert_suppression': 'enableAnomalyAlertSuppression',
        'received_list': 'receivedList',
        'monitor_object_groups': 'monitorObjectGroups',
        'chain_id': 'chainId',
        'resource_template_id': 'resourceTemplateId',
        'cleared': 'cleared',
        'ad_alert_desc': 'adAlertDesc',
        'resource_template_name': 'resourceTemplateName',
        'anomaly': 'anomaly',
        'instance_name': 'instanceName',
        'monitor_object_id': 'monitorObjectId',
        'rule': 'rule',
        'ack_comment': 'ackComment',
        'alert_group_entity_value': 'alertGroupEntityValue',
        'instance_id': 'instanceId',
        'suppress_desc': 'suppressDesc',
        'log_partition': 'logPartition',
        'next_recipient': 'nextRecipient',
        'ad_alert': 'adAlert',
        'acked_by': 'ackedBy',
        'severity': 'severity',
        'acked_epoch': 'ackedEpoch',
        'chain': 'chain',
        'sub_chain_id': 'subChainId',
        'log_meta_data': 'logMetaData',
        'monitor_object_type': 'monitorObjectType',
        'acked': 'acked',
        'resource_template_type': 'resourceTemplateType',
        'clear_value': 'clearValue',
        'instance_description': 'instanceDescription',
        'dependency_routing_state': 'dependencyRoutingState',
        'dependency_role': 'dependencyRole'
    }

    def __init__(self, resource_id=None, end_epoch=None, threshold=None, type=None, start_epoch=None, enable_anomaly_alert_generation=None, internal_id=None, monitor_object_name=None, data_point_name=None, data_point_id=None, suppressor=None, id=None, rule_id=None, alert_external_ticket_url=None, tenant=None, alert_value=None, sdted=None, sdt=None, enable_anomaly_alert_suppression=None, received_list=None, monitor_object_groups=None, chain_id=None, resource_template_id=None, cleared=None, ad_alert_desc=None, resource_template_name=None, anomaly=None, instance_name=None, monitor_object_id=None, rule=None, ack_comment=None, alert_group_entity_value=None, instance_id=None, suppress_desc=None, log_partition=None, next_recipient=None, ad_alert=None, acked_by=None, severity=None, acked_epoch=None, chain=None, sub_chain_id=None, log_meta_data=None, monitor_object_type=None, acked=None, resource_template_type=None, clear_value=None, instance_description=None, dependency_routing_state=None, dependency_role=None):  # noqa: E501
        """AlertResponse - a model defined in Swagger"""  # noqa: E501
        self._resource_id = None
        self._end_epoch = None
        self._threshold = None
        self._type = None
        self._start_epoch = None
        self._enable_anomaly_alert_generation = None
        self._internal_id = None
        self._monitor_object_name = None
        self._data_point_name = None
        self._data_point_id = None
        self._suppressor = None
        self._id = None
        self._rule_id = None
        self._alert_external_ticket_url = None
        self._tenant = None
        self._alert_value = None
        self._sdted = None
        self._sdt = None
        self._enable_anomaly_alert_suppression = None
        self._received_list = None
        self._monitor_object_groups = None
        self._chain_id = None
        self._resource_template_id = None
        self._cleared = None
        self._ad_alert_desc = None
        self._resource_template_name = None
        self._anomaly = None
        self._instance_name = None
        self._monitor_object_id = None
        self._rule = None
        self._ack_comment = None
        self._alert_group_entity_value = None
        self._instance_id = None
        self._suppress_desc = None
        self._log_partition = None
        self._next_recipient = None
        self._ad_alert = None
        self._acked_by = None
        self._severity = None
        self._acked_epoch = None
        self._chain = None
        self._sub_chain_id = None
        self._log_meta_data = None
        self._monitor_object_type = None
        self._acked = None
        self._resource_template_type = None
        self._clear_value = None
        self._instance_description = None
        self._dependency_routing_state = None
        self._dependency_role = None
        self.discriminator = None
        if resource_id is not None:
            self.resource_id = resource_id
        if end_epoch is not None:
            self.end_epoch = end_epoch
        if threshold is not None:
            self.threshold = threshold
        if type is not None:
            self.type = type
        if start_epoch is not None:
            self.start_epoch = start_epoch
        if enable_anomaly_alert_generation is not None:
            self.enable_anomaly_alert_generation = enable_anomaly_alert_generation
        if internal_id is not None:
            self.internal_id = internal_id
        if monitor_object_name is not None:
            self.monitor_object_name = monitor_object_name
        if data_point_name is not None:
            self.data_point_name = data_point_name
        if data_point_id is not None:
            self.data_point_id = data_point_id
        if suppressor is not None:
            self.suppressor = suppressor
        if id is not None:
            self.id = id
        if rule_id is not None:
            self.rule_id = rule_id
        if alert_external_ticket_url is not None:
            self.alert_external_ticket_url = alert_external_ticket_url
        if tenant is not None:
            self.tenant = tenant
        if alert_value is not None:
            self.alert_value = alert_value
        if sdted is not None:
            self.sdted = sdted
        if sdt is not None:
            self.sdt = sdt
        if enable_anomaly_alert_suppression is not None:
            self.enable_anomaly_alert_suppression = enable_anomaly_alert_suppression
        if received_list is not None:
            self.received_list = received_list
        if monitor_object_groups is not None:
            self.monitor_object_groups = monitor_object_groups
        if chain_id is not None:
            self.chain_id = chain_id
        if resource_template_id is not None:
            self.resource_template_id = resource_template_id
        if cleared is not None:
            self.cleared = cleared
        if ad_alert_desc is not None:
            self.ad_alert_desc = ad_alert_desc
        if resource_template_name is not None:
            self.resource_template_name = resource_template_name
        if anomaly is not None:
            self.anomaly = anomaly
        if instance_name is not None:
            self.instance_name = instance_name
        if monitor_object_id is not None:
            self.monitor_object_id = monitor_object_id
        if rule is not None:
            self.rule = rule
        if ack_comment is not None:
            self.ack_comment = ack_comment
        if alert_group_entity_value is not None:
            self.alert_group_entity_value = alert_group_entity_value
        if instance_id is not None:
            self.instance_id = instance_id
        if suppress_desc is not None:
            self.suppress_desc = suppress_desc
        if log_partition is not None:
            self.log_partition = log_partition
        if next_recipient is not None:
            self.next_recipient = next_recipient
        if ad_alert is not None:
            self.ad_alert = ad_alert
        if acked_by is not None:
            self.acked_by = acked_by
        if severity is not None:
            self.severity = severity
        if acked_epoch is not None:
            self.acked_epoch = acked_epoch
        if chain is not None:
            self.chain = chain
        if sub_chain_id is not None:
            self.sub_chain_id = sub_chain_id
        if log_meta_data is not None:
            self.log_meta_data = log_meta_data
        if monitor_object_type is not None:
            self.monitor_object_type = monitor_object_type
        if acked is not None:
            self.acked = acked
        if resource_template_type is not None:
            self.resource_template_type = resource_template_type
        if clear_value is not None:
            self.clear_value = clear_value
        if instance_description is not None:
            self.instance_description = instance_description
        if dependency_routing_state is not None:
            self.dependency_routing_state = dependency_routing_state
        if dependency_role is not None:
            self.dependency_role = dependency_role

    @property
    def resource_id(self):
        """Gets the resource_id of this AlertResponse.  # noqa: E501

        The device specific LogicModule Id  # noqa: E501

        :return: The resource_id of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id):
        """Sets the resource_id of this AlertResponse.

        The device specific LogicModule Id  # noqa: E501

        :param resource_id: The resource_id of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._resource_id = resource_id

    @property
    def end_epoch(self):
        """Gets the end_epoch of this AlertResponse.  # noqa: E501

        The time (in epoch format) that the alert ended  # noqa: E501

        :return: The end_epoch of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._end_epoch

    @end_epoch.setter
    def end_epoch(self, end_epoch):
        """Sets the end_epoch of this AlertResponse.

        The time (in epoch format) that the alert ended  # noqa: E501

        :param end_epoch: The end_epoch of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._end_epoch = end_epoch

    @property
    def threshold(self):
        """Gets the threshold of this AlertResponse.  # noqa: E501

        The threshold associated with the object in alert  # noqa: E501

        :return: The threshold of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._threshold

    @threshold.setter
    def threshold(self, threshold):
        """Sets the threshold of this AlertResponse.

        The threshold associated with the object in alert  # noqa: E501

        :param threshold: The threshold of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._threshold = threshold

    @property
    def type(self):
        """Gets the type of this AlertResponse.  # noqa: E501

        The type of alert  # noqa: E501

        :return: The type of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this AlertResponse.

        The type of alert  # noqa: E501

        :param type: The type of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def start_epoch(self):
        """Gets the start_epoch of this AlertResponse.  # noqa: E501

        The time (in epoch format) that the alert started  # noqa: E501

        :return: The start_epoch of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._start_epoch

    @start_epoch.setter
    def start_epoch(self, start_epoch):
        """Sets the start_epoch of this AlertResponse.

        The time (in epoch format) that the alert started  # noqa: E501

        :param start_epoch: The start_epoch of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._start_epoch = start_epoch

    @property
    def enable_anomaly_alert_generation(self):
        """Gets the enable_anomaly_alert_generation of this AlertResponse.  # noqa: E501

        Indicates dynamic threshold alert generation setting. Expression is comma separated 0 denotes OFF, 1 denotes ON, -1 denotes INVALID 1,0,1 =   warn : ON     error: OFF   critical: ON Empty value on this parameter means : 0,0,0  # noqa: E501

        :return: The enable_anomaly_alert_generation of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._enable_anomaly_alert_generation

    @enable_anomaly_alert_generation.setter
    def enable_anomaly_alert_generation(self, enable_anomaly_alert_generation):
        """Sets the enable_anomaly_alert_generation of this AlertResponse.

        Indicates dynamic threshold alert generation setting. Expression is comma separated 0 denotes OFF, 1 denotes ON, -1 denotes INVALID 1,0,1 =   warn : ON     error: OFF   critical: ON Empty value on this parameter means : 0,0,0  # noqa: E501

        :param enable_anomaly_alert_generation: The enable_anomaly_alert_generation of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._enable_anomaly_alert_generation = enable_anomaly_alert_generation

    @property
    def internal_id(self):
        """Gets the internal_id of this AlertResponse.  # noqa: E501

        The internal id for the alert  # noqa: E501

        :return: The internal_id of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._internal_id

    @internal_id.setter
    def internal_id(self, internal_id):
        """Sets the internal_id of this AlertResponse.

        The internal id for the alert  # noqa: E501

        :param internal_id: The internal_id of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._internal_id = internal_id

    @property
    def monitor_object_name(self):
        """Gets the monitor_object_name of this AlertResponse.  # noqa: E501

        The name of the object that the alert is associated with  # noqa: E501

        :return: The monitor_object_name of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._monitor_object_name

    @monitor_object_name.setter
    def monitor_object_name(self, monitor_object_name):
        """Sets the monitor_object_name of this AlertResponse.

        The name of the object that the alert is associated with  # noqa: E501

        :param monitor_object_name: The monitor_object_name of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._monitor_object_name = monitor_object_name

    @property
    def data_point_name(self):
        """Gets the data_point_name of this AlertResponse.  # noqa: E501

        The name of the datapoint in alert  # noqa: E501

        :return: The data_point_name of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._data_point_name

    @data_point_name.setter
    def data_point_name(self, data_point_name):
        """Sets the data_point_name of this AlertResponse.

        The name of the datapoint in alert  # noqa: E501

        :param data_point_name: The data_point_name of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._data_point_name = data_point_name

    @property
    def data_point_id(self):
        """Gets the data_point_id of this AlertResponse.  # noqa: E501

        The id of the datapoint in alert  # noqa: E501

        :return: The data_point_id of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._data_point_id

    @data_point_id.setter
    def data_point_id(self, data_point_id):
        """Sets the data_point_id of this AlertResponse.

        The id of the datapoint in alert  # noqa: E501

        :param data_point_id: The data_point_id of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._data_point_id = data_point_id

    @property
    def suppressor(self):
        """Gets the suppressor of this AlertResponse.  # noqa: E501

        The component (For example: SDT, HostClusterAlert) which suppressed the alert  # noqa: E501

        :return: The suppressor of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._suppressor

    @suppressor.setter
    def suppressor(self, suppressor):
        """Sets the suppressor of this AlertResponse.

        The component (For example: SDT, HostClusterAlert) which suppressed the alert  # noqa: E501

        :param suppressor: The suppressor of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._suppressor = suppressor

    @property
    def id(self):
        """Gets the id of this AlertResponse.  # noqa: E501

        The alert id  # noqa: E501

        :return: The id of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AlertResponse.

        The alert id  # noqa: E501

        :param id: The id of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def rule_id(self):
        """Gets the rule_id of this AlertResponse.  # noqa: E501

        The id of the rule the alert matches  # noqa: E501

        :return: The rule_id of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._rule_id

    @rule_id.setter
    def rule_id(self, rule_id):
        """Sets the rule_id of this AlertResponse.

        The id of the rule the alert matches  # noqa: E501

        :param rule_id: The rule_id of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._rule_id = rule_id

    @property
    def alert_external_ticket_url(self):
        """Gets the alert_external_ticket_url of this AlertResponse.  # noqa: E501


        :return: The alert_external_ticket_url of this AlertResponse.  # noqa: E501
        :rtype: JSONObject
        """
        return self._alert_external_ticket_url

    @alert_external_ticket_url.setter
    def alert_external_ticket_url(self, alert_external_ticket_url):
        """Sets the alert_external_ticket_url of this AlertResponse.


        :param alert_external_ticket_url: The alert_external_ticket_url of this AlertResponse.  # noqa: E501
        :type: JSONObject
        """

        self._alert_external_ticket_url = alert_external_ticket_url

    @property
    def tenant(self):
        """Gets the tenant of this AlertResponse.  # noqa: E501

        Tenant to which this alert belongs to.   # noqa: E501

        :return: The tenant of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._tenant

    @tenant.setter
    def tenant(self, tenant):
        """Sets the tenant of this AlertResponse.

        Tenant to which this alert belongs to.   # noqa: E501

        :param tenant: The tenant of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._tenant = tenant

    @property
    def alert_value(self):
        """Gets the alert_value of this AlertResponse.  # noqa: E501

        The value that triggered the alert  # noqa: E501

        :return: The alert_value of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._alert_value

    @alert_value.setter
    def alert_value(self, alert_value):
        """Sets the alert_value of this AlertResponse.

        The value that triggered the alert  # noqa: E501

        :param alert_value: The alert_value of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._alert_value = alert_value

    @property
    def sdted(self):
        """Gets the sdted of this AlertResponse.  # noqa: E501

        It specifies if the SDT is set for an active alert or not. However, the sdted is set to false for cleared alert as you cannot apply SDT to a cleared alert.  # noqa: E501

        :return: The sdted of this AlertResponse.  # noqa: E501
        :rtype: bool
        """
        return self._sdted

    @sdted.setter
    def sdted(self, sdted):
        """Sets the sdted of this AlertResponse.

        It specifies if the SDT is set for an active alert or not. However, the sdted is set to false for cleared alert as you cannot apply SDT to a cleared alert.  # noqa: E501

        :param sdted: The sdted of this AlertResponse.  # noqa: E501
        :type: bool
        """

        self._sdted = sdted

    @property
    def sdt(self):
        """Gets the sdt of this AlertResponse.  # noqa: E501

        The active SDT, if one exists  # noqa: E501

        :return: The sdt of this AlertResponse.  # noqa: E501
        :rtype: object
        """
        return self._sdt

    @sdt.setter
    def sdt(self, sdt):
        """Sets the sdt of this AlertResponse.

        The active SDT, if one exists  # noqa: E501

        :param sdt: The sdt of this AlertResponse.  # noqa: E501
        :type: object
        """

        self._sdt = sdt

    @property
    def enable_anomaly_alert_suppression(self):
        """Gets the enable_anomaly_alert_suppression of this AlertResponse.  # noqa: E501

        Indicates anomaly detection alert suppression setting, expression is comma separated 0 denotes OFF, 1 denotes ON, -1 denotes INVALID 1,0,1 =   warn : ON     error: OFF   critical: ON Empty value on this parameter means : 0,0,0  # noqa: E501

        :return: The enable_anomaly_alert_suppression of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._enable_anomaly_alert_suppression

    @enable_anomaly_alert_suppression.setter
    def enable_anomaly_alert_suppression(self, enable_anomaly_alert_suppression):
        """Sets the enable_anomaly_alert_suppression of this AlertResponse.

        Indicates anomaly detection alert suppression setting, expression is comma separated 0 denotes OFF, 1 denotes ON, -1 denotes INVALID 1,0,1 =   warn : ON     error: OFF   critical: ON Empty value on this parameter means : 0,0,0  # noqa: E501

        :param enable_anomaly_alert_suppression: The enable_anomaly_alert_suppression of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._enable_anomaly_alert_suppression = enable_anomaly_alert_suppression

    @property
    def received_list(self):
        """Gets the received_list of this AlertResponse.  # noqa: E501

        The recipients that have received the alert  # noqa: E501

        :return: The received_list of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._received_list

    @received_list.setter
    def received_list(self, received_list):
        """Sets the received_list of this AlertResponse.

        The recipients that have received the alert  # noqa: E501

        :param received_list: The received_list of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._received_list = received_list

    @property
    def monitor_object_groups(self):
        """Gets the monitor_object_groups of this AlertResponse.  # noqa: E501

        Information about the groups the object is a member of  # noqa: E501

        :return: The monitor_object_groups of this AlertResponse.  # noqa: E501
        :rtype: object
        """
        return self._monitor_object_groups

    @monitor_object_groups.setter
    def monitor_object_groups(self, monitor_object_groups):
        """Sets the monitor_object_groups of this AlertResponse.

        Information about the groups the object is a member of  # noqa: E501

        :param monitor_object_groups: The monitor_object_groups of this AlertResponse.  # noqa: E501
        :type: object
        """

        self._monitor_object_groups = monitor_object_groups

    @property
    def chain_id(self):
        """Gets the chain_id of this AlertResponse.  # noqa: E501

        The id of the escalation chain the alert was routed to  # noqa: E501

        :return: The chain_id of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._chain_id

    @chain_id.setter
    def chain_id(self, chain_id):
        """Sets the chain_id of this AlertResponse.

        The id of the escalation chain the alert was routed to  # noqa: E501

        :param chain_id: The chain_id of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._chain_id = chain_id

    @property
    def resource_template_id(self):
        """Gets the resource_template_id of this AlertResponse.  # noqa: E501

        The id of the datasource in alert  # noqa: E501

        :return: The resource_template_id of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._resource_template_id

    @resource_template_id.setter
    def resource_template_id(self, resource_template_id):
        """Sets the resource_template_id of this AlertResponse.

        The id of the datasource in alert  # noqa: E501

        :param resource_template_id: The resource_template_id of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._resource_template_id = resource_template_id

    @property
    def cleared(self):
        """Gets the cleared of this AlertResponse.  # noqa: E501

        Whether or not the alert has cleared  # noqa: E501

        :return: The cleared of this AlertResponse.  # noqa: E501
        :rtype: bool
        """
        return self._cleared

    @cleared.setter
    def cleared(self, cleared):
        """Sets the cleared of this AlertResponse.

        Whether or not the alert has cleared  # noqa: E501

        :param cleared: The cleared of this AlertResponse.  # noqa: E501
        :type: bool
        """

        self._cleared = cleared

    @property
    def ad_alert_desc(self):
        """Gets the ad_alert_desc of this AlertResponse.  # noqa: E501

        The description for dynamic threshold based alert  # noqa: E501

        :return: The ad_alert_desc of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._ad_alert_desc

    @ad_alert_desc.setter
    def ad_alert_desc(self, ad_alert_desc):
        """Sets the ad_alert_desc of this AlertResponse.

        The description for dynamic threshold based alert  # noqa: E501

        :param ad_alert_desc: The ad_alert_desc of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._ad_alert_desc = ad_alert_desc

    @property
    def resource_template_name(self):
        """Gets the resource_template_name of this AlertResponse.  # noqa: E501

        The name of the datasource in alert  # noqa: E501

        :return: The resource_template_name of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._resource_template_name

    @resource_template_name.setter
    def resource_template_name(self, resource_template_name):
        """Sets the resource_template_name of this AlertResponse.

        The name of the datasource in alert  # noqa: E501

        :param resource_template_name: The resource_template_name of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._resource_template_name = resource_template_name

    @property
    def anomaly(self):
        """Gets the anomaly of this AlertResponse.  # noqa: E501

        Indicates the anomaly alert, value can be true/false/null. If alert value lies within confidence band then false, otherwise true. If confidence band is not available then value will be null.  # noqa: E501

        :return: The anomaly of this AlertResponse.  # noqa: E501
        :rtype: bool
        """
        return self._anomaly

    @anomaly.setter
    def anomaly(self, anomaly):
        """Sets the anomaly of this AlertResponse.

        Indicates the anomaly alert, value can be true/false/null. If alert value lies within confidence band then false, otherwise true. If confidence band is not available then value will be null.  # noqa: E501

        :param anomaly: The anomaly of this AlertResponse.  # noqa: E501
        :type: bool
        """

        self._anomaly = anomaly

    @property
    def instance_name(self):
        """Gets the instance_name of this AlertResponse.  # noqa: E501

        The name of the instance in alert  # noqa: E501

        :return: The instance_name of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._instance_name

    @instance_name.setter
    def instance_name(self, instance_name):
        """Sets the instance_name of this AlertResponse.

        The name of the instance in alert  # noqa: E501

        :param instance_name: The instance_name of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._instance_name = instance_name

    @property
    def monitor_object_id(self):
        """Gets the monitor_object_id of this AlertResponse.  # noqa: E501

        The id of the object that the alert is associated with  # noqa: E501

        :return: The monitor_object_id of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._monitor_object_id

    @monitor_object_id.setter
    def monitor_object_id(self, monitor_object_id):
        """Sets the monitor_object_id of this AlertResponse.

        The id of the object that the alert is associated with  # noqa: E501

        :param monitor_object_id: The monitor_object_id of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._monitor_object_id = monitor_object_id

    @property
    def rule(self):
        """Gets the rule of this AlertResponse.  # noqa: E501

        The rule the alert matches  # noqa: E501

        :return: The rule of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._rule

    @rule.setter
    def rule(self, rule):
        """Sets the rule of this AlertResponse.

        The rule the alert matches  # noqa: E501

        :param rule: The rule of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._rule = rule

    @property
    def ack_comment(self):
        """Gets the ack_comment of this AlertResponse.  # noqa: E501

        The comment submitted with the acknowledgement  # noqa: E501

        :return: The ack_comment of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._ack_comment

    @ack_comment.setter
    def ack_comment(self, ack_comment):
        """Sets the ack_comment of this AlertResponse.

        The comment submitted with the acknowledgement  # noqa: E501

        :param ack_comment: The ack_comment of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._ack_comment = ack_comment

    @property
    def alert_group_entity_value(self):
        """Gets the alert_group_entity_value of this AlertResponse.  # noqa: E501

        Alert group entity value for stateful log alerts  # noqa: E501

        :return: The alert_group_entity_value of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._alert_group_entity_value

    @alert_group_entity_value.setter
    def alert_group_entity_value(self, alert_group_entity_value):
        """Sets the alert_group_entity_value of this AlertResponse.

        Alert group entity value for stateful log alerts  # noqa: E501

        :param alert_group_entity_value: The alert_group_entity_value of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._alert_group_entity_value = alert_group_entity_value

    @property
    def instance_id(self):
        """Gets the instance_id of this AlertResponse.  # noqa: E501

        The id of the instance in alert  # noqa: E501

        :return: The instance_id of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._instance_id

    @instance_id.setter
    def instance_id(self, instance_id):
        """Sets the instance_id of this AlertResponse.

        The id of the instance in alert  # noqa: E501

        :param instance_id: The instance_id of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._instance_id = instance_id

    @property
    def suppress_desc(self):
        """Gets the suppress_desc of this AlertResponse.  # noqa: E501

        The description for suppressed alert  # noqa: E501

        :return: The suppress_desc of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._suppress_desc

    @suppress_desc.setter
    def suppress_desc(self, suppress_desc):
        """Sets the suppress_desc of this AlertResponse.

        The description for suppressed alert  # noqa: E501

        :param suppress_desc: The suppress_desc of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._suppress_desc = suppress_desc

    @property
    def log_partition(self):
        """Gets the log_partition of this AlertResponse.  # noqa: E501

        Specified log alert partition information  # noqa: E501

        :return: The log_partition of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._log_partition

    @log_partition.setter
    def log_partition(self, log_partition):
        """Sets the log_partition of this AlertResponse.

        Specified log alert partition information  # noqa: E501

        :param log_partition: The log_partition of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._log_partition = log_partition

    @property
    def next_recipient(self):
        """Gets the next_recipient of this AlertResponse.  # noqa: E501

        The next recipient in the escalation chain for this alert  # noqa: E501

        :return: The next_recipient of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._next_recipient

    @next_recipient.setter
    def next_recipient(self, next_recipient):
        """Sets the next_recipient of this AlertResponse.

        The next recipient in the escalation chain for this alert  # noqa: E501

        :param next_recipient: The next_recipient of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._next_recipient = next_recipient

    @property
    def ad_alert(self):
        """Gets the ad_alert of this AlertResponse.  # noqa: E501

        Specifies whether alert is dynamic threshold based or not  # noqa: E501

        :return: The ad_alert of this AlertResponse.  # noqa: E501
        :rtype: bool
        """
        return self._ad_alert

    @ad_alert.setter
    def ad_alert(self, ad_alert):
        """Sets the ad_alert of this AlertResponse.

        Specifies whether alert is dynamic threshold based or not  # noqa: E501

        :param ad_alert: The ad_alert of this AlertResponse.  # noqa: E501
        :type: bool
        """

        self._ad_alert = ad_alert

    @property
    def acked_by(self):
        """Gets the acked_by of this AlertResponse.  # noqa: E501

        The user that acknowledged the alert  # noqa: E501

        :return: The acked_by of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._acked_by

    @acked_by.setter
    def acked_by(self, acked_by):
        """Sets the acked_by of this AlertResponse.

        The user that acknowledged the alert  # noqa: E501

        :param acked_by: The acked_by of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._acked_by = acked_by

    @property
    def severity(self):
        """Gets the severity of this AlertResponse.  # noqa: E501

        The alert severity, where 2=warning, 3=error and 4=critical  # noqa: E501

        :return: The severity of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._severity

    @severity.setter
    def severity(self, severity):
        """Sets the severity of this AlertResponse.

        The alert severity, where 2=warning, 3=error and 4=critical  # noqa: E501

        :param severity: The severity of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._severity = severity

    @property
    def acked_epoch(self):
        """Gets the acked_epoch of this AlertResponse.  # noqa: E501

        The time (in epoch format) that the alert was acknowledged  # noqa: E501

        :return: The acked_epoch of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._acked_epoch

    @acked_epoch.setter
    def acked_epoch(self, acked_epoch):
        """Sets the acked_epoch of this AlertResponse.

        The time (in epoch format) that the alert was acknowledged  # noqa: E501

        :param acked_epoch: The acked_epoch of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._acked_epoch = acked_epoch

    @property
    def chain(self):
        """Gets the chain of this AlertResponse.  # noqa: E501

        The escalation chain the alert was routed to  # noqa: E501

        :return: The chain of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._chain

    @chain.setter
    def chain(self, chain):
        """Sets the chain of this AlertResponse.

        The escalation chain the alert was routed to  # noqa: E501

        :param chain: The chain of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._chain = chain

    @property
    def sub_chain_id(self):
        """Gets the sub_chain_id of this AlertResponse.  # noqa: E501

        The id of the sub time based chain  # noqa: E501

        :return: The sub_chain_id of this AlertResponse.  # noqa: E501
        :rtype: int
        """
        return self._sub_chain_id

    @sub_chain_id.setter
    def sub_chain_id(self, sub_chain_id):
        """Sets the sub_chain_id of this AlertResponse.

        The id of the sub time based chain  # noqa: E501

        :param sub_chain_id: The sub_chain_id of this AlertResponse.  # noqa: E501
        :type: int
        """

        self._sub_chain_id = sub_chain_id

    @property
    def log_meta_data(self):
        """Gets the log_meta_data of this AlertResponse.  # noqa: E501

        Specified log alert metadata fields value  # noqa: E501

        :return: The log_meta_data of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._log_meta_data

    @log_meta_data.setter
    def log_meta_data(self, log_meta_data):
        """Sets the log_meta_data of this AlertResponse.

        Specified log alert metadata fields value  # noqa: E501

        :param log_meta_data: The log_meta_data of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._log_meta_data = log_meta_data

    @property
    def monitor_object_type(self):
        """Gets the monitor_object_type of this AlertResponse.  # noqa: E501


        :return: The monitor_object_type of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._monitor_object_type

    @monitor_object_type.setter
    def monitor_object_type(self, monitor_object_type):
        """Sets the monitor_object_type of this AlertResponse.


        :param monitor_object_type: The monitor_object_type of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._monitor_object_type = monitor_object_type

    @property
    def acked(self):
        """Gets the acked of this AlertResponse.  # noqa: E501

        Whether or not the alert has been acknowledged  # noqa: E501

        :return: The acked of this AlertResponse.  # noqa: E501
        :rtype: bool
        """
        return self._acked

    @acked.setter
    def acked(self, acked):
        """Sets the acked of this AlertResponse.

        Whether or not the alert has been acknowledged  # noqa: E501

        :param acked: The acked of this AlertResponse.  # noqa: E501
        :type: bool
        """

        self._acked = acked

    @property
    def resource_template_type(self):
        """Gets the resource_template_type of this AlertResponse.  # noqa: E501

        The type of the logicmodule in alert  # noqa: E501

        :return: The resource_template_type of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._resource_template_type

    @resource_template_type.setter
    def resource_template_type(self, resource_template_type):
        """Sets the resource_template_type of this AlertResponse.

        The type of the logicmodule in alert  # noqa: E501

        :param resource_template_type: The resource_template_type of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._resource_template_type = resource_template_type

    @property
    def clear_value(self):
        """Gets the clear_value of this AlertResponse.  # noqa: E501

        The value that cleared the alert  # noqa: E501

        :return: The clear_value of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._clear_value

    @clear_value.setter
    def clear_value(self, clear_value):
        """Sets the clear_value of this AlertResponse.

        The value that cleared the alert  # noqa: E501

        :param clear_value: The clear_value of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._clear_value = clear_value

    @property
    def instance_description(self):
        """Gets the instance_description of this AlertResponse.  # noqa: E501

        The description of the instance in alert  # noqa: E501

        :return: The instance_description of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._instance_description

    @instance_description.setter
    def instance_description(self, instance_description):
        """Sets the instance_description of this AlertResponse.

        The description of the instance in alert  # noqa: E501

        :param instance_description: The instance_description of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._instance_description = instance_description

    @property
    def dependency_routing_state(self):
        """Gets the dependency_routing_state of this AlertResponse.  # noqa: E501

        The dependency routing state  # noqa: E501

        :return: The dependency_routing_state of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._dependency_routing_state

    @dependency_routing_state.setter
    def dependency_routing_state(self, dependency_routing_state):
        """Sets the dependency_routing_state of this AlertResponse.

        The dependency routing state  # noqa: E501

        :param dependency_routing_state: The dependency_routing_state of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._dependency_routing_state = dependency_routing_state

    @property
    def dependency_role(self):
        """Gets the dependency_role of this AlertResponse.  # noqa: E501

        The dependency role  # noqa: E501

        :return: The dependency_role of this AlertResponse.  # noqa: E501
        :rtype: str
        """
        return self._dependency_role

    @dependency_role.setter
    def dependency_role(self, dependency_role):
        """Sets the dependency_role of this AlertResponse.

        The dependency role  # noqa: E501

        :param dependency_role: The dependency_role of this AlertResponse.  # noqa: E501
        :type: str
        """

        self._dependency_role = dependency_role

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AlertResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AlertResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
