# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DataSource(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'eri_discovery_config': 'ScriptERIDiscoveryAttributeV3',
        'access_groups': 'list[AccessGroup]',
        'display_name': 'str',
        'description': 'str',
        'applies_to': 'str',
        'lineage_id': 'str',
        'collect_method': 'str',
        'checksum': 'str',
        'data_points': 'list[DataPoint]',
        'id': 'int',
        'access_group_ids': 'list[int]',
        'group': 'str',
        'collector_attribute': 'CollectorAttribute',
        'auto_discovery_config': 'AutoDiscoveryConfiguration',
        'payload_version': 'int',
        'use_wild_value_as_uuid': 'bool',
        'enable_auto_discovery': 'bool',
        'technology': 'str',
        'version': 'int',
        'tags': 'str',
        'audit_version': 'int',
        'has_multi_instances': 'bool',
        'installation_metadata': 'IntegrationMetadata',
        'eri_discovery_interval': 'int',
        'enable_eri_discovery': 'bool',
        'collect_interval': 'int',
        'name': 'str'
    }

    attribute_map = {
        'eri_discovery_config': 'eriDiscoveryConfig',
        'access_groups': 'accessGroups',
        'display_name': 'displayName',
        'description': 'description',
        'applies_to': 'appliesTo',
        'lineage_id': 'lineageId',
        'collect_method': 'collectMethod',
        'checksum': 'checksum',
        'data_points': 'dataPoints',
        'id': 'id',
        'access_group_ids': 'accessGroupIds',
        'group': 'group',
        'collector_attribute': 'collectorAttribute',
        'auto_discovery_config': 'autoDiscoveryConfig',
        'payload_version': 'payloadVersion',
        'use_wild_value_as_uuid': 'useWildValueAsUUID',
        'enable_auto_discovery': 'enableAutoDiscovery',
        'technology': 'technology',
        'version': 'version',
        'tags': 'tags',
        'audit_version': 'auditVersion',
        'has_multi_instances': 'hasMultiInstances',
        'installation_metadata': 'installationMetadata',
        'eri_discovery_interval': 'eriDiscoveryInterval',
        'enable_eri_discovery': 'enableEriDiscovery',
        'collect_interval': 'collectInterval',
        'name': 'name'
    }

    def __init__(self, eri_discovery_config=None, access_groups=None, display_name=None, description=None, applies_to=None, lineage_id=None, collect_method=None, checksum=None, data_points=None, id=None, access_group_ids=None, group=None, collector_attribute=None, auto_discovery_config=None, payload_version=None, use_wild_value_as_uuid=None, enable_auto_discovery=None, technology=None, version=None, tags=None, audit_version=None, has_multi_instances=None, installation_metadata=None, eri_discovery_interval=None, enable_eri_discovery=None, collect_interval=None, name=None):  # noqa: E501
        """DataSource - a model defined in Swagger"""  # noqa: E501
        self._eri_discovery_config = None
        self._access_groups = None
        self._display_name = None
        self._description = None
        self._applies_to = None
        self._lineage_id = None
        self._collect_method = None
        self._checksum = None
        self._data_points = None
        self._id = None
        self._access_group_ids = None
        self._group = None
        self._collector_attribute = None
        self._auto_discovery_config = None
        self._payload_version = None
        self._use_wild_value_as_uuid = None
        self._enable_auto_discovery = None
        self._technology = None
        self._version = None
        self._tags = None
        self._audit_version = None
        self._has_multi_instances = None
        self._installation_metadata = None
        self._eri_discovery_interval = None
        self._enable_eri_discovery = None
        self._collect_interval = None
        self._name = None
        self.discriminator = None
        if eri_discovery_config is not None:
            self.eri_discovery_config = eri_discovery_config
        if access_groups is not None:
            self.access_groups = access_groups
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if applies_to is not None:
            self.applies_to = applies_to
        if lineage_id is not None:
            self.lineage_id = lineage_id
        self.collect_method = collect_method
        if checksum is not None:
            self.checksum = checksum
        if data_points is not None:
            self.data_points = data_points
        if id is not None:
            self.id = id
        if access_group_ids is not None:
            self.access_group_ids = access_group_ids
        if group is not None:
            self.group = group
        self.collector_attribute = collector_attribute
        if auto_discovery_config is not None:
            self.auto_discovery_config = auto_discovery_config
        if payload_version is not None:
            self.payload_version = payload_version
        if use_wild_value_as_uuid is not None:
            self.use_wild_value_as_uuid = use_wild_value_as_uuid
        if enable_auto_discovery is not None:
            self.enable_auto_discovery = enable_auto_discovery
        if technology is not None:
            self.technology = technology
        if version is not None:
            self.version = version
        if tags is not None:
            self.tags = tags
        if audit_version is not None:
            self.audit_version = audit_version
        if has_multi_instances is not None:
            self.has_multi_instances = has_multi_instances
        if installation_metadata is not None:
            self.installation_metadata = installation_metadata
        if eri_discovery_interval is not None:
            self.eri_discovery_interval = eri_discovery_interval
        if enable_eri_discovery is not None:
            self.enable_eri_discovery = enable_eri_discovery
        self.collect_interval = collect_interval
        self.name = name

    @property
    def eri_discovery_config(self):
        """Gets the eri_discovery_config of this DataSource.  # noqa: E501


        :return: The eri_discovery_config of this DataSource.  # noqa: E501
        :rtype: ScriptERIDiscoveryAttributeV3
        """
        return self._eri_discovery_config

    @eri_discovery_config.setter
    def eri_discovery_config(self, eri_discovery_config):
        """Sets the eri_discovery_config of this DataSource.


        :param eri_discovery_config: The eri_discovery_config of this DataSource.  # noqa: E501
        :type: ScriptERIDiscoveryAttributeV3
        """

        self._eri_discovery_config = eri_discovery_config

    @property
    def access_groups(self):
        """Gets the access_groups of this DataSource.  # noqa: E501

        Module's access groups  # noqa: E501

        :return: The access_groups of this DataSource.  # noqa: E501
        :rtype: list[AccessGroup]
        """
        return self._access_groups

    @access_groups.setter
    def access_groups(self, access_groups):
        """Sets the access_groups of this DataSource.

        Module's access groups  # noqa: E501

        :param access_groups: The access_groups of this DataSource.  # noqa: E501
        :type: list[AccessGroup]
        """

        self._access_groups = access_groups

    @property
    def display_name(self):
        """Gets the display_name of this DataSource.  # noqa: E501

        The data source display name  # noqa: E501

        :return: The display_name of this DataSource.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this DataSource.

        The data source display name  # noqa: E501

        :param display_name: The display_name of this DataSource.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this DataSource.  # noqa: E501

        The description for the LMModule  # noqa: E501

        :return: The description of this DataSource.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this DataSource.

        The description for the LMModule  # noqa: E501

        :param description: The description of this DataSource.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def applies_to(self):
        """Gets the applies_to of this DataSource.  # noqa: E501

        The Applies To for the LMModule  # noqa: E501

        :return: The applies_to of this DataSource.  # noqa: E501
        :rtype: str
        """
        return self._applies_to

    @applies_to.setter
    def applies_to(self, applies_to):
        """Sets the applies_to of this DataSource.

        The Applies To for the LMModule  # noqa: E501

        :param applies_to: The applies_to of this DataSource.  # noqa: E501
        :type: str
        """

        self._applies_to = applies_to

    @property
    def lineage_id(self):
        """Gets the lineage_id of this DataSource.  # noqa: E501

        The lineageId the LMModule belongs to  # noqa: E501

        :return: The lineage_id of this DataSource.  # noqa: E501
        :rtype: str
        """
        return self._lineage_id

    @lineage_id.setter
    def lineage_id(self, lineage_id):
        """Sets the lineage_id of this DataSource.

        The lineageId the LMModule belongs to  # noqa: E501

        :param lineage_id: The lineage_id of this DataSource.  # noqa: E501
        :type: str
        """

        self._lineage_id = lineage_id

    @property
    def collect_method(self):
        """Gets the collect_method of this DataSource.  # noqa: E501

        The  method to collect data. The values can be snmp|ping|exs|webpage|wmi|cim|datadump|dns|ipmi|jdbb|script|udp|tcp|xen  # noqa: E501

        :return: The collect_method of this DataSource.  # noqa: E501
        :rtype: str
        """
        return self._collect_method

    @collect_method.setter
    def collect_method(self, collect_method):
        """Sets the collect_method of this DataSource.

        The  method to collect data. The values can be snmp|ping|exs|webpage|wmi|cim|datadump|dns|ipmi|jdbb|script|udp|tcp|xen  # noqa: E501

        :param collect_method: The collect_method of this DataSource.  # noqa: E501
        :type: str
        """
        if collect_method is None:
            raise ValueError("Invalid value for `collect_method`, must not be `None`")  # noqa: E501

        self._collect_method = collect_method

    @property
    def checksum(self):
        """Gets the checksum of this DataSource.  # noqa: E501

        The metadata checksum for the LMModule content  # noqa: E501

        :return: The checksum of this DataSource.  # noqa: E501
        :rtype: str
        """
        return self._checksum

    @checksum.setter
    def checksum(self, checksum):
        """Sets the checksum of this DataSource.

        The metadata checksum for the LMModule content  # noqa: E501

        :param checksum: The checksum of this DataSource.  # noqa: E501
        :type: str
        """

        self._checksum = checksum

    @property
    def data_points(self):
        """Gets the data_points of this DataSource.  # noqa: E501

        The data point list  # noqa: E501

        :return: The data_points of this DataSource.  # noqa: E501
        :rtype: list[DataPoint]
        """
        return self._data_points

    @data_points.setter
    def data_points(self, data_points):
        """Sets the data_points of this DataSource.

        The data point list  # noqa: E501

        :param data_points: The data_points of this DataSource.  # noqa: E501
        :type: list[DataPoint]
        """

        self._data_points = data_points

    @property
    def id(self):
        """Gets the id of this DataSource.  # noqa: E501

        The ID of the LMModule  # noqa: E501

        :return: The id of this DataSource.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DataSource.

        The ID of the LMModule  # noqa: E501

        :param id: The id of this DataSource.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def access_group_ids(self):
        """Gets the access_group_ids of this DataSource.  # noqa: E501

        The Access Groups Id's  # noqa: E501

        :return: The access_group_ids of this DataSource.  # noqa: E501
        :rtype: list[int]
        """
        return self._access_group_ids

    @access_group_ids.setter
    def access_group_ids(self, access_group_ids):
        """Sets the access_group_ids of this DataSource.

        The Access Groups Id's  # noqa: E501

        :param access_group_ids: The access_group_ids of this DataSource.  # noqa: E501
        :type: list[int]
        """

        self._access_group_ids = access_group_ids

    @property
    def group(self):
        """Gets the group of this DataSource.  # noqa: E501

        The group the LMModule is in  # noqa: E501

        :return: The group of this DataSource.  # noqa: E501
        :rtype: str
        """
        return self._group

    @group.setter
    def group(self, group):
        """Sets the group of this DataSource.

        The group the LMModule is in  # noqa: E501

        :param group: The group of this DataSource.  # noqa: E501
        :type: str
        """

        self._group = group

    @property
    def collector_attribute(self):
        """Gets the collector_attribute of this DataSource.  # noqa: E501


        :return: The collector_attribute of this DataSource.  # noqa: E501
        :rtype: CollectorAttribute
        """
        return self._collector_attribute

    @collector_attribute.setter
    def collector_attribute(self, collector_attribute):
        """Sets the collector_attribute of this DataSource.


        :param collector_attribute: The collector_attribute of this DataSource.  # noqa: E501
        :type: CollectorAttribute
        """
        if collector_attribute is None:
            raise ValueError("Invalid value for `collector_attribute`, must not be `None`")  # noqa: E501

        self._collector_attribute = collector_attribute

    @property
    def auto_discovery_config(self):
        """Gets the auto_discovery_config of this DataSource.  # noqa: E501


        :return: The auto_discovery_config of this DataSource.  # noqa: E501
        :rtype: AutoDiscoveryConfiguration
        """
        return self._auto_discovery_config

    @auto_discovery_config.setter
    def auto_discovery_config(self, auto_discovery_config):
        """Sets the auto_discovery_config of this DataSource.


        :param auto_discovery_config: The auto_discovery_config of this DataSource.  # noqa: E501
        :type: AutoDiscoveryConfiguration
        """

        self._auto_discovery_config = auto_discovery_config

    @property
    def payload_version(self):
        """Gets the payload_version of this DataSource.  # noqa: E501

        The DataSource payload version for custom metrics  # noqa: E501

        :return: The payload_version of this DataSource.  # noqa: E501
        :rtype: int
        """
        return self._payload_version

    @payload_version.setter
    def payload_version(self, payload_version):
        """Sets the payload_version of this DataSource.

        The DataSource payload version for custom metrics  # noqa: E501

        :param payload_version: The payload_version of this DataSource.  # noqa: E501
        :type: int
        """

        self._payload_version = payload_version

    @property
    def use_wild_value_as_uuid(self):
        """Gets the use_wild_value_as_uuid of this DataSource.  # noqa: E501

        Use wild-value as unique identifier in case of multi instance datasource: true|false  # noqa: E501

        :return: The use_wild_value_as_uuid of this DataSource.  # noqa: E501
        :rtype: bool
        """
        return self._use_wild_value_as_uuid

    @use_wild_value_as_uuid.setter
    def use_wild_value_as_uuid(self, use_wild_value_as_uuid):
        """Sets the use_wild_value_as_uuid of this DataSource.

        Use wild-value as unique identifier in case of multi instance datasource: true|false  # noqa: E501

        :param use_wild_value_as_uuid: The use_wild_value_as_uuid of this DataSource.  # noqa: E501
        :type: bool
        """

        self._use_wild_value_as_uuid = use_wild_value_as_uuid

    @property
    def enable_auto_discovery(self):
        """Gets the enable_auto_discovery of this DataSource.  # noqa: E501

        Enable Auto Discovery or not when this data source has multi instance: false|true  # noqa: E501

        :return: The enable_auto_discovery of this DataSource.  # noqa: E501
        :rtype: bool
        """
        return self._enable_auto_discovery

    @enable_auto_discovery.setter
    def enable_auto_discovery(self, enable_auto_discovery):
        """Sets the enable_auto_discovery of this DataSource.

        Enable Auto Discovery or not when this data source has multi instance: false|true  # noqa: E501

        :param enable_auto_discovery: The enable_auto_discovery of this DataSource.  # noqa: E501
        :type: bool
        """

        self._enable_auto_discovery = enable_auto_discovery

    @property
    def technology(self):
        """Gets the technology of this DataSource.  # noqa: E501

        The Technical Notes for the LMModule  # noqa: E501

        :return: The technology of this DataSource.  # noqa: E501
        :rtype: str
        """
        return self._technology

    @technology.setter
    def technology(self, technology):
        """Sets the technology of this DataSource.

        The Technical Notes for the LMModule  # noqa: E501

        :param technology: The technology of this DataSource.  # noqa: E501
        :type: str
        """

        self._technology = technology

    @property
    def version(self):
        """Gets the version of this DataSource.  # noqa: E501

        The data source version  # noqa: E501

        :return: The version of this DataSource.  # noqa: E501
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this DataSource.

        The data source version  # noqa: E501

        :param version: The version of this DataSource.  # noqa: E501
        :type: int
        """

        self._version = version

    @property
    def tags(self):
        """Gets the tags of this DataSource.  # noqa: E501

        The Tags for the LMModule  # noqa: E501

        :return: The tags of this DataSource.  # noqa: E501
        :rtype: str
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this DataSource.

        The Tags for the LMModule  # noqa: E501

        :param tags: The tags of this DataSource.  # noqa: E501
        :type: str
        """

        self._tags = tags

    @property
    def audit_version(self):
        """Gets the audit_version of this DataSource.  # noqa: E501

        The data source audit version  # noqa: E501

        :return: The audit_version of this DataSource.  # noqa: E501
        :rtype: int
        """
        return self._audit_version

    @audit_version.setter
    def audit_version(self, audit_version):
        """Sets the audit_version of this DataSource.

        The data source audit version  # noqa: E501

        :param audit_version: The audit_version of this DataSource.  # noqa: E501
        :type: int
        """

        self._audit_version = audit_version

    @property
    def has_multi_instances(self):
        """Gets the has_multi_instances of this DataSource.  # noqa: E501

        If the DataSource has multi instance: true|false  # noqa: E501

        :return: The has_multi_instances of this DataSource.  # noqa: E501
        :rtype: bool
        """
        return self._has_multi_instances

    @has_multi_instances.setter
    def has_multi_instances(self, has_multi_instances):
        """Sets the has_multi_instances of this DataSource.

        If the DataSource has multi instance: true|false  # noqa: E501

        :param has_multi_instances: The has_multi_instances of this DataSource.  # noqa: E501
        :type: bool
        """

        self._has_multi_instances = has_multi_instances

    @property
    def installation_metadata(self):
        """Gets the installation_metadata of this DataSource.  # noqa: E501


        :return: The installation_metadata of this DataSource.  # noqa: E501
        :rtype: IntegrationMetadata
        """
        return self._installation_metadata

    @installation_metadata.setter
    def installation_metadata(self, installation_metadata):
        """Sets the installation_metadata of this DataSource.


        :param installation_metadata: The installation_metadata of this DataSource.  # noqa: E501
        :type: IntegrationMetadata
        """

        self._installation_metadata = installation_metadata

    @property
    def eri_discovery_interval(self):
        """Gets the eri_discovery_interval of this DataSource.  # noqa: E501

        The DataSource data collect interval  # noqa: E501

        :return: The eri_discovery_interval of this DataSource.  # noqa: E501
        :rtype: int
        """
        return self._eri_discovery_interval

    @eri_discovery_interval.setter
    def eri_discovery_interval(self, eri_discovery_interval):
        """Sets the eri_discovery_interval of this DataSource.

        The DataSource data collect interval  # noqa: E501

        :param eri_discovery_interval: The eri_discovery_interval of this DataSource.  # noqa: E501
        :type: int
        """

        self._eri_discovery_interval = eri_discovery_interval

    @property
    def enable_eri_discovery(self):
        """Gets the enable_eri_discovery of this DataSource.  # noqa: E501

        Enable ERI Discovery or not: false|true  # noqa: E501

        :return: The enable_eri_discovery of this DataSource.  # noqa: E501
        :rtype: bool
        """
        return self._enable_eri_discovery

    @enable_eri_discovery.setter
    def enable_eri_discovery(self, enable_eri_discovery):
        """Sets the enable_eri_discovery of this DataSource.

        Enable ERI Discovery or not: false|true  # noqa: E501

        :param enable_eri_discovery: The enable_eri_discovery of this DataSource.  # noqa: E501
        :type: bool
        """

        self._enable_eri_discovery = enable_eri_discovery

    @property
    def collect_interval(self):
        """Gets the collect_interval of this DataSource.  # noqa: E501

        The DataSource data collect interval  # noqa: E501

        :return: The collect_interval of this DataSource.  # noqa: E501
        :rtype: int
        """
        return self._collect_interval

    @collect_interval.setter
    def collect_interval(self, collect_interval):
        """Sets the collect_interval of this DataSource.

        The DataSource data collect interval  # noqa: E501

        :param collect_interval: The collect_interval of this DataSource.  # noqa: E501
        :type: int
        """
        if collect_interval is None:
            raise ValueError("Invalid value for `collect_interval`, must not be `None`")  # noqa: E501

        self._collect_interval = collect_interval

    @property
    def name(self):
        """Gets the name of this DataSource.  # noqa: E501

        The data source name  # noqa: E501

        :return: The name of this DataSource.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DataSource.

        The data source name  # noqa: E501

        :param name: The name of this DataSource.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DataSource, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DataSource):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
