# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from logicmonitor_sdk.models.widget import Widget  # noqa: F401,E501

class DeviceSLAWidget(Widget):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'calculation_method': 'int',
        'days_in_week': 'str',
        'display_type': 'int',
        'top_x': 'int',
        'timezone': 'str',
        'bottom_label': 'str',
        'display_percentage_bar': 'bool',
        'period_in_one_day': 'str',
        'metrics': 'list[SlaMetric]',
        'unmonitored_time_type': 'int',
        'color_thresholds': 'list[ColorThreshold]'
    }
    if hasattr(Widget, "swagger_types"):
        swagger_types.update(Widget.swagger_types)

    attribute_map = {
        'calculation_method': 'calculationMethod',
        'days_in_week': 'daysInWeek',
        'display_type': 'displayType',
        'top_x': 'topX',
        'timezone': 'timezone',
        'bottom_label': 'bottomLabel',
        'display_percentage_bar': 'displayPercentageBar',
        'period_in_one_day': 'periodInOneDay',
        'metrics': 'metrics',
        'unmonitored_time_type': 'unmonitoredTimeType',
        'color_thresholds': 'colorThresholds'
    }
    if hasattr(Widget, "attribute_map"):
        attribute_map.update(Widget.attribute_map)

    def __init__(self, calculation_method=None, days_in_week=None, display_type=None, top_x=None, timezone=None, bottom_label=None, display_percentage_bar=None, period_in_one_day=None, metrics=None, unmonitored_time_type=None, color_thresholds=None, *args, **kwargs):  # noqa: E501
        """DeviceSLAWidget - a model defined in Swagger"""  # noqa: E501
        self._calculation_method = None
        self._days_in_week = None
        self._display_type = None
        self._top_x = None
        self._timezone = None
        self._bottom_label = None
        self._display_percentage_bar = None
        self._period_in_one_day = None
        self._metrics = None
        self._unmonitored_time_type = None
        self._color_thresholds = None
        self.discriminator = None
        if calculation_method is not None:
            self.calculation_method = calculation_method
        if days_in_week is not None:
            self.days_in_week = days_in_week
        if display_type is not None:
            self.display_type = display_type
        if top_x is not None:
            self.top_x = top_x
        if timezone is not None:
            self.timezone = timezone
        if bottom_label is not None:
            self.bottom_label = bottom_label
        if display_percentage_bar is not None:
            self.display_percentage_bar = display_percentage_bar
        if period_in_one_day is not None:
            self.period_in_one_day = period_in_one_day
        self.metrics = metrics
        if unmonitored_time_type is not None:
            self.unmonitored_time_type = unmonitored_time_type
        if color_thresholds is not None:
            self.color_thresholds = color_thresholds
        Widget.__init__(self, *args, **kwargs)

    @property
    def calculation_method(self):
        """Gets the calculation_method of this DeviceSLAWidget.  # noqa: E501

        Calculation method: 0 = percent all resources available, 1 = average of all SLA metrics  # noqa: E501

        :return: The calculation_method of this DeviceSLAWidget.  # noqa: E501
        :rtype: int
        """
        return self._calculation_method

    @calculation_method.setter
    def calculation_method(self, calculation_method):
        """Sets the calculation_method of this DeviceSLAWidget.

        Calculation method: 0 = percent all resources available, 1 = average of all SLA metrics  # noqa: E501

        :param calculation_method: The calculation_method of this DeviceSLAWidget.  # noqa: E501
        :type: int
        """

        self._calculation_method = calculation_method

    @property
    def days_in_week(self):
        """Gets the days_in_week of this DeviceSLAWidget.  # noqa: E501

        The days that SLA should be computed for, separated by commas. 1=Sunday, 2=Monday, 3=Tuesday, 4=Wednesday, 5=Thursday, 6=Friday, 7=Saturday.  # noqa: E501

        :return: The days_in_week of this DeviceSLAWidget.  # noqa: E501
        :rtype: str
        """
        return self._days_in_week

    @days_in_week.setter
    def days_in_week(self, days_in_week):
        """Sets the days_in_week of this DeviceSLAWidget.

        The days that SLA should be computed for, separated by commas. 1=Sunday, 2=Monday, 3=Tuesday, 4=Wednesday, 5=Thursday, 6=Friday, 7=Saturday.  # noqa: E501

        :param days_in_week: The days_in_week of this DeviceSLAWidget.  # noqa: E501
        :type: str
        """

        self._days_in_week = days_in_week

    @property
    def display_type(self):
        """Gets the display_type of this DeviceSLAWidget.  # noqa: E501

        Whether or not selected metrics should be combined into one number (displayType:0) or should be displayed individually, up to four metrics (displayType:1)  # noqa: E501

        :return: The display_type of this DeviceSLAWidget.  # noqa: E501
        :rtype: int
        """
        return self._display_type

    @display_type.setter
    def display_type(self, display_type):
        """Sets the display_type of this DeviceSLAWidget.

        Whether or not selected metrics should be combined into one number (displayType:0) or should be displayed individually, up to four metrics (displayType:1)  # noqa: E501

        :param display_type: The display_type of this DeviceSLAWidget.  # noqa: E501
        :type: int
        """

        self._display_type = display_type

    @property
    def top_x(self):
        """Gets the top_x of this DeviceSLAWidget.  # noqa: E501

        Top list size for each point, 1 means aggregate  # noqa: E501

        :return: The top_x of this DeviceSLAWidget.  # noqa: E501
        :rtype: int
        """
        return self._top_x

    @top_x.setter
    def top_x(self, top_x):
        """Sets the top_x of this DeviceSLAWidget.

        Top list size for each point, 1 means aggregate  # noqa: E501

        :param top_x: The top_x of this DeviceSLAWidget.  # noqa: E501
        :type: int
        """

        self._top_x = top_x

    @property
    def timezone(self):
        """Gets the timezone of this DeviceSLAWidget.  # noqa: E501

        The specific timezone for the widget  # noqa: E501

        :return: The timezone of this DeviceSLAWidget.  # noqa: E501
        :rtype: str
        """
        return self._timezone

    @timezone.setter
    def timezone(self, timezone):
        """Sets the timezone of this DeviceSLAWidget.

        The specific timezone for the widget  # noqa: E501

        :param timezone: The timezone of this DeviceSLAWidget.  # noqa: E501
        :type: str
        """

        self._timezone = timezone

    @property
    def bottom_label(self):
        """Gets the bottom_label of this DeviceSLAWidget.  # noqa: E501

        The services that should be used to compute the SLA, where each service should include serviceGroup and service  # noqa: E501

        :return: The bottom_label of this DeviceSLAWidget.  # noqa: E501
        :rtype: str
        """
        return self._bottom_label

    @bottom_label.setter
    def bottom_label(self, bottom_label):
        """Sets the bottom_label of this DeviceSLAWidget.

        The services that should be used to compute the SLA, where each service should include serviceGroup and service  # noqa: E501

        :param bottom_label: The bottom_label of this DeviceSLAWidget.  # noqa: E501
        :type: str
        """

        self._bottom_label = bottom_label

    @property
    def display_percentage_bar(self):
        """Gets the display_percentage_bar of this DeviceSLAWidget.  # noqa: E501

        Whether a progress bar is displayed in list mode  # noqa: E501

        :return: The display_percentage_bar of this DeviceSLAWidget.  # noqa: E501
        :rtype: bool
        """
        return self._display_percentage_bar

    @display_percentage_bar.setter
    def display_percentage_bar(self, display_percentage_bar):
        """Sets the display_percentage_bar of this DeviceSLAWidget.

        Whether a progress bar is displayed in list mode  # noqa: E501

        :param display_percentage_bar: The display_percentage_bar of this DeviceSLAWidget.  # noqa: E501
        :type: bool
        """

        self._display_percentage_bar = display_percentage_bar

    @property
    def period_in_one_day(self):
        """Gets the period_in_one_day of this DeviceSLAWidget.  # noqa: E501

        The period during the selected days that the SLA should be computed for. * = all day, or a time range can be specified in the format of \"hh:mm TO hh:mm\", e.g. \"01:15 TO 17:15\"  # noqa: E501

        :return: The period_in_one_day of this DeviceSLAWidget.  # noqa: E501
        :rtype: str
        """
        return self._period_in_one_day

    @period_in_one_day.setter
    def period_in_one_day(self, period_in_one_day):
        """Sets the period_in_one_day of this DeviceSLAWidget.

        The period during the selected days that the SLA should be computed for. * = all day, or a time range can be specified in the format of \"hh:mm TO hh:mm\", e.g. \"01:15 TO 17:15\"  # noqa: E501

        :param period_in_one_day: The period_in_one_day of this DeviceSLAWidget.  # noqa: E501
        :type: str
        """

        self._period_in_one_day = period_in_one_day

    @property
    def metrics(self):
        """Gets the metrics of this DeviceSLAWidget.  # noqa: E501

        The metrics (datapoints) that should be used to compute the SLA, where each service should include groupName (can be *), deviceName (can be *), dataSourceId or dataSourceFullName, instances (can be *), metric (datapoint), threshold, and exclusionSDTType (empty string means SDT periods will not be excluded, \"group\" means SDT periods at the device group level will be excluded, and \"device\" means SDT periods at the device level will be excluded)  # noqa: E501

        :return: The metrics of this DeviceSLAWidget.  # noqa: E501
        :rtype: list[SlaMetric]
        """
        return self._metrics

    @metrics.setter
    def metrics(self, metrics):
        """Sets the metrics of this DeviceSLAWidget.

        The metrics (datapoints) that should be used to compute the SLA, where each service should include groupName (can be *), deviceName (can be *), dataSourceId or dataSourceFullName, instances (can be *), metric (datapoint), threshold, and exclusionSDTType (empty string means SDT periods will not be excluded, \"group\" means SDT periods at the device group level will be excluded, and \"device\" means SDT periods at the device level will be excluded)  # noqa: E501

        :param metrics: The metrics of this DeviceSLAWidget.  # noqa: E501
        :type: list[SlaMetric]
        """
        if metrics is None:
            raise ValueError("Invalid value for `metrics`, must not be `None`")  # noqa: E501

        self._metrics = metrics

    @property
    def unmonitored_time_type(self):
        """Gets the unmonitored_time_type of this DeviceSLAWidget.  # noqa: E501

        How no data should be treated: 0 = unmonitored time will be ignored & subtracted from the total possible time, 1 = unmonitored time will be subtracted from uptime and counted as a violation, 2 = unmonitored time will be added to uptime and counted as available  # noqa: E501

        :return: The unmonitored_time_type of this DeviceSLAWidget.  # noqa: E501
        :rtype: int
        """
        return self._unmonitored_time_type

    @unmonitored_time_type.setter
    def unmonitored_time_type(self, unmonitored_time_type):
        """Sets the unmonitored_time_type of this DeviceSLAWidget.

        How no data should be treated: 0 = unmonitored time will be ignored & subtracted from the total possible time, 1 = unmonitored time will be subtracted from uptime and counted as a violation, 2 = unmonitored time will be added to uptime and counted as available  # noqa: E501

        :param unmonitored_time_type: The unmonitored_time_type of this DeviceSLAWidget.  # noqa: E501
        :type: int
        """

        self._unmonitored_time_type = unmonitored_time_type

    @property
    def color_thresholds(self):
        """Gets the color_thresholds of this DeviceSLAWidget.  # noqa: E501

        The threshold of color changes  # noqa: E501

        :return: The color_thresholds of this DeviceSLAWidget.  # noqa: E501
        :rtype: list[ColorThreshold]
        """
        return self._color_thresholds

    @color_thresholds.setter
    def color_thresholds(self, color_thresholds):
        """Sets the color_thresholds of this DeviceSLAWidget.

        The threshold of color changes  # noqa: E501

        :param color_thresholds: The color_thresholds of this DeviceSLAWidget.  # noqa: E501
        :type: list[ColorThreshold]
        """

        self._color_thresholds = color_thresholds

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeviceSLAWidget, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeviceSLAWidget):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
