# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class MapModuleToAccessGroup(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'accessgroups': 'list[int]',
        'moduletype': 'str',
        'moduleid': 'int'
    }

    attribute_map = {
        'accessgroups': 'accessgroups',
        'moduletype': 'moduletype',
        'moduleid': 'moduleid'
    }

    def __init__(self, accessgroups=None, moduletype=None, moduleid=None):  # noqa: E501
        """MapModuleToAccessGroup - a model defined in Swagger"""  # noqa: E501
        self._accessgroups = None
        self._moduletype = None
        self._moduleid = None
        self.discriminator = None
        self.accessgroups = accessgroups
        self.moduletype = moduletype
        self.moduleid = moduleid

    @property
    def accessgroups(self):
        """Gets the accessgroups of this MapModuleToAccessGroup.  # noqa: E501

        Id's of the access group  # noqa: E501

        :return: The accessgroups of this MapModuleToAccessGroup.  # noqa: E501
        :rtype: list[int]
        """
        return self._accessgroups

    @accessgroups.setter
    def accessgroups(self, accessgroups):
        """Sets the accessgroups of this MapModuleToAccessGroup.

        Id's of the access group  # noqa: E501

        :param accessgroups: The accessgroups of this MapModuleToAccessGroup.  # noqa: E501
        :type: list[int]
        """
        if accessgroups is None:
            raise ValueError("Invalid value for `accessgroups`, must not be `None`")  # noqa: E501

        self._accessgroups = accessgroups

    @property
    def moduletype(self):
        """Gets the moduletype of this MapModuleToAccessGroup.  # noqa: E501

        Type of module  # noqa: E501

        :return: The moduletype of this MapModuleToAccessGroup.  # noqa: E501
        :rtype: str
        """
        return self._moduletype

    @moduletype.setter
    def moduletype(self, moduletype):
        """Sets the moduletype of this MapModuleToAccessGroup.

        Type of module  # noqa: E501

        :param moduletype: The moduletype of this MapModuleToAccessGroup.  # noqa: E501
        :type: str
        """
        if moduletype is None:
            raise ValueError("Invalid value for `moduletype`, must not be `None`")  # noqa: E501

        self._moduletype = moduletype

    @property
    def moduleid(self):
        """Gets the moduleid of this MapModuleToAccessGroup.  # noqa: E501

        Id of the logic module  # noqa: E501

        :return: The moduleid of this MapModuleToAccessGroup.  # noqa: E501
        :rtype: int
        """
        return self._moduleid

    @moduleid.setter
    def moduleid(self, moduleid):
        """Sets the moduleid of this MapModuleToAccessGroup.

        Id of the logic module  # noqa: E501

        :param moduleid: The moduleid of this MapModuleToAccessGroup.  # noqa: E501
        :type: int
        """
        if moduleid is None:
            raise ValueError("Invalid value for `moduleid`, must not be `None`")  # noqa: E501

        self._moduleid = moduleid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MapModuleToAccessGroup, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MapModuleToAccessGroup):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
