# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from logicmonitor_sdk.models.ops_note_scope import OpsNoteScope  # noqa: F401,E501

class OpsNoteWebsiteScope(OpsNoteScope):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'full_path': 'str',
        'website_name': 'str',
        'website_id': 'int',
        'group_id': 'int'
    }
    if hasattr(OpsNoteScope, "swagger_types"):
        swagger_types.update(OpsNoteScope.swagger_types)

    attribute_map = {
        'full_path': 'fullPath',
        'website_name': 'websiteName',
        'website_id': 'websiteId',
        'group_id': 'groupId'
    }
    if hasattr(OpsNoteScope, "attribute_map"):
        attribute_map.update(OpsNoteScope.attribute_map)

    def __init__(self, full_path=None, website_name=None, website_id=None, group_id=None, *args, **kwargs):  # noqa: E501
        """OpsNoteWebsiteScope - a model defined in Swagger"""  # noqa: E501
        self._full_path = None
        self._website_name = None
        self._website_id = None
        self._group_id = None
        self.discriminator = None
        if full_path is not None:
            self.full_path = full_path
        if website_name is not None:
            self.website_name = website_name
        if website_id is not None:
            self.website_id = website_id
        if group_id is not None:
            self.group_id = group_id
        OpsNoteScope.__init__(self, *args, **kwargs)

    @property
    def full_path(self):
        """Gets the full_path of this OpsNoteWebsiteScope.  # noqa: E501


        :return: The full_path of this OpsNoteWebsiteScope.  # noqa: E501
        :rtype: str
        """
        return self._full_path

    @full_path.setter
    def full_path(self, full_path):
        """Sets the full_path of this OpsNoteWebsiteScope.


        :param full_path: The full_path of this OpsNoteWebsiteScope.  # noqa: E501
        :type: str
        """

        self._full_path = full_path

    @property
    def website_name(self):
        """Gets the website_name of this OpsNoteWebsiteScope.  # noqa: E501


        :return: The website_name of this OpsNoteWebsiteScope.  # noqa: E501
        :rtype: str
        """
        return self._website_name

    @website_name.setter
    def website_name(self, website_name):
        """Sets the website_name of this OpsNoteWebsiteScope.


        :param website_name: The website_name of this OpsNoteWebsiteScope.  # noqa: E501
        :type: str
        """

        self._website_name = website_name

    @property
    def website_id(self):
        """Gets the website_id of this OpsNoteWebsiteScope.  # noqa: E501


        :return: The website_id of this OpsNoteWebsiteScope.  # noqa: E501
        :rtype: int
        """
        return self._website_id

    @website_id.setter
    def website_id(self, website_id):
        """Sets the website_id of this OpsNoteWebsiteScope.


        :param website_id: The website_id of this OpsNoteWebsiteScope.  # noqa: E501
        :type: int
        """

        self._website_id = website_id

    @property
    def group_id(self):
        """Gets the group_id of this OpsNoteWebsiteScope.  # noqa: E501


        :return: The group_id of this OpsNoteWebsiteScope.  # noqa: E501
        :rtype: int
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id):
        """Sets the group_id of this OpsNoteWebsiteScope.


        :param group_id: The group_id of this OpsNoteWebsiteScope.  # noqa: E501
        :type: int
        """

        self._group_id = group_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OpsNoteWebsiteScope, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OpsNoteWebsiteScope):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
