# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RestEventSourceFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'comment': 'str',
        'id': 'int',
        'value': 'str',
        'operator': 'str'
    }

    attribute_map = {
        'name': 'name',
        'comment': 'comment',
        'id': 'id',
        'value': 'value',
        'operator': 'operator'
    }

    def __init__(self, name=None, comment=None, id=None, value=None, operator=None):  # noqa: E501
        """RestEventSourceFilter - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._comment = None
        self._id = None
        self._value = None
        self._operator = None
        self.discriminator = None
        self.name = name
        self.comment = comment
        if id is not None:
            self.id = id
        self.value = value
        self.operator = operator

    @property
    def name(self):
        """Gets the name of this RestEventSourceFilter.  # noqa: E501

        The filter name  # noqa: E501

        :return: The name of this RestEventSourceFilter.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RestEventSourceFilter.

        The filter name  # noqa: E501

        :param name: The name of this RestEventSourceFilter.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def comment(self):
        """Gets the comment of this RestEventSourceFilter.  # noqa: E501

        The filter comment  # noqa: E501

        :return: The comment of this RestEventSourceFilter.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this RestEventSourceFilter.

        The filter comment  # noqa: E501

        :param comment: The comment of this RestEventSourceFilter.  # noqa: E501
        :type: str
        """
        if comment is None:
            raise ValueError("Invalid value for `comment`, must not be `None`")  # noqa: E501

        self._comment = comment

    @property
    def id(self):
        """Gets the id of this RestEventSourceFilter.  # noqa: E501

        The filter id  # noqa: E501

        :return: The id of this RestEventSourceFilter.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RestEventSourceFilter.

        The filter id  # noqa: E501

        :param id: The id of this RestEventSourceFilter.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def value(self):
        """Gets the value of this RestEventSourceFilter.  # noqa: E501

        The filter value  # noqa: E501

        :return: The value of this RestEventSourceFilter.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this RestEventSourceFilter.

        The filter value  # noqa: E501

        :param value: The value of this RestEventSourceFilter.  # noqa: E501
        :type: str
        """
        if value is None:
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    @property
    def operator(self):
        """Gets the operator of this RestEventSourceFilter.  # noqa: E501

        The filter operator  # noqa: E501

        :return: The operator of this RestEventSourceFilter.  # noqa: E501
        :rtype: str
        """
        return self._operator

    @operator.setter
    def operator(self, operator):
        """Sets the operator of this RestEventSourceFilter.

        The filter operator  # noqa: E501

        :param operator: The operator of this RestEventSourceFilter.  # noqa: E501
        :type: str
        """
        if operator is None:
            raise ValueError("Invalid value for `operator`, must not be `None`")  # noqa: E501

        self._operator = operator

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RestEventSourceFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RestEventSourceFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
