# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RestLogSourceResourceMappingV3(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'method': 'str',
        'index': 'str',
        'comment': 'str',
        'id': 'str',
        'value': 'str',
        'key': 'str'
    }

    attribute_map = {
        'method': 'method',
        'index': 'index',
        'comment': 'comment',
        'id': 'id',
        'value': 'value',
        'key': 'key'
    }

    def __init__(self, method=None, index=None, comment=None, id=None, value=None, key=None):  # noqa: E501
        """RestLogSourceResourceMappingV3 - a model defined in Swagger"""  # noqa: E501
        self._method = None
        self._index = None
        self._comment = None
        self._id = None
        self._value = None
        self._key = None
        self.discriminator = None
        if method is not None:
            self.method = method
        if index is not None:
            self.index = index
        if comment is not None:
            self.comment = comment
        if id is not None:
            self.id = id
        if value is not None:
            self.value = value
        if key is not None:
            self.key = key

    @property
    def method(self):
        """Gets the method of this RestLogSourceResourceMappingV3.  # noqa: E501

        The LogSourceResourceMapping method  # noqa: E501

        :return: The method of this RestLogSourceResourceMappingV3.  # noqa: E501
        :rtype: str
        """
        return self._method

    @method.setter
    def method(self, method):
        """Sets the method of this RestLogSourceResourceMappingV3.

        The LogSourceResourceMapping method  # noqa: E501

        :param method: The method of this RestLogSourceResourceMappingV3.  # noqa: E501
        :type: str
        """
        allowed_values = ["INVALID", "Invalid", "STATIC", "Static", "TOKEN", "Token", "REGEX", "Regex", "ATTRIBUTE", "Attribute", "REGEX_GROUP", "RegexGroup", "IP", "Ip", "FQDN", "HOSTNAME", "HostName", "HOST_WITHOUT_DNS", "HostWithoutDNS"]  # noqa: E501
        if method not in allowed_values:
            raise ValueError(
                "Invalid value for `method` ({0}), must be one of {1}"  # noqa: E501
                .format(method, allowed_values)
            )

        self._method = method

    @property
    def index(self):
        """Gets the index of this RestLogSourceResourceMappingV3.  # noqa: E501

        The LogSourceResourceMapping index  # noqa: E501

        :return: The index of this RestLogSourceResourceMappingV3.  # noqa: E501
        :rtype: str
        """
        return self._index

    @index.setter
    def index(self, index):
        """Sets the index of this RestLogSourceResourceMappingV3.

        The LogSourceResourceMapping index  # noqa: E501

        :param index: The index of this RestLogSourceResourceMappingV3.  # noqa: E501
        :type: str
        """

        self._index = index

    @property
    def comment(self):
        """Gets the comment of this RestLogSourceResourceMappingV3.  # noqa: E501

        The LogSourceResourceMapping comment  # noqa: E501

        :return: The comment of this RestLogSourceResourceMappingV3.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this RestLogSourceResourceMappingV3.

        The LogSourceResourceMapping comment  # noqa: E501

        :param comment: The comment of this RestLogSourceResourceMappingV3.  # noqa: E501
        :type: str
        """

        self._comment = comment

    @property
    def id(self):
        """Gets the id of this RestLogSourceResourceMappingV3.  # noqa: E501

        The LogSourceResourceMapping id  # noqa: E501

        :return: The id of this RestLogSourceResourceMappingV3.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RestLogSourceResourceMappingV3.

        The LogSourceResourceMapping id  # noqa: E501

        :param id: The id of this RestLogSourceResourceMappingV3.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def value(self):
        """Gets the value of this RestLogSourceResourceMappingV3.  # noqa: E501

        The LogSourceResourceMapping value  # noqa: E501

        :return: The value of this RestLogSourceResourceMappingV3.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this RestLogSourceResourceMappingV3.

        The LogSourceResourceMapping value  # noqa: E501

        :param value: The value of this RestLogSourceResourceMappingV3.  # noqa: E501
        :type: str
        """

        self._value = value

    @property
    def key(self):
        """Gets the key of this RestLogSourceResourceMappingV3.  # noqa: E501

        The LogSourceResourceMapping key  # noqa: E501

        :return: The key of this RestLogSourceResourceMappingV3.  # noqa: E501
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this RestLogSourceResourceMappingV3.

        The LogSourceResourceMapping key  # noqa: E501

        :param key: The key of this RestLogSourceResourceMappingV3.  # noqa: E501
        :type: str
        """

        self._key = key

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RestLogSourceResourceMappingV3, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RestLogSourceResourceMappingV3):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
