# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RestNMapNetscanPolicyCredential(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'device_group_id': 'int',
        'custom': 'list[dict(str, str)]',
        'device_group_name': 'str',
        'snmp_v3_credentials': 'list[dict(str, str)]',
        'device_id': 'int',
        'device_name': 'str'
    }

    attribute_map = {
        'device_group_id': 'deviceGroupId',
        'custom': 'custom',
        'device_group_name': 'deviceGroupName',
        'snmp_v3_credentials': 'snmpV3Credentials',
        'device_id': 'deviceId',
        'device_name': 'deviceName'
    }

    def __init__(self, device_group_id=None, custom=None, device_group_name=None, snmp_v3_credentials=None, device_id=None, device_name=None):  # noqa: E501
        """RestNMapNetscanPolicyCredential - a model defined in Swagger"""  # noqa: E501
        self._device_group_id = None
        self._custom = None
        self._device_group_name = None
        self._snmp_v3_credentials = None
        self._device_id = None
        self._device_name = None
        self.discriminator = None
        if device_group_id is not None:
            self.device_group_id = device_group_id
        if custom is not None:
            self.custom = custom
        if device_group_name is not None:
            self.device_group_name = device_group_name
        if snmp_v3_credentials is not None:
            self.snmp_v3_credentials = snmp_v3_credentials
        if device_id is not None:
            self.device_id = device_id
        if device_name is not None:
            self.device_name = device_name

    @property
    def device_group_id(self):
        """Gets the device_group_id of this RestNMapNetscanPolicyCredential.  # noqa: E501

        The ID of the device group that credentials should be inherited from, for this scan  # noqa: E501

        :return: The device_group_id of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :rtype: int
        """
        return self._device_group_id

    @device_group_id.setter
    def device_group_id(self, device_group_id):
        """Sets the device_group_id of this RestNMapNetscanPolicyCredential.

        The ID of the device group that credentials should be inherited from, for this scan  # noqa: E501

        :param device_group_id: The device_group_id of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :type: int
        """

        self._device_group_id = device_group_id

    @property
    def custom(self):
        """Gets the custom of this RestNMapNetscanPolicyCredential.  # noqa: E501

        Custom credentials that should be used for this scan  # noqa: E501

        :return: The custom of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :rtype: list[dict(str, str)]
        """
        return self._custom

    @custom.setter
    def custom(self, custom):
        """Sets the custom of this RestNMapNetscanPolicyCredential.

        Custom credentials that should be used for this scan  # noqa: E501

        :param custom: The custom of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :type: list[dict(str, str)]
        """

        self._custom = custom

    @property
    def device_group_name(self):
        """Gets the device_group_name of this RestNMapNetscanPolicyCredential.  # noqa: E501

        The name of the device group that credentials should be inherited from, for this scan  # noqa: E501

        :return: The device_group_name of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :rtype: str
        """
        return self._device_group_name

    @device_group_name.setter
    def device_group_name(self, device_group_name):
        """Sets the device_group_name of this RestNMapNetscanPolicyCredential.

        The name of the device group that credentials should be inherited from, for this scan  # noqa: E501

        :param device_group_name: The device_group_name of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :type: str
        """

        self._device_group_name = device_group_name

    @property
    def snmp_v3_credentials(self):
        """Gets the snmp_v3_credentials of this RestNMapNetscanPolicyCredential.  # noqa: E501

        Multiple snmpv3 properties that should be used for this scan  # noqa: E501

        :return: The snmp_v3_credentials of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :rtype: list[dict(str, str)]
        """
        return self._snmp_v3_credentials

    @snmp_v3_credentials.setter
    def snmp_v3_credentials(self, snmp_v3_credentials):
        """Sets the snmp_v3_credentials of this RestNMapNetscanPolicyCredential.

        Multiple snmpv3 properties that should be used for this scan  # noqa: E501

        :param snmp_v3_credentials: The snmp_v3_credentials of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :type: list[dict(str, str)]
        """

        self._snmp_v3_credentials = snmp_v3_credentials

    @property
    def device_id(self):
        """Gets the device_id of this RestNMapNetscanPolicyCredential.  # noqa: E501

        The ID of the device that credentials should be inherited from, for this scan  # noqa: E501

        :return: The device_id of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :rtype: int
        """
        return self._device_id

    @device_id.setter
    def device_id(self, device_id):
        """Sets the device_id of this RestNMapNetscanPolicyCredential.

        The ID of the device that credentials should be inherited from, for this scan  # noqa: E501

        :param device_id: The device_id of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :type: int
        """

        self._device_id = device_id

    @property
    def device_name(self):
        """Gets the device_name of this RestNMapNetscanPolicyCredential.  # noqa: E501

        The name of the device that credentials should be inherited from, for this scan  # noqa: E501

        :return: The device_name of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :rtype: str
        """
        return self._device_name

    @device_name.setter
    def device_name(self, device_name):
        """Sets the device_name of this RestNMapNetscanPolicyCredential.

        The name of the device that credentials should be inherited from, for this scan  # noqa: E501

        :param device_name: The device_name of this RestNMapNetscanPolicyCredential.  # noqa: E501
        :type: str
        """

        self._device_name = device_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RestNMapNetscanPolicyCredential, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RestNMapNetscanPolicyCredential):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
