# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SaasAccountTestResult(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'non_permission_apis_errors': 'list[str]',
        'invalid_status_urls': 'str',
        'no_permission_service': 'str',
        'result_code': 'int',
        'detail_link': 'str',
        'no_permission_apis': 'list[str]'
    }

    attribute_map = {
        'non_permission_apis_errors': 'nonPermissionApisErrors',
        'invalid_status_urls': 'invalidStatusUrls',
        'no_permission_service': 'noPermissionService',
        'result_code': 'resultCode',
        'detail_link': 'detailLink',
        'no_permission_apis': 'noPermissionApis'
    }

    def __init__(self, non_permission_apis_errors=None, invalid_status_urls=None, no_permission_service=None, result_code=None, detail_link=None, no_permission_apis=None):  # noqa: E501
        """SaasAccountTestResult - a model defined in Swagger"""  # noqa: E501
        self._non_permission_apis_errors = None
        self._invalid_status_urls = None
        self._no_permission_service = None
        self._result_code = None
        self._detail_link = None
        self._no_permission_apis = None
        self.discriminator = None
        if non_permission_apis_errors is not None:
            self.non_permission_apis_errors = non_permission_apis_errors
        if invalid_status_urls is not None:
            self.invalid_status_urls = invalid_status_urls
        if no_permission_service is not None:
            self.no_permission_service = no_permission_service
        if result_code is not None:
            self.result_code = result_code
        if detail_link is not None:
            self.detail_link = detail_link
        if no_permission_apis is not None:
            self.no_permission_apis = no_permission_apis

    @property
    def non_permission_apis_errors(self):
        """Gets the non_permission_apis_errors of this SaasAccountTestResult.  # noqa: E501


        :return: The non_permission_apis_errors of this SaasAccountTestResult.  # noqa: E501
        :rtype: list[str]
        """
        return self._non_permission_apis_errors

    @non_permission_apis_errors.setter
    def non_permission_apis_errors(self, non_permission_apis_errors):
        """Sets the non_permission_apis_errors of this SaasAccountTestResult.


        :param non_permission_apis_errors: The non_permission_apis_errors of this SaasAccountTestResult.  # noqa: E501
        :type: list[str]
        """

        self._non_permission_apis_errors = non_permission_apis_errors

    @property
    def invalid_status_urls(self):
        """Gets the invalid_status_urls of this SaasAccountTestResult.  # noqa: E501


        :return: The invalid_status_urls of this SaasAccountTestResult.  # noqa: E501
        :rtype: str
        """
        return self._invalid_status_urls

    @invalid_status_urls.setter
    def invalid_status_urls(self, invalid_status_urls):
        """Sets the invalid_status_urls of this SaasAccountTestResult.


        :param invalid_status_urls: The invalid_status_urls of this SaasAccountTestResult.  # noqa: E501
        :type: str
        """

        self._invalid_status_urls = invalid_status_urls

    @property
    def no_permission_service(self):
        """Gets the no_permission_service of this SaasAccountTestResult.  # noqa: E501


        :return: The no_permission_service of this SaasAccountTestResult.  # noqa: E501
        :rtype: str
        """
        return self._no_permission_service

    @no_permission_service.setter
    def no_permission_service(self, no_permission_service):
        """Sets the no_permission_service of this SaasAccountTestResult.


        :param no_permission_service: The no_permission_service of this SaasAccountTestResult.  # noqa: E501
        :type: str
        """

        self._no_permission_service = no_permission_service

    @property
    def result_code(self):
        """Gets the result_code of this SaasAccountTestResult.  # noqa: E501


        :return: The result_code of this SaasAccountTestResult.  # noqa: E501
        :rtype: int
        """
        return self._result_code

    @result_code.setter
    def result_code(self, result_code):
        """Sets the result_code of this SaasAccountTestResult.


        :param result_code: The result_code of this SaasAccountTestResult.  # noqa: E501
        :type: int
        """

        self._result_code = result_code

    @property
    def detail_link(self):
        """Gets the detail_link of this SaasAccountTestResult.  # noqa: E501


        :return: The detail_link of this SaasAccountTestResult.  # noqa: E501
        :rtype: str
        """
        return self._detail_link

    @detail_link.setter
    def detail_link(self, detail_link):
        """Sets the detail_link of this SaasAccountTestResult.


        :param detail_link: The detail_link of this SaasAccountTestResult.  # noqa: E501
        :type: str
        """

        self._detail_link = detail_link

    @property
    def no_permission_apis(self):
        """Gets the no_permission_apis of this SaasAccountTestResult.  # noqa: E501


        :return: The no_permission_apis of this SaasAccountTestResult.  # noqa: E501
        :rtype: list[str]
        """
        return self._no_permission_apis

    @no_permission_apis.setter
    def no_permission_apis(self, no_permission_apis):
        """Sets the no_permission_apis of this SaasAccountTestResult.


        :param no_permission_apis: The no_permission_apis of this SaasAccountTestResult.  # noqa: E501
        :type: list[str]
        """

        self._no_permission_apis = no_permission_apis

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SaasAccountTestResult, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SaasAccountTestResult):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
