# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>  # noqa: E501

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SeverityFilters(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'critical': 'bool',
        'warning': 'bool',
        '_none': 'bool',
        'error': 'bool'
    }

    attribute_map = {
        'critical': 'critical',
        'warning': 'warning',
        '_none': 'none',
        'error': 'error'
    }

    def __init__(self, critical=None, warning=None, _none=None, error=None):  # noqa: E501
        """SeverityFilters - a model defined in Swagger"""  # noqa: E501
        self._critical = None
        self._warning = None
        self.__none = None
        self._error = None
        self.discriminator = None
        if critical is not None:
            self.critical = critical
        if warning is not None:
            self.warning = warning
        if _none is not None:
            self._none = _none
        if error is not None:
            self.error = error

    @property
    def critical(self):
        """Gets the critical of this SeverityFilters.  # noqa: E501


        :return: The critical of this SeverityFilters.  # noqa: E501
        :rtype: bool
        """
        return self._critical

    @critical.setter
    def critical(self, critical):
        """Sets the critical of this SeverityFilters.


        :param critical: The critical of this SeverityFilters.  # noqa: E501
        :type: bool
        """

        self._critical = critical

    @property
    def warning(self):
        """Gets the warning of this SeverityFilters.  # noqa: E501


        :return: The warning of this SeverityFilters.  # noqa: E501
        :rtype: bool
        """
        return self._warning

    @warning.setter
    def warning(self, warning):
        """Sets the warning of this SeverityFilters.


        :param warning: The warning of this SeverityFilters.  # noqa: E501
        :type: bool
        """

        self._warning = warning

    @property
    def _none(self):
        """Gets the _none of this SeverityFilters.  # noqa: E501


        :return: The _none of this SeverityFilters.  # noqa: E501
        :rtype: bool
        """
        return self.__none

    @_none.setter
    def _none(self, _none):
        """Sets the _none of this SeverityFilters.


        :param _none: The _none of this SeverityFilters.  # noqa: E501
        :type: bool
        """

        self.__none = _none

    @property
    def error(self):
        """Gets the error of this SeverityFilters.  # noqa: E501


        :return: The error of this SeverityFilters.  # noqa: E501
        :rtype: bool
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this SeverityFilters.


        :param error: The error of this SeverityFilters.  # noqa: E501
        :type: bool
        """

        self._error = error

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SeverityFilters, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SeverityFilters):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
