# logicmonitor-sdk
LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically. <br> <br> Note: <ul> <li> For Python SDKs, the REQUEST parameters can contain camelCase or an underscore. </li> <li> Both underscore and camelCase are supported if parameters are encapsulated within the body. </li> <li> Only camelCase is supported if parameters are encapsulated within the body and also if the user is passing raw JSON as REQUEST parameter. However, the RESPONSE parameters always contain an underscore. For example, you can use testLocation or test_location in the REQUEST parameter. But the RESPONSE parameter will always be test_location. </li> <li> The fields parameter only supports camelCase. </li> </ul>

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 3.0.0
- Package version: 3.0.222
- Build package: io.swagger.codegen.v3.config.CodegenConfigurator$3

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import logicmonitor_sdk 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import logicmonitor_sdk
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import logicmonitor_sdk
from logicmonitor_sdk.rest import ApiException
from pprint import pprint

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.AlertAck() # AlertAck | 
id = 'id_example' # str | 

try:
    # ack alert by id
    api_response = api_instance.ack_alert_by_id(body, id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->ack_alert_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.AckCollectorDown() # AckCollectorDown | 

try:
    # ack collector down alert
    api_response = api_instance.ack_collector_down_alert_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->ack_collector_down_alert_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.AccessGroup() # AccessGroup |  (optional)

try:
    # Create a access group
    api_response = api_instance.add_access_group(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_access_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.Admin() # Admin | 

try:
    # add user
    api_response = api_instance.add_admin(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_admin: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.AlertAck() # AlertAck | 
id = 'id_example' # str | 

try:
    # add alert note
    api_response = api_instance.add_alert_note_by_id(body, id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_alert_note_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.AlertRule() # AlertRule | 

try:
    # add alert rule
    api_response = api_instance.add_alert_rule(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_alert_rule: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
admin_id = 56 # int | 
body = logicmonitor_sdk.APIToken() # APIToken | 
type = 'API Token' # str |  (optional) (default to API Token)

try:
    # add api tokens for a user
    api_response = api_instance.add_api_token_by_admin_id(admin_id, body, type=type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_api_token_by_admin_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.AppliesToFunction() # AppliesToFunction |  (optional)

try:
    # add applies to function
    api_response = api_instance.add_applies_to_function(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_applies_to_function: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.Collector() # Collector | 

try:
    # add collector
    api_response = api_instance.add_collector(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_collector: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.CollectorGroup() # CollectorGroup | 

try:
    # add collector group
    api_response = api_instance.add_collector_group(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_collector_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.ConfigSource() # ConfigSource |  (optional)

try:
    # add config source
    api_response = api_instance.add_config_source(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_config_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.Dashboard() # Dashboard | 

try:
    # add dashboard
    api_response = api_instance.add_dashboard(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_dashboard: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.DashboardGroup() # DashboardGroup | 

try:
    # add dashboard group
    api_response = api_instance.add_dashboard_group(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_dashboard_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.DashboardGroup() # DashboardGroup |  (optional)
recursive = true # bool |  (optional) (default to true)

try:
    # add dashboard group asynchronously
    api_response = api_instance.add_dashboard_group_asynchronously(id, body=body, recursive=recursive)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_dashboard_group_asynchronously: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.DataSource() # DataSource |  (optional)
create_graph = false # bool |  (optional) (default to false)

try:
    # add datasource
    api_response = api_instance.add_datasource_by_id(body=body, create_graph=create_graph)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_datasource_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.Device() # Device | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
add_from_wizard = false # bool |  (optional) (default to false)

try:
    # add a new device
    api_response = api_instance.add_device(body, start=start, end=end, netflow_filter=netflow_filter, add_from_wizard=add_from_wizard)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_device: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | The device-datasource ID
body = logicmonitor_sdk.DeviceDataSourceInstance() # DeviceDataSourceInstance | 

try:
    # add device instance 
    api_response = api_instance.add_device_datasource_instance(device_id, hds_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_device_datasource_instance: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
device_ds_id = 56 # int | The device-datasource ID you'd like to add an instance group for
body = logicmonitor_sdk.DeviceDataSourceInstanceGroup() # DeviceDataSourceInstanceGroup | 

try:
    # add device datasource instance group 
    api_response = api_instance.add_device_datasource_instance_group(device_id, device_ds_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_device_datasource_instance_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.DeviceGroup() # DeviceGroup | 

try:
    # add device group
    api_response = api_instance.add_device_group(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_device_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
body = logicmonitor_sdk.DeviceClusterAlertConfig() # DeviceClusterAlertConfig | 

try:
    # Add cluster alert configuration
    api_response = api_instance.add_device_group_cluster_alert_conf(device_group_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_device_group_cluster_alert_conf: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
gid = 56 # int | group ID
body = logicmonitor_sdk.EntityProperty() # EntityProperty | 

try:
    # add device group property
    api_response = api_instance.add_device_group_property(gid, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_device_group_property: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
body = logicmonitor_sdk.EntityProperty() # EntityProperty | 

try:
    # add device property
    api_response = api_instance.add_device_property(device_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_device_property: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.RestDNSMappingV3() # RestDNSMappingV3 |  (optional)

try:
    # Add dns mapping
    api_response = api_instance.add_dns_mapping(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_dns_mapping: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.EscalatingChain() # EscalatingChain | 

try:
    # add escalation chain
    api_response = api_instance.add_escalation_chain(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_escalation_chain: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.EventSource() # EventSource |  (optional)

try:
    # add eventSource
    api_response = api_instance.add_event_source(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_event_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.BatchJob() # BatchJob |  (optional)

try:
    # Add JobMonitor
    api_response = api_instance.add_job_monitor(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_job_monitor: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.LogSource() # LogSource |  (optional)

try:
    # add log source 
    api_response = api_instance.add_log_source(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_log_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.Netscan() # Netscan |  (optional)

try:
    # add a new netscan
    api_response = api_instance.add_netscan(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_netscan: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.RestOidV3() # RestOidV3 |  (optional)

try:
    # add a new OID
    api_response = api_instance.add_oid(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_oid: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.OpsNote() # OpsNote | 

try:
    # add opsnote
    api_response = api_instance.add_ops_note(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_ops_note: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.PropertyRule() # PropertyRule |  (optional)

try:
    # add a new property rule
    api_response = api_instance.add_property_rule(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_property_rule: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.RecipientGroup() # RecipientGroup | 

try:
    # add recipient group
    api_response = api_instance.add_recipient_group(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_recipient_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.ReportBase() # ReportBase | 

try:
    # add report
    api_response = api_instance.add_report(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_report: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.ReportGroup() # ReportGroup | 

try:
    # add report group
    api_response = api_instance.add_report_group(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_report_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.Role() # Role | 

try:
    # add role
    api_response = api_instance.add_role(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_role: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.SDT() # SDT | 

try:
    # add SDT (Response may contain extra fields depending upon the type of SDT being added)
    api_response = api_instance.add_sdt(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_sdt: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.TopologySource() # TopologySource |  (optional)

try:
    # Add TopologySource
    api_response = api_instance.add_topology_source(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_topology_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.Website() # Website | 

try:
    # add website
    api_response = api_instance.add_website(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_website: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.WebsiteGroup() # WebsiteGroup | 

try:
    # add website group
    api_response = api_instance.add_website_group(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_website_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.Widget() # Widget | 

try:
    # add widget (Based upon widget type the request and response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
    api_response = api_instance.add_widget(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->add_widget: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | 
instance_id = 56 # int | 

try:
    # collect a config for a device
    api_response = api_instance.collect_device_config_source_config(device_id, hds_id, instance_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->collect_device_config_source_config: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.LogPartition() # LogPartition |  (optional)

try:
    # Create a new log partition
    api_response = api_instance.create_log_partition(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->create_log_partition: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # Delete access group
    api_response = api_instance.delete_access_group(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_access_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete user
    api_response = api_instance.delete_admin_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_admin_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete alert rule
    api_response = api_instance.delete_alert_rule_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_alert_rule_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
admin_id = 56 # int | 
apitoken_id = 56 # int | 

try:
    # delete apiToken
    api_response = api_instance.delete_api_token_by_id(admin_id, apitoken_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_api_token_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
ignore_reference = false # bool |  (optional) (default to false)

try:
    # delete applies to function
    api_response = api_instance.delete_applies_to_function_by_id(id, ignore_reference=ignore_reference)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_applies_to_function_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete collector
    api_response = api_instance.delete_collector_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_collector_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete collector group
    api_response = api_instance.delete_collector_group_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_collector_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete config source by id
    api_response = api_instance.delete_config_source_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_config_source_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete dashboard
    api_response = api_instance.delete_dashboard_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_dashboard_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
allow_non_empty_group = false # bool |  (optional) (default to false)

try:
    # delete dashboard group
    api_response = api_instance.delete_dashboard_group_by_id(id, allow_non_empty_group=allow_non_empty_group)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_dashboard_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete datasource
    api_response = api_instance.delete_datasource_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_datasource_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
delete_hard = true # bool |  (optional) (default to true)

try:
    # delete a device
    api_response = api_instance.delete_device_by_id(id, start=start, end=end, netflow_filter=netflow_filter, delete_hard=delete_hard)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_device_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | The device-datasource ID
id = 56 # int | 

try:
    # delete a device instance
    api_response = api_instance.delete_device_datasource_instance_by_id(device_id, hds_id, id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_device_datasource_instance_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
delete_children = false # bool |  (optional) (default to false)
delete_hard = true # bool |  (optional) (default to true)

try:
    # delete device group
    api_response = api_instance.delete_device_group_by_id(id, delete_children=delete_children, delete_hard=delete_hard)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_device_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
id = 56 # int | 

try:
    # Delete cluster alert configuration
    api_response = api_instance.delete_device_group_cluster_alert_conf_by_id(device_group_id, id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_device_group_cluster_alert_conf_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
gid = 56 # int | group ID
name = 'name_example' # str | 

try:
    # delete device group property
    api_response = api_instance.delete_device_group_property_by_name(gid, name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_device_group_property_by_name: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
name = 'name_example' # str | 

try:
    # delete device property
    api_response = api_instance.delete_device_property_by_name(device_id, name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_device_property_by_name: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete escalation chain
    api_response = api_instance.delete_escalation_chain_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_escalation_chain_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete eventSource by id
    api_response = api_instance.delete_event_source_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_event_source_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # Delete JobMonitor
    api_response = api_instance.delete_job_monitor(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_job_monitor: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 

try:
    # Delete a log partition by ID
    api_response = api_instance.delete_log_partition_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_log_partition_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete log source 
    api_response = api_instance.delete_log_source(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_log_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete a netscan
    api_response = api_instance.delete_netscan_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_netscan_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete a OID
    api_response = api_instance.delete_oid(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_oid: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 

try:
    # delete opsnote
    api_response = api_instance.delete_ops_note_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_ops_note_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete a property rule
    api_response = api_instance.delete_property_rule(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_property_rule: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete recipient group
    api_response = api_instance.delete_recipient_group_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_recipient_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete report
    api_response = api_instance.delete_report_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_report_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete report group
    api_response = api_instance.delete_report_group_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_report_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete role
    api_response = api_instance.delete_role_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_role_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 

try:
    # delete SDT
    api_response = api_instance.delete_sdt_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_sdt_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # Delete TopologySource
    api_response = api_instance.delete_topology_source(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_topology_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete website
    api_response = api_instance.delete_website_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_website_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
delete_children = 0 # int |  (optional) (default to 0)

try:
    # delete website group
    api_response = api_instance.delete_website_group_by_id(id, delete_children=delete_children)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_website_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # delete widget
    api_response = api_instance.delete_widget_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->delete_widget_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.RestAzureSubscriptionsDiscoverV3() # RestAzureSubscriptionsDiscoverV3 | 

try:
    # view subscriptions
    api_response = api_instance.discover_subscriptions(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->discover_subscriptions: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 

try:
    # escalate alert by id
    api_response = api_instance.escalated_alert_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->escalated_alert_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.Debug() # Debug |  (optional)
collector_id = -1 # int |  (optional) (default to -1)

try:
    # Execute a Collector debug command
    api_response = api_instance.execute_debug_command(body=body, collector_id=collector_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->execute_debug_command: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.DeviceInstances() # DeviceInstances | 
period = 1.0 # float |  (optional) (default to 1.0)
start = 0 # int |  (optional) (default to 0)
end = 0 # int |  (optional) (default to 0)
aggregate = 'none' # str | the aggregate option (optional) (default to none)

try:
    # fetch device instances data
    api_response = api_instance.fetch_device_instances_data(body, period=period, start=start, end=end, aggregate=aggregate)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->fetch_device_instances_data: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
task_id = 'task_id_example' # str | 

try:
    # get report for task Id
    api_response = api_instance.fetch_report_using_task_id(id, task_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->fetch_report_using_task_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.GenerateReportRequest() # GenerateReportRequest |  (optional)

try:
    # run a report
    api_response = api_instance.generate_report_by_id(id, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->generate_report_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # Get access group by id
    api_response = api_instance.get_access_group_by_id(id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_access_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # Get access group list
    api_response = api_instance.get_access_group_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_access_group_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get user
    api_response = api_instance.get_admin_by_id(id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_admin_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
type = 'type_example' # str |  (optional)
permission = 'permission_example' # str |  (optional)
filter_group_string = 'filter_group_string_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get user list
    api_response = api_instance.get_admin_list(type=type, permission=permission, filter_group_string=filter_group_string, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_admin_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 
need_message = false # bool |  (optional) (default to false)
custom_columns = 'custom_columns_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)

try:
    # get alert
    api_response = api_instance.get_alert_by_id(id, need_message=need_message, custom_columns=custom_columns, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_alert_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get alert list
    api_response = api_instance.get_alert_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_alert_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
need_message = false # bool |  (optional) (default to false)
custom_columns = 'custom_columns_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device group alerts
    api_response = api_instance.get_alert_list_by_device_group_id(id, need_message=need_message, custom_columns=custom_columns, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_alert_list_by_device_group_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
need_message = false # bool |  (optional) (default to false)
custom_columns = 'custom_columns_example' # str |  (optional)
bound = 'instances' # str |  (optional) (default to instances)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get alerts
    api_response = api_instance.get_alert_list_by_device_id(id, start=start, end=end, netflow_filter=netflow_filter, need_message=need_message, custom_columns=custom_columns, bound=bound, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_alert_list_by_device_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get alert rule by id
    api_response = api_instance.get_alert_rule_by_id(id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_alert_rule_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get alert rule list
    api_response = api_instance.get_alert_rule_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_alert_rule_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))

try:
    # Retrieve a list of all log partitions
    api_response = api_instance.get_all_log_partitions()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_all_log_partitions: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get SDTs for a device
    api_response = api_instance.get_all_sdt_list_by_device_id(id, start=start, end=end, netflow_filter=netflow_filter, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_all_sdt_list_by_device_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get a list of SDTs for a website group (Response may contain extra fields depending upon the type of SDT)
    api_response = api_instance.get_all_sdt_list_by_website_group_id(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_all_sdt_list_by_website_group_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
type = 'type_example' # str |  (optional)
permission = 'permission_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get a list of api tokens across users
    api_response = api_instance.get_api_token_list(type=type, permission=permission, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_api_token_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
admin_id = 56 # int | 
type = 'type_example' # str |  (optional)
permission = 'permission_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get api tokens for a user
    api_response = api_instance.get_api_token_list_by_admin_id(admin_id, type=type, permission=permission, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_api_token_list_by_admin_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # get applies to function
    api_response = api_instance.get_applies_to_function_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_applies_to_function_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get applies to function list
    api_response = api_instance.get_applies_to_function_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_applies_to_function_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get devices associated with a datasource
    api_response = api_instance.get_associated_device_list_by_data_source_id(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_associated_device_list_by_data_source_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 

try:
    # Get audit log by id
    api_response = api_instance.get_audit_log_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_audit_log_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
format = 'format_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # Get audit logs
    api_response = api_instance.get_audit_log_list(format=format, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_audit_log_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))

try:
    # Get AWS account ID
    api_response = api_instance.get_aws_account_id()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_aws_account_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))

try:
    # Get AWS external ID
    api_response = api_instance.get_aws_external_id()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_aws_external_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get collector
    api_response = api_instance.get_collector_by_id(id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_collector_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get collector group
    api_response = api_instance.get_collector_group_by_id(id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_collector_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get collector group list
    api_response = api_instance.get_collector_group_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_collector_group_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
collector_id = 56 # int | 
os_and_arch = 'os_and_arch_example' # str | 
collector_version = 56 # int | The version of the installer you'd like to download. This defaults to the latest GD Collector, unless useEA is true (optional)
token = 'token_example' # str |  (optional)
monitor_others = true # bool |  (optional) (default to true)
collector_size = 'medium' # str | The size of the Collector you'd like to install. Options are nano, small (requires 2GB memory), medium (requires 4GB memory), large (requires 8GB memory), extra large (requires 16GB memory), double extra large (requires 32GB memory). Requires collector version 22.180 or higher. Defaults to small (optional) (default to medium)
use_ea = false # bool | If true, the latest EA Collector version will be used. Defaults to false (optional) (default to false)

try:
    # get collector installer
    api_response = api_instance.get_collector_installer(collector_id, os_and_arch, collector_version=collector_version, token=token, monitor_others=monitor_others, collector_size=collector_size, use_ea=use_ea)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_collector_installer: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get collector list
    api_response = api_instance.get_collector_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_collector_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get collector version list
    api_response = api_instance.get_collector_version_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_collector_version_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
format = 'json' # str |  (optional) (default to json)

try:
    # get config source by id
    api_response = api_instance.get_config_source_by_id(id, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_config_source_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
format = 'json' # str |  (optional) (default to json)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get config source list
    api_response = api_instance.get_config_source_list(format=format, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_config_source_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))

try:
    # get contract info by company
    api_response = api_instance.get_contract_info_by_company()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_contract_info_by_company: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
template = false # bool |  (optional) (default to false)
format = 'json' # str |  (optional) (default to json)
fields = 'fields_example' # str |  (optional)

try:
    # get dashboard
    api_response = api_instance.get_dashboard_by_id(id, template=template, format=format, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_dashboard_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
template = false # bool |  (optional) (default to false)
format = 'json' # str |  (optional) (default to json)
fields = 'fields_example' # str |  (optional)

try:
    # get dashboard group
    api_response = api_instance.get_dashboard_group_by_id(id, template=template, format=format, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_dashboard_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get dashboard group list
    api_response = api_instance.get_dashboard_group_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_dashboard_group_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get dashboard list
    api_response = api_instance.get_dashboard_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_dashboard_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
ds_id = 56 # int | 
id = 56 # int | 

try:
    # get datasource overview graph by id
    api_response = api_instance.get_data_source_overview_graph_by_id(ds_id, id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_data_source_overview_graph_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
ds_id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get datasource overview graph list
    api_response = api_instance.get_data_source_overview_graph_list(ds_id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_data_source_overview_graph_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
format = 'json' # str |  (optional) (default to json)
fields = 'fields_example' # str |  (optional)

try:
    # get datasource by id
    api_response = api_instance.get_datasource_by_id(id, format=format, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_datasource_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
format = 'json' # str |  (optional) (default to json)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get datasource list
    api_response = api_instance.get_datasource_list(format=format, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_datasource_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 
collector_id = -1 # int |  (optional) (default to -1)

try:
    # Get the result of a Collector debug command using sessionId
    api_response = api_instance.get_debug_command_result(id, collector_id=collector_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_debug_command_result: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
delta_id = 'delta_id_example' # str | 

try:
    # Get delta devices using deltaId
    api_response = api_instance.get_delta_devices(delta_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_delta_devices: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
delta_id = 'delta_id_example' # str |  (optional)

try:
    # Get filter matched devices with new deltaId
    api_response = api_instance.get_delta_id_with_devices(delta_id=delta_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_delta_id_with_devices: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)

try:
    # get device by id
    api_response = api_instance.get_device_by_id(id, start=start, end=end, netflow_filter=netflow_filter, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | 
instance_id = 56 # int | 
id = 'id_example' # str | 
format = 'json' # str |  (optional) (default to json)
start_epoch = 0 # int |  (optional) (default to 0)
fields = 'fields_example' # str |  (optional)

try:
    # get a config for a device
    api_response = api_instance.get_device_config_source_config_by_id(device_id, hds_id, instance_id, id, format=format, start_epoch=start_epoch, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_config_source_config_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | 
instance_id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get detailed config information for the instance
    api_response = api_instance.get_device_config_source_config_list(device_id, hds_id, instance_id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_config_source_config_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get device datasource 
    api_response = api_instance.get_device_datasource_by_id(device_id, id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
id = 56 # int | 
period = 1.0 # float |  (optional) (default to 1.0)
start = 0 # int |  (optional) (default to 0)
end = 0 # int |  (optional) (default to 0)
datapoints = 'datapoints_example' # str |  (optional)
format = 'json' # str |  (optional) (default to json)
aggregate = 'none' # str | the aggregate option (optional) (default to none)

try:
    # get device datasource data 
    api_response = api_instance.get_device_datasource_data_by_id(device_id, id, period=period, start=start, end=end, datapoints=datapoints, format=format, aggregate=aggregate)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_data_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | Device-DataSource ID
instance_id = 56 # int | 
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get device instance alert setting
    api_response = api_instance.get_device_datasource_instance_alert_setting_by_id(device_id, hds_id, instance_id, id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_instance_alert_setting_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)

try:
    # get a list of alert settings for a device
    api_response = api_instance.get_device_datasource_instance_alert_setting_list_of_device(device_id, start=start, end=end, netflow_filter=netflow_filter, size=size, offset=offset)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_instance_alert_setting_list_of_device: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | Device-DataSource ID
instance_id = 56 # int | 
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)

try:
    # get a list of alert settings for a device datasource instance
    api_response = api_instance.get_device_datasource_instance_alert_setting_list_of_dsi(device_id, hds_id, instance_id, size=size, offset=offset)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_instance_alert_setting_list_of_dsi: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | The device-datasource ID
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get device instance 
    api_response = api_instance.get_device_datasource_instance_by_id(device_id, hds_id, id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_instance_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | The device-datasource ID
id = 56 # int | 
period = 1.0 # float |  (optional) (default to 1.0)
start = 0 # int |  (optional) (default to 0)
end = 0 # int |  (optional) (default to 0)
datapoints = 'datapoints_example' # str |  (optional)
format = 'json' # str |  (optional) (default to json)

try:
    # get device instance data
    api_response = api_instance.get_device_datasource_instance_data(device_id, hds_id, id, period=period, start=start, end=end, datapoints=datapoints, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_instance_data: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | The device-datasource ID
id = 56 # int | 
graph_id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
format = 'format_example' # str |  (optional)

try:
    # get device instance graph data 
    api_response = api_instance.get_device_datasource_instance_graph_data(device_id, hds_id, id, graph_id, start=start, end=end, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_instance_graph_data: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
device_ds_id = 56 # int | The device-datasource ID you'd like to add an instance group for
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get device datasource instance group 
    api_response = api_instance.get_device_datasource_instance_group_by_id(device_id, device_ds_id, id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_instance_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
device_ds_id = 56 # int | The device-datasource ID you'd like to add an instance group for
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device datasource instance group list 
    api_response = api_instance.get_device_datasource_instance_group_list(device_id, device_ds_id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_instance_group_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
device_ds_id = 56 # int | The device-datasource ID you'd like to add an instance group for
dsig_id = 56 # int | 
ograph_id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
format = 'format_example' # str |  (optional)

try:
    # get device instance group overview graph data 
    api_response = api_instance.get_device_datasource_instance_group_overview_graph_data(device_id, device_ds_id, dsig_id, ograph_id, start=start, end=end, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_instance_group_overview_graph_data: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | The device-datasource ID
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device instance list
    api_response = api_instance.get_device_datasource_instance_list(device_id, hds_id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_instance_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | The device-datasource ID
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device instance SDT history
    api_response = api_instance.get_device_datasource_instance_sdt_history(device_id, hds_id, id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_instance_sdt_history: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device datasource list 
    api_response = api_instance.get_device_datasource_list(device_id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_datasource_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get device group
    api_response = api_instance.get_device_group_by_id(id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
id = 56 # int | 

try:
    # Get cluster alert configuration by id
    api_response = api_instance.get_device_group_cluster_alert_conf_by_id(device_group_id, id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_group_cluster_alert_conf_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get a list of cluster alert configurations for a device group
    api_response = api_instance.get_device_group_cluster_alert_conf_list(device_group_id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_group_cluster_alert_conf_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
ds_id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get device group datasource alert setting 
    api_response = api_instance.get_device_group_datasource_alert_setting(device_group_id, ds_id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_group_datasource_alert_setting: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get device group datasource
    api_response = api_instance.get_device_group_datasource_by_id(device_group_id, id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_group_datasource_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
include_disabled_data_source_without_instance = false # bool |  (optional) (default to false)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device group datasource list
    api_response = api_instance.get_device_group_datasource_list(device_group_id, include_disabled_data_source_without_instance=include_disabled_data_source_without_instance, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_group_datasource_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device group list
    api_response = api_instance.get_device_group_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_group_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
gid = 56 # int | group ID
name = 'name_example' # str | 
fields = 'fields_example' # str |  (optional)

try:
    # get device group property by name
    api_response = api_instance.get_device_group_property_by_name(gid, name, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_group_property_by_name: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
gid = 56 # int | group ID
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device group properties
    api_response = api_instance.get_device_group_property_list(gid, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_group_property_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device group SDTs
    api_response = api_instance.get_device_group_sdt_list(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_group_sdt_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
instance_id = 56 # int | 
graph_id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
format = 'format_example' # str |  (optional)

try:
    # get device instance data
    api_response = api_instance.get_device_instance_graph_data_only_by_instance_id(instance_id, graph_id, start=start, end=end, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_instance_graph_data_only_by_instance_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device instance list
    api_response = api_instance.get_device_instance_list(id, start=start, end=end, netflow_filter=netflow_filter, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_instance_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
include_deleted_resources = false # bool |  (optional) (default to false)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device list
    api_response = api_instance.get_device_list(start=start, end=end, netflow_filter=netflow_filter, include_deleted_resources=include_deleted_resources, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
name = 'name_example' # str | 
fields = 'fields_example' # str |  (optional)

try:
    # get device property by name
    api_response = api_instance.get_device_property_by_name(device_id, name, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_property_by_name: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get device properties
    api_response = api_instance.get_device_property_list(device_id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_device_property_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get escalation chain by id
    api_response = api_instance.get_escalation_chain_by_id(id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_escalation_chain_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get escalation chain list
    api_response = api_instance.get_escalation_chain_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_escalation_chain_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
format = 'json' # str |  (optional) (default to json)

try:
    # get eventSource by id
    api_response = api_instance.get_event_source_by_id(id, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_event_source_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
format = 'json' # str |  (optional) (default to json)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get eventSource list
    api_response = api_instance.get_event_source_list(format=format, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_event_source_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))

try:
    # get external api stats info
    api_response = api_instance.get_external_api_stats()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_external_api_stats: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get immediate devices under group
    api_response = api_instance.get_immediate_device_list_by_device_group_id(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_immediate_device_list_by_device_group_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get a list of websites for a group (Response may contain extra fields depending upon the type of check { PingCheck | WebCheck} being added)
    api_response = api_instance.get_immediate_website_list_by_website_group_id(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_immediate_website_list_by_website_group_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
format = 'format_example' # str |  (optional)

try:
    # get integration audit logs list
    api_response = api_instance.get_integration_audit_logs(format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_integration_audit_logs: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
format = 'json' # str |  (optional) (default to json)

try:
    # Get JobMonitor by id
    api_response = api_instance.get_job_monitor_by_id(id, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_job_monitor_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
format = 'json' # str |  (optional) (default to json)

try:
    # Get JobMonitor List
    api_response = api_instance.get_job_monitor_list(format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_job_monitor_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 
format = 'json' # str |  (optional) (default to json)

try:
    # get log source 
    api_response = api_instance.get_log_source_by_id(id, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_log_source_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
format = 'json' # str |  (optional) (default to json)

try:
    # get log source list
    api_response = api_instance.get_log_source_list(format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_log_source_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))

try:
    # get metrics usage
    api_response = api_instance.get_metrics_usage()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_metrics_usage: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
port = 'port_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get netflow endpoints
    api_response = api_instance.get_netflow_endpoint_list(id, start=start, end=end, netflow_filter=netflow_filter, port=port, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_netflow_endpoint_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get netflow flows
    api_response = api_instance.get_netflow_flow_list(id, start=start, end=end, netflow_filter=netflow_filter, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_netflow_flow_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
ip = 'ip_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get netflow ports
    api_response = api_instance.get_netflow_port_list(id, start=start, end=end, netflow_filter=netflow_filter, ip=ip, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_netflow_port_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # get netscan by id
    api_response = api_instance.get_netscan_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_netscan_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get netscan list
    api_response = api_instance.get_netscan_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_netscan_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # get OID by id
    api_response = api_instance.get_oid_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_oid_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))

try:
    # get OID's list
    api_response = api_instance.get_oid_list()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_oid_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 
fields = 'fields_example' # str |  (optional)

try:
    # get opsnote by id
    api_response = api_instance.get_ops_note_by_id(id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_ops_note_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str | Filter the response based on tags, createdBy, happenedOn, monitorObjectGroups, monitorObjectNames, or _all field values (optional)

try:
    # get opsnote list
    api_response = api_instance.get_ops_note_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_ops_note_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 

try:
    # Retrieve details of a specific log partition
    api_response = api_instance.get_partition_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_partition_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
format = 'json' # str |  (optional) (default to json)

try:
    # get property rules by id
    api_response = api_instance.get_property_rules_by_id(id, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_property_rules_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
format = 'json' # str |  (optional) (default to json)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get property rules list
    api_response = api_instance.get_property_rules_list(format=format, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_property_rules_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # get recipient group by id
    api_response = api_instance.get_recipient_group_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_recipient_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get recipient group List
    api_response = api_instance.get_recipient_group_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_recipient_group_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get report by id
    api_response = api_instance.get_report_by_id(id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_report_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # get report group by id
    api_response = api_instance.get_report_group_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_report_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get report group list
    api_response = api_instance.get_report_group_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_report_group_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get report list
    api_response = api_instance.get_report_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_report_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))

try:
    # Retrieve the list of log retentions
    api_response = api_instance.get_retention_list()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_retention_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get role by id
    api_response = api_instance.get_role_by_id(id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_role_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
exclude_admin = false # bool |  (optional) (default to false)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get role list
    api_response = api_instance.get_role_list(exclude_admin=exclude_admin, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_role_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 

try:
    # get SDT by id (Response may contain extra fields depending upon the type of SDT of given id)
    api_response = api_instance.get_sdt_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_sdt_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get SDT history for the device dataSource
    api_response = api_instance.get_sdt_history_by_device_data_source_id(device_id, id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_sdt_history_by_device_data_source_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get SDT history for the group
    api_response = api_instance.get_sdt_history_by_device_group_id(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_sdt_history_by_device_group_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get SDT history for the device
    api_response = api_instance.get_sdt_history_by_device_id(id, start=start, end=end, netflow_filter=netflow_filter, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_sdt_history_by_device_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get SDT history for the website group (Response may contain extra fields depending upon the type of SDT)
    api_response = api_instance.get_sdt_history_by_website_group_id(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_sdt_history_by_website_group_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get SDT history for the website (Response may contain extra fields depending upon the type of SDT)
    api_response = api_instance.get_sdt_history_by_website_id(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_sdt_history_by_website_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get SDT list
    api_response = api_instance.get_sdt_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_sdt_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get website checkpoint list
    api_response = api_instance.get_site_monitor_check_point_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_site_monitor_check_point_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
format = 'format_example' # str |  (optional)
keyword = 'keyword_example' # str |  (optional)

try:
    # get top talkers graph
    api_response = api_instance.get_top_talkers_graph(id, start=start, end=end, netflow_filter=netflow_filter, format=format, keyword=keyword)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_top_talkers_graph: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
format = 'json' # str |  (optional) (default to json)

try:
    # Get TopologySource by id
    api_response = api_instance.get_topology_source_by_id(id, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_topology_source_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))

try:
    # Get TopologySource List
    api_response = api_instance.get_topology_source_list()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_topology_source_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get unmonitored device list
    api_response = api_instance.get_unmonitored_device_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_unmonitored_device_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # get update history for a configSource
    api_response = api_instance.get_update_reason_list_by_config_source_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_update_reason_list_by_config_source_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get update history for a datasource
    api_response = api_instance.get_update_reason_list_by_data_source_id(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_update_reason_list_by_data_source_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))

try:
    # get metadata
    api_response = api_instance.get_v4_metadata()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_v4_metadata: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
need_message = false # bool |  (optional) (default to false)
custom_columns = 'custom_columns_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get alerts for a website
    api_response = api_instance.get_website_alert_list_by_website_id(id, need_message=need_message, custom_columns=custom_columns, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_website_alert_list_by_website_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
format = 'json' # str |  (optional) (default to json)

try:
    # get website by id
    api_response = api_instance.get_website_by_id(id, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_website_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
srv_id = 56 # int | 
check_id = 56 # int | 
period = 1.0 # float |  (optional) (default to 1.0)
start = 0 # int |  (optional) (default to 0)
end = 0 # int |  (optional) (default to 0)
datapoints = 'datapoints_example' # str |  (optional)
format = 'json' # str |  (optional) (default to json)
aggregate = 'none' # str | the aggregate option (optional) (default to none)

try:
    # get data for a website checkpoint
    api_response = api_instance.get_website_checkpoint_data_by_id(srv_id, check_id, period=period, start=start, end=end, datapoints=datapoints, format=format, aggregate=aggregate)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_website_checkpoint_data_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
graph_name = 'graph_name_example' # str | 
start = 0 # int |  (optional) (default to 0)
end = 0 # int |  (optional) (default to 0)
format = 'format_example' # str |  (optional)

try:
    # get website data by graph name
    api_response = api_instance.get_website_data_by_graph_name(id, graph_name, start=start, end=end, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_website_data_by_graph_name: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
website_id = 56 # int | 
checkpoint_id = 56 # int | 
graph_name = 'graph_name_example' # str | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
format = 'format_example' # str |  (optional)

try:
    # get website graph data
    api_response = api_instance.get_website_graph_data(website_id, checkpoint_id, graph_name, start=start, end=end, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_website_graph_data: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 

try:
    # get website group
    api_response = api_instance.get_website_group_by_id(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_website_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get website group list
    api_response = api_instance.get_website_group_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_website_group_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
collector_ids = 'collector_ids_example' # str |  (optional)
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get website list
    api_response = api_instance.get_website_list(collector_ids=collector_ids, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_website_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get a list of properties for a website
    api_response = api_instance.get_website_property_list_by_website_id(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_website_property_list_by_website_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get a list of SDTs for a website
    api_response = api_instance.get_website_sdt_list_by_website_id(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_website_sdt_list_by_website_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)

try:
    # get widget by id (Based upon widget type the response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
    api_response = api_instance.get_widget_by_id(id, fields=fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_widget_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
format = 'format_example' # str |  (optional)

try:
    # get widget data (Based upon widget type the response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
    api_response = api_instance.get_widget_data_by_id(id, start=start, end=end, format=format)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_widget_data_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get widget list (Based upon widget type the response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
    api_response = api_instance.get_widget_list(fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_widget_list: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
fields = 'fields_example' # str |  (optional)
size = 50 # int |  (optional) (default to 50)
offset = 0 # int |  (optional) (default to 0)
filter = 'filter_example' # str |  (optional)

try:
    # get widget list by DashboardId
    api_response = api_instance.get_widget_list_by_dashboard_id(id, fields=fields, size=size, offset=offset, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->get_widget_list_by_dashboard_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
file = 'file_example' # str | 

try:
    # import batch job via xml
    api_response = api_instance.import_batch_job(file)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->import_batch_job: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
file = 'file_example' # str | 

try:
    # import config source via xml
    api_response = api_instance.import_config_source(file)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->import_config_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
file = 'file_example' # str | 

try:
    # import datasource via xml
    api_response = api_instance.import_data_source(file)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->import_data_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
file = 'file_example' # str | 

try:
    # import eventsource via xml
    api_response = api_instance.import_event_source(file)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->import_event_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.RestMapModuleV3() # RestMapModuleV3 |  (optional)

try:
    # Create a mapping of access group & module
    api_response = api_instance.map_un_map_module_to_access_group(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->map_un_map_module_to_access_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 
action = 'action_example' # str | 

try:
    # Perform an action on a specified log partition
    api_response = api_instance.partition_action(id, action)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->partition_action: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.AccessGroup() # AccessGroup | 

try:
    # Update access group
    api_response = api_instance.patch_access_group(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_access_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Admin() # Admin | 
change_password = false # bool |  (optional) (default to false)
validation_only = false # bool |  (optional) (default to false)

try:
    # update user
    api_response = api_instance.patch_admin_by_id(id, body, change_password=change_password, validation_only=validation_only)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_admin_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.AlertRule() # AlertRule | 

try:
    # update alert rule
    api_response = api_instance.patch_alert_rule_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_alert_rule_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
admin_id = 56 # int | 
apitoken_id = 56 # int | 
body = logicmonitor_sdk.APIToken() # APIToken | 

try:
    # update api tokens for a user
    api_response = api_instance.patch_api_token_by_admin_id(admin_id, apitoken_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_api_token_by_admin_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.AppliesToFunction() # AppliesToFunction |  (optional)
reason = 'reason_example' # str |  (optional)
ignore_reference = false # bool |  (optional) (default to false)

try:
    # update applies to function
    api_response = api_instance.patch_applies_to_function(id, body=body, reason=reason, ignore_reference=ignore_reference)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_applies_to_function: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Collector() # Collector | 
auto_balance_monitored_devices = false # bool |  (optional) (default to false)
force_update_failed_over_devices = false # bool |  (optional) (default to false)
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update collector
    api_response = api_instance.patch_collector_by_id(id, body, auto_balance_monitored_devices=auto_balance_monitored_devices, force_update_failed_over_devices=force_update_failed_over_devices, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_collector_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.CollectorGroup() # CollectorGroup | 
auto_balance_monitored_devices = false # bool |  (optional) (default to false)
force_update_failed_over_devices = false # bool |  (optional) (default to false)
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update collector group
    api_response = api_instance.patch_collector_group_by_id(id, body, auto_balance_monitored_devices=auto_balance_monitored_devices, force_update_failed_over_devices=force_update_failed_over_devices, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_collector_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.ConfigSource() # ConfigSource |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # update config source by id
    api_response = api_instance.patch_config_source_by_id(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_config_source_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Dashboard() # Dashboard | 
overwrite_group_fields = false # bool |  (optional) (default to false)

try:
    # update dashboard
    api_response = api_instance.patch_dashboard_by_id(id, body, overwrite_group_fields=overwrite_group_fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_dashboard_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.DashboardGroup() # DashboardGroup | 

try:
    # update dashboard group
    api_response = api_instance.patch_dashboard_group_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_dashboard_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.DataSource() # DataSource |  (optional)
reason = 'reason_example' # str |  (optional)
force_unique_identifier = false # bool |  (optional) (default to false)
force_restricted_change_key = 'force_restricted_change_key_example' # str |  (optional)

try:
    # update datasource
    api_response = api_instance.patch_datasource_by_id(id, body=body, reason=reason, force_unique_identifier=force_unique_identifier, force_restricted_change_key=force_restricted_change_key)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_datasource_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 
body = logicmonitor_sdk.RestUserCustomizedDataV3() # RestUserCustomizedDataV3 |  (optional)

try:
    # update default dashboard
    api_response = api_instance.patch_default_dashboard(id, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_default_dashboard: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Device() # Device | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update a device
    api_response = api_instance.patch_device(id, body, start=start, end=end, netflow_filter=netflow_filter, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_device: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | Device-DataSource ID
instance_id = 56 # int | 
id = 56 # int | 
body = logicmonitor_sdk.DeviceDataSourceInstanceAlertSetting() # DeviceDataSourceInstanceAlertSetting | 

try:
    # update device instance alert setting
    api_response = api_instance.patch_device_datasource_instance_alert_setting_by_id(device_id, hds_id, instance_id, id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_device_datasource_instance_alert_setting_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | The device-datasource ID
id = 56 # int | 
body = logicmonitor_sdk.DeviceDataSourceInstance() # DeviceDataSourceInstance | 
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update device instance
    api_response = api_instance.patch_device_datasource_instance_by_id(device_id, hds_id, id, body, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_device_datasource_instance_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
device_ds_id = 56 # int | The device-datasource ID you'd like to add an instance group for
id = 56 # int | 
body = logicmonitor_sdk.DeviceDataSourceInstanceGroup() # DeviceDataSourceInstanceGroup | 

try:
    # update device datasource instance group
    api_response = api_instance.patch_device_datasource_instance_group_by_id(device_id, device_ds_id, id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_device_datasource_instance_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.DeviceGroup() # DeviceGroup | 
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update device group
    api_response = api_instance.patch_device_group_by_id(id, body, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_device_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
id = 56 # int | 
body = logicmonitor_sdk.DeviceClusterAlertConfig() # DeviceClusterAlertConfig | 

try:
    # Update cluster alert configuration
    api_response = api_instance.patch_device_group_cluster_alert_conf_by_id(device_group_id, id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_device_group_cluster_alert_conf_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
ds_id = 56 # int | 
body = logicmonitor_sdk.DeviceGroupDataSourceAlertConfig() # DeviceGroupDataSourceAlertConfig | 

try:
    # update device group datasource alert setting
    api_response = api_instance.patch_device_group_datasource_alert_setting(device_group_id, ds_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_device_group_datasource_alert_setting: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
id = 56 # int | 
body = logicmonitor_sdk.DeviceGroupDataSource() # DeviceGroupDataSource |  (optional)

try:
    # update device group datasource
    api_response = api_instance.patch_device_group_datasource_by_id(device_group_id, id, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_device_group_datasource_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
gid = 56 # int | group ID
name = 'name_example' # str | 
body = logicmonitor_sdk.EntityProperty() # EntityProperty | 

try:
    # update device group property
    api_response = api_instance.patch_device_group_property_by_name(gid, name, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_device_group_property_by_name: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
name = 'name_example' # str | 
body = logicmonitor_sdk.EntityProperty() # EntityProperty | 

try:
    # update device property
    api_response = api_instance.patch_device_property_by_name(device_id, name, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_device_property_by_name: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.EscalatingChain() # EscalatingChain | 

try:
    # update escalation chain
    api_response = api_instance.patch_escalation_chain_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_escalation_chain_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.EventSource() # EventSource |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # update eventSource by id
    api_response = api_instance.patch_event_source_by_id(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_event_source_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.BatchJob() # BatchJob |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # Update JobMonitor
    api_response = api_instance.patch_job_monitor(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_job_monitor: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.LogPartition() # LogPartition |  (optional)

try:
    # Update an existing log partition
    api_response = api_instance.patch_log_partition(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_log_partition: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.LogSource() # LogSource |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # update log source 
    api_response = api_instance.patch_log_source(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_log_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Netscan() # Netscan |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # update a netscan
    api_response = api_instance.patch_netscan(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_netscan: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.RestOidV3() # RestOidV3 |  (optional)

try:
    # update a OID
    api_response = api_instance.patch_oid(id, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_oid: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 
body = logicmonitor_sdk.OpsNote() # OpsNote | 

try:
    # update opsnote
    api_response = api_instance.patch_ops_note_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_ops_note_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.PropertyRule() # PropertyRule |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # update a property rule
    api_response = api_instance.patch_property_rule(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_property_rule: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.RecipientGroup() # RecipientGroup | 

try:
    # update recipient group
    api_response = api_instance.patch_recipient_group_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_recipient_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.ReportBase() # ReportBase | 

try:
    # update report
    api_response = api_instance.patch_report_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_report_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.ReportGroup() # ReportGroup | 

try:
    # update report group
    api_response = api_instance.patch_report_group_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_report_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Role() # Role | 

try:
    # update role
    api_response = api_instance.patch_role_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_role_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 
body = logicmonitor_sdk.SDT() # SDT | 

try:
    # update SDT (Response may contain extra fields depending upon the type of SDT being updated)
    api_response = api_instance.patch_sdt_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_sdt_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.TopologySource() # TopologySource |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # Update TopologySource
    api_response = api_instance.patch_topology_source(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_topology_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Website() # Website | 
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update website
    api_response = api_instance.patch_website_by_id(id, body, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_website_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.WebsiteGroup() # WebsiteGroup | 
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update website group
    api_response = api_instance.patch_website_group_by_id(id, body, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_website_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Widget() # Widget | 

try:
    # update widget (Based upon widget type the request and response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
    api_response = api_instance.patch_widget_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->patch_widget_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)

try:
    # schedule active discovery for a device
    api_response = api_instance.schedule_auto_discovery_by_device_id(id, start=start, end=end, netflow_filter=netflow_filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->schedule_auto_discovery_by_device_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.RestAwsAccountTestV3() # RestAwsAccountTestV3 | 

try:
    # test AWS account
    api_response = api_instance.test_aws_account(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->test_aws_account: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.RestAzureAccountTestV3() # RestAzureAccountTestV3 | 

try:
    # test Azure account
    api_response = api_instance.test_azure_account(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->test_azure_account: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.RestGcpAccountTestV3() # RestGcpAccountTestV3 | 

try:
    # test GCP account
    api_response = api_instance.test_gcp_account(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->test_gcp_account: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.RestSaaSAccountTestV3() # RestSaaSAccountTestV3 | 

try:
    # test SaaS account
    api_response = api_instance.test_saa_s_account(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->test_saa_s_account: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.AccessGroup() # AccessGroup | 

try:
    # Update access group
    api_response = api_instance.update_access_group(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_access_group: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Admin() # Admin | 
change_password = false # bool |  (optional) (default to false)
validation_only = false # bool |  (optional) (default to false)

try:
    # update user
    api_response = api_instance.update_admin_by_id(id, body, change_password=change_password, validation_only=validation_only)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_admin_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.AlertRule() # AlertRule | 

try:
    # update alert rule
    api_response = api_instance.update_alert_rule_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_alert_rule_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
admin_id = 56 # int | 
apitoken_id = 56 # int | 
body = logicmonitor_sdk.APIToken() # APIToken | 

try:
    # update api tokens for a user
    api_response = api_instance.update_api_token_by_admin_id(admin_id, apitoken_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_api_token_by_admin_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.AppliesToFunction() # AppliesToFunction |  (optional)
reason = 'reason_example' # str |  (optional)
ignore_reference = false # bool |  (optional) (default to false)

try:
    # update applies to function
    api_response = api_instance.update_applies_to_function(id, body=body, reason=reason, ignore_reference=ignore_reference)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_applies_to_function: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Collector() # Collector | 
auto_balance_monitored_devices = false # bool |  (optional) (default to false)
force_update_failed_over_devices = false # bool |  (optional) (default to false)
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update collector
    api_response = api_instance.update_collector_by_id(id, body, auto_balance_monitored_devices=auto_balance_monitored_devices, force_update_failed_over_devices=force_update_failed_over_devices, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_collector_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.CollectorGroup() # CollectorGroup | 
auto_balance_monitored_devices = false # bool |  (optional) (default to false)
force_update_failed_over_devices = false # bool |  (optional) (default to false)
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update collector group
    api_response = api_instance.update_collector_group_by_id(id, body, auto_balance_monitored_devices=auto_balance_monitored_devices, force_update_failed_over_devices=force_update_failed_over_devices, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_collector_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.ConfigSource() # ConfigSource |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # update config source by id
    api_response = api_instance.update_config_source_by_id(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_config_source_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Dashboard() # Dashboard | 
overwrite_group_fields = false # bool |  (optional) (default to false)

try:
    # update dashboard
    api_response = api_instance.update_dashboard_by_id(id, body, overwrite_group_fields=overwrite_group_fields)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_dashboard_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.DashboardGroup() # DashboardGroup | 

try:
    # update dashboard group
    api_response = api_instance.update_dashboard_group_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_dashboard_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.DataSource() # DataSource |  (optional)
reason = 'reason_example' # str |  (optional)
force_unique_identifier = false # bool |  (optional) (default to false)
force_restricted_change_key = 'force_restricted_change_key_example' # str |  (optional)

try:
    # update datasource
    api_response = api_instance.update_datasource_by_id(id, body=body, reason=reason, force_unique_identifier=force_unique_identifier, force_restricted_change_key=force_restricted_change_key)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_datasource_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 
body = logicmonitor_sdk.RestUserCustomizedDataV3() # RestUserCustomizedDataV3 |  (optional)

try:
    # update default dashboard
    api_response = api_instance.update_default_dashboard(id, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_default_dashboard: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Device() # Device | 
start = 789 # int |  (optional)
end = 789 # int |  (optional)
netflow_filter = 'netflow_filter_example' # str |  (optional)
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update a device
    api_response = api_instance.update_device(id, body, start=start, end=end, netflow_filter=netflow_filter, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_device: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | Device-DataSource ID
instance_id = 56 # int | 
id = 56 # int | 
body = logicmonitor_sdk.DeviceDataSourceInstanceAlertSetting() # DeviceDataSourceInstanceAlertSetting | 

try:
    # update device instance alert setting
    api_response = api_instance.update_device_datasource_instance_alert_setting_by_id(device_id, hds_id, instance_id, id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_device_datasource_instance_alert_setting_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
hds_id = 56 # int | The device-datasource ID
id = 56 # int | 
body = logicmonitor_sdk.DeviceDataSourceInstance() # DeviceDataSourceInstance | 
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update device instance
    api_response = api_instance.update_device_datasource_instance_by_id(device_id, hds_id, id, body, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_device_datasource_instance_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
device_ds_id = 56 # int | The device-datasource ID you'd like to add an instance group for
id = 56 # int | 
body = logicmonitor_sdk.DeviceDataSourceInstanceGroup() # DeviceDataSourceInstanceGroup | 

try:
    # update device datasource instance group
    api_response = api_instance.update_device_datasource_instance_group_by_id(device_id, device_ds_id, id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_device_datasource_instance_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.DeviceGroup() # DeviceGroup | 
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update device group
    api_response = api_instance.update_device_group_by_id(id, body, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_device_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
id = 56 # int | 
body = logicmonitor_sdk.DeviceClusterAlertConfig() # DeviceClusterAlertConfig | 

try:
    # Update cluster alert configuration
    api_response = api_instance.update_device_group_cluster_alert_conf_by_id(device_group_id, id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_device_group_cluster_alert_conf_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
ds_id = 56 # int | 
body = logicmonitor_sdk.DeviceGroupDataSourceAlertConfig() # DeviceGroupDataSourceAlertConfig | 

try:
    # update device group datasource alert setting
    api_response = api_instance.update_device_group_datasource_alert_setting(device_group_id, ds_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_device_group_datasource_alert_setting: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_group_id = 56 # int | 
id = 56 # int | 
body = logicmonitor_sdk.DeviceGroupDataSource() # DeviceGroupDataSource |  (optional)

try:
    # update device group datasource
    api_response = api_instance.update_device_group_datasource_by_id(device_group_id, id, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_device_group_datasource_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
gid = 56 # int | group ID
name = 'name_example' # str | 
body = logicmonitor_sdk.EntityProperty() # EntityProperty | 

try:
    # update device group property
    api_response = api_instance.update_device_group_property_by_name(gid, name, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_device_group_property_by_name: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
name = 'name_example' # str | 
body = logicmonitor_sdk.EntityProperty() # EntityProperty | 

try:
    # update device property
    api_response = api_instance.update_device_property_by_name(device_id, name, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_device_property_by_name: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.EscalatingChain() # EscalatingChain | 

try:
    # update escalation chain
    api_response = api_instance.update_escalation_chain_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_escalation_chain_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.EventSource() # EventSource |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # update eventSource by id
    api_response = api_instance.update_event_source_by_id(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_event_source_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
device_id = 56 # int | 
device_ds_id = 56 # int | The device-datasource ID you'd like to add an instance group for
dsig_id = 56 # int | 
dp_id = 56 # int | 
body = logicmonitor_sdk.RestDeviceInstanceGroupAlertConfigV3() # RestDeviceInstanceGroupAlertConfigV3 |  (optional)

try:
    # update instance group alert threshold (Setting the threshold at default group is not allowed)
    api_response = api_instance.update_instance_group_alert_threshold(device_id, device_ds_id, dsig_id, dp_id, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_instance_group_alert_threshold: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.BatchJob() # BatchJob |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # Update JobMonitor
    api_response = api_instance.update_job_monitor(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_job_monitor: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.LogPartition() # LogPartition |  (optional)

try:
    # Update an existing log partition
    api_response = api_instance.update_log_partition(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_log_partition: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.LogSource() # LogSource |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # update log source 
    api_response = api_instance.update_log_source(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_log_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Netscan() # Netscan |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # update a netscan
    api_response = api_instance.update_netscan(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_netscan: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.RestOidV3() # RestOidV3 |  (optional)

try:
    # update a OID
    api_response = api_instance.update_oid(id, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_oid: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 
body = logicmonitor_sdk.OpsNote() # OpsNote | 

try:
    # update opsnote
    api_response = api_instance.update_ops_note_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_ops_note_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.PropertyRule() # PropertyRule |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # update a property rule
    api_response = api_instance.update_property_rule(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_property_rule: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.RecipientGroup() # RecipientGroup | 

try:
    # update recipient group
    api_response = api_instance.update_recipient_group_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_recipient_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.ReportBase() # ReportBase | 

try:
    # update report
    api_response = api_instance.update_report_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_report_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.ReportGroup() # ReportGroup | 

try:
    # update report group
    api_response = api_instance.update_report_group_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_report_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Role() # Role | 

try:
    # update role
    api_response = api_instance.update_role_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_role_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 'id_example' # str | 
body = logicmonitor_sdk.SDT() # SDT | 

try:
    # update SDT (Response may contain extra fields depending upon the type of SDT being updated)
    api_response = api_instance.update_sdt_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_sdt_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.TopologySource() # TopologySource |  (optional)
reason = 'reason_example' # str |  (optional)

try:
    # Update TopologySource
    api_response = api_instance.update_topology_source(id, body=body, reason=reason)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_topology_source: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Website() # Website | 
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update website
    api_response = api_instance.update_website_by_id(id, body, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_website_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.WebsiteGroup() # WebsiteGroup | 
op_type = 'refresh' # str |  (optional) (default to refresh)

try:
    # update website group
    api_response = api_instance.update_website_group_by_id(id, body, op_type=op_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_website_group_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
id = 56 # int | 
body = logicmonitor_sdk.Widget() # Widget | 

try:
    # update widget (Based upon widget type the request and response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
    api_response = api_instance.update_widget_by_id(id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->update_widget_by_id: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.RestAwsAccountTestV3() # RestAwsAccountTestV3 | 

try:
    # verify AWS Billing Permissions
    api_response = api_instance.verify_aws_billing_permissions(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->verify_aws_billing_permissions: %s\n" % e)

# Configure API key authorization: LMv1
configuration = logicmonitor_sdk.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class test
api_instance = logicmonitor_sdk.LMApi(logicmonitor_sdk.ApiClient(configuration))
body = logicmonitor_sdk.RestAzureStorageAccountVerify() # RestAzureStorageAccountVerify | 

try:
    # view storage accounts
    api_response = api_instance.verify_storage_accounts_permissions(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LMApi->verify_storage_accounts_permissions: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to */santaba/rest*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*LMApi* | [**ack_alert_by_id**](docs/LMApi.md#ack_alert_by_id) | **POST** /alert/alerts/{id}/ack | ack alert by id
*LMApi* | [**ack_collector_down_alert_by_id**](docs/LMApi.md#ack_collector_down_alert_by_id) | **POST** /setting/collector/collectors/{id}/ackdown | ack collector down alert
*LMApi* | [**add_access_group**](docs/LMApi.md#add_access_group) | **POST** /setting/accessgroup/add | Create a access group
*LMApi* | [**add_admin**](docs/LMApi.md#add_admin) | **POST** /setting/admins | add user
*LMApi* | [**add_alert_note_by_id**](docs/LMApi.md#add_alert_note_by_id) | **POST** /alert/alerts/{id}/note | add alert note
*LMApi* | [**add_alert_rule**](docs/LMApi.md#add_alert_rule) | **POST** /setting/alert/rules | add alert rule
*LMApi* | [**add_api_token_by_admin_id**](docs/LMApi.md#add_api_token_by_admin_id) | **POST** /setting/admins/{adminId}/apitokens | add api tokens for a user
*LMApi* | [**add_applies_to_function**](docs/LMApi.md#add_applies_to_function) | **POST** /setting/functions | add applies to function
*LMApi* | [**add_collector**](docs/LMApi.md#add_collector) | **POST** /setting/collector/collectors | add collector
*LMApi* | [**add_collector_group**](docs/LMApi.md#add_collector_group) | **POST** /setting/collector/groups | add collector group
*LMApi* | [**add_config_source**](docs/LMApi.md#add_config_source) | **POST** /setting/configsources | add config source
*LMApi* | [**add_dashboard**](docs/LMApi.md#add_dashboard) | **POST** /dashboard/dashboards | add dashboard
*LMApi* | [**add_dashboard_group**](docs/LMApi.md#add_dashboard_group) | **POST** /dashboard/groups | add dashboard group
*LMApi* | [**add_dashboard_group_asynchronously**](docs/LMApi.md#add_dashboard_group_asynchronously) | **POST** /dashboard/groups/{id}/asyncclone | add dashboard group asynchronously
*LMApi* | [**add_datasource_by_id**](docs/LMApi.md#add_datasource_by_id) | **POST** /setting/datasources | add datasource
*LMApi* | [**add_device**](docs/LMApi.md#add_device) | **POST** /device/devices | add a new device
*LMApi* | [**add_device_datasource_instance**](docs/LMApi.md#add_device_datasource_instance) | **POST** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances | add device instance 
*LMApi* | [**add_device_datasource_instance_group**](docs/LMApi.md#add_device_datasource_instance_group) | **POST** /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups | add device datasource instance group 
*LMApi* | [**add_device_group**](docs/LMApi.md#add_device_group) | **POST** /device/groups | add device group
*LMApi* | [**add_device_group_cluster_alert_conf**](docs/LMApi.md#add_device_group_cluster_alert_conf) | **POST** /device/groups/{deviceGroupId}/clusterAlertConf | Add cluster alert configuration
*LMApi* | [**add_device_group_property**](docs/LMApi.md#add_device_group_property) | **POST** /device/groups/{gid}/properties | add device group property
*LMApi* | [**add_device_property**](docs/LMApi.md#add_device_property) | **POST** /device/devices/{deviceId}/properties | add device property
*LMApi* | [**add_dns_mapping**](docs/LMApi.md#add_dns_mapping) | **POST** /setting/dnsmappings | Add dns mapping
*LMApi* | [**add_escalation_chain**](docs/LMApi.md#add_escalation_chain) | **POST** /setting/alert/chains | add escalation chain
*LMApi* | [**add_event_source**](docs/LMApi.md#add_event_source) | **POST** /setting/eventsources | add eventSource
*LMApi* | [**add_job_monitor**](docs/LMApi.md#add_job_monitor) | **POST** /setting/batchjobs | Add JobMonitor
*LMApi* | [**add_log_source**](docs/LMApi.md#add_log_source) | **POST** /setting/logsources | add log source 
*LMApi* | [**add_netscan**](docs/LMApi.md#add_netscan) | **POST** /setting/netscans | add a new netscan
*LMApi* | [**add_oid**](docs/LMApi.md#add_oid) | **POST** /setting/oids | add a new OID
*LMApi* | [**add_ops_note**](docs/LMApi.md#add_ops_note) | **POST** /setting/opsnotes | add opsnote
*LMApi* | [**add_property_rule**](docs/LMApi.md#add_property_rule) | **POST** /setting/propertyrules | add a new property rule
*LMApi* | [**add_recipient_group**](docs/LMApi.md#add_recipient_group) | **POST** /setting/recipientgroups | add recipient group
*LMApi* | [**add_report**](docs/LMApi.md#add_report) | **POST** /report/reports | add report
*LMApi* | [**add_report_group**](docs/LMApi.md#add_report_group) | **POST** /report/groups | add report group
*LMApi* | [**add_role**](docs/LMApi.md#add_role) | **POST** /setting/roles | add role
*LMApi* | [**add_sdt**](docs/LMApi.md#add_sdt) | **POST** /sdt/sdts | add SDT (Response may contain extra fields depending upon the type of SDT being added)
*LMApi* | [**add_topology_source**](docs/LMApi.md#add_topology_source) | **POST** /setting/topologysources | Add TopologySource
*LMApi* | [**add_website**](docs/LMApi.md#add_website) | **POST** /website/websites | add website
*LMApi* | [**add_website_group**](docs/LMApi.md#add_website_group) | **POST** /website/groups | add website group
*LMApi* | [**add_widget**](docs/LMApi.md#add_widget) | **POST** /dashboard/widgets | add widget (Based upon widget type the request and response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
*LMApi* | [**collect_device_config_source_config**](docs/LMApi.md#collect_device_config_source_config) | **POST** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/config/configCollection | collect a config for a device
*LMApi* | [**create_log_partition**](docs/LMApi.md#create_log_partition) | **POST** /log/partitions | Create a new log partition
*LMApi* | [**delete_access_group**](docs/LMApi.md#delete_access_group) | **DELETE** /setting/accessgroup/{id} | Delete access group
*LMApi* | [**delete_admin_by_id**](docs/LMApi.md#delete_admin_by_id) | **DELETE** /setting/admins/{id} | delete user
*LMApi* | [**delete_alert_rule_by_id**](docs/LMApi.md#delete_alert_rule_by_id) | **DELETE** /setting/alert/rules/{id} | delete alert rule
*LMApi* | [**delete_api_token_by_id**](docs/LMApi.md#delete_api_token_by_id) | **DELETE** /setting/admins/{adminId}/apitokens/{apitokenId} | delete apiToken
*LMApi* | [**delete_applies_to_function_by_id**](docs/LMApi.md#delete_applies_to_function_by_id) | **DELETE** /setting/functions/{id} | delete applies to function
*LMApi* | [**delete_collector_by_id**](docs/LMApi.md#delete_collector_by_id) | **DELETE** /setting/collector/collectors/{id} | delete collector
*LMApi* | [**delete_collector_group_by_id**](docs/LMApi.md#delete_collector_group_by_id) | **DELETE** /setting/collector/groups/{id} | delete collector group
*LMApi* | [**delete_config_source_by_id**](docs/LMApi.md#delete_config_source_by_id) | **DELETE** /setting/configsources/{id} | delete config source by id
*LMApi* | [**delete_dashboard_by_id**](docs/LMApi.md#delete_dashboard_by_id) | **DELETE** /dashboard/dashboards/{id} | delete dashboard
*LMApi* | [**delete_dashboard_group_by_id**](docs/LMApi.md#delete_dashboard_group_by_id) | **DELETE** /dashboard/groups/{id} | delete dashboard group
*LMApi* | [**delete_datasource_by_id**](docs/LMApi.md#delete_datasource_by_id) | **DELETE** /setting/datasources/{id} | delete datasource
*LMApi* | [**delete_device_by_id**](docs/LMApi.md#delete_device_by_id) | **DELETE** /device/devices/{id} | delete a device
*LMApi* | [**delete_device_datasource_instance_by_id**](docs/LMApi.md#delete_device_datasource_instance_by_id) | **DELETE** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{id} | delete a device instance
*LMApi* | [**delete_device_group_by_id**](docs/LMApi.md#delete_device_group_by_id) | **DELETE** /device/groups/{id} | delete device group
*LMApi* | [**delete_device_group_cluster_alert_conf_by_id**](docs/LMApi.md#delete_device_group_cluster_alert_conf_by_id) | **DELETE** /device/groups/{deviceGroupId}/clusterAlertConf/{id} | Delete cluster alert configuration
*LMApi* | [**delete_device_group_property_by_name**](docs/LMApi.md#delete_device_group_property_by_name) | **DELETE** /device/groups/{gid}/properties/{name} | delete device group property
*LMApi* | [**delete_device_property_by_name**](docs/LMApi.md#delete_device_property_by_name) | **DELETE** /device/devices/{deviceId}/properties/{name} | delete device property
*LMApi* | [**delete_escalation_chain_by_id**](docs/LMApi.md#delete_escalation_chain_by_id) | **DELETE** /setting/alert/chains/{id} | delete escalation chain
*LMApi* | [**delete_event_source_by_id**](docs/LMApi.md#delete_event_source_by_id) | **DELETE** /setting/eventsources/{id} | delete eventSource by id
*LMApi* | [**delete_job_monitor**](docs/LMApi.md#delete_job_monitor) | **DELETE** /setting/batchjobs/{id} | Delete JobMonitor
*LMApi* | [**delete_log_partition_by_id**](docs/LMApi.md#delete_log_partition_by_id) | **DELETE** /log/partitions/{id} | Delete a log partition by ID
*LMApi* | [**delete_log_source**](docs/LMApi.md#delete_log_source) | **DELETE** /setting/logsources/{id} | delete log source 
*LMApi* | [**delete_netscan_by_id**](docs/LMApi.md#delete_netscan_by_id) | **DELETE** /setting/netscans/{id} | delete a netscan
*LMApi* | [**delete_oid**](docs/LMApi.md#delete_oid) | **DELETE** /setting/oids/{id} | delete a OID
*LMApi* | [**delete_ops_note_by_id**](docs/LMApi.md#delete_ops_note_by_id) | **DELETE** /setting/opsnotes/{id} | delete opsnote
*LMApi* | [**delete_property_rule**](docs/LMApi.md#delete_property_rule) | **DELETE** /setting/propertyrules/{id} | delete a property rule
*LMApi* | [**delete_recipient_group_by_id**](docs/LMApi.md#delete_recipient_group_by_id) | **DELETE** /setting/recipientgroups/{id} | delete recipient group
*LMApi* | [**delete_report_by_id**](docs/LMApi.md#delete_report_by_id) | **DELETE** /report/reports/{id} | delete report
*LMApi* | [**delete_report_group_by_id**](docs/LMApi.md#delete_report_group_by_id) | **DELETE** /report/groups/{id} | delete report group
*LMApi* | [**delete_role_by_id**](docs/LMApi.md#delete_role_by_id) | **DELETE** /setting/roles/{id} | delete role
*LMApi* | [**delete_sdt_by_id**](docs/LMApi.md#delete_sdt_by_id) | **DELETE** /sdt/sdts/{id} | delete SDT
*LMApi* | [**delete_topology_source**](docs/LMApi.md#delete_topology_source) | **DELETE** /setting/topologysources/{id} | Delete TopologySource
*LMApi* | [**delete_website_by_id**](docs/LMApi.md#delete_website_by_id) | **DELETE** /website/websites/{id} | delete website
*LMApi* | [**delete_website_group_by_id**](docs/LMApi.md#delete_website_group_by_id) | **DELETE** /website/groups/{id} | delete website group
*LMApi* | [**delete_widget_by_id**](docs/LMApi.md#delete_widget_by_id) | **DELETE** /dashboard/widgets/{id} | delete widget
*LMApi* | [**discover_subscriptions**](docs/LMApi.md#discover_subscriptions) | **POST** /azure/functions/discoverSubscriptions | view subscriptions
*LMApi* | [**escalated_alert_by_id**](docs/LMApi.md#escalated_alert_by_id) | **POST** /alert/alerts/{id}/escalate | escalate alert by id
*LMApi* | [**execute_debug_command**](docs/LMApi.md#execute_debug_command) | **POST** /debug | Execute a Collector debug command
*LMApi* | [**fetch_device_instances_data**](docs/LMApi.md#fetch_device_instances_data) | **POST** /device/instances/datafetch | fetch device instances data
*LMApi* | [**fetch_report_using_task_id**](docs/LMApi.md#fetch_report_using_task_id) | **GET** /report/reports/{id}/tasks/{taskId} | get report for task Id
*LMApi* | [**generate_report_by_id**](docs/LMApi.md#generate_report_by_id) | **POST** /report/reports/{id}/executions | run a report
*LMApi* | [**get_access_group_by_id**](docs/LMApi.md#get_access_group_by_id) | **GET** /setting/accessgroup/{id} | Get access group by id
*LMApi* | [**get_access_group_list**](docs/LMApi.md#get_access_group_list) | **GET** /setting/accessgroup | Get access group list
*LMApi* | [**get_admin_by_id**](docs/LMApi.md#get_admin_by_id) | **GET** /setting/admins/{id} | get user
*LMApi* | [**get_admin_list**](docs/LMApi.md#get_admin_list) | **GET** /setting/admins | get user list
*LMApi* | [**get_alert_by_id**](docs/LMApi.md#get_alert_by_id) | **GET** /alert/alerts/{id} | get alert
*LMApi* | [**get_alert_list**](docs/LMApi.md#get_alert_list) | **GET** /alert/alerts | get alert list
*LMApi* | [**get_alert_list_by_device_group_id**](docs/LMApi.md#get_alert_list_by_device_group_id) | **GET** /device/groups/{id}/alerts | get device group alerts
*LMApi* | [**get_alert_list_by_device_id**](docs/LMApi.md#get_alert_list_by_device_id) | **GET** /device/devices/{id}/alerts | get alerts
*LMApi* | [**get_alert_rule_by_id**](docs/LMApi.md#get_alert_rule_by_id) | **GET** /setting/alert/rules/{id} | get alert rule by id
*LMApi* | [**get_alert_rule_list**](docs/LMApi.md#get_alert_rule_list) | **GET** /setting/alert/rules | get alert rule list
*LMApi* | [**get_all_log_partitions**](docs/LMApi.md#get_all_log_partitions) | **GET** /log/partitions | Retrieve a list of all log partitions
*LMApi* | [**get_all_sdt_list_by_device_id**](docs/LMApi.md#get_all_sdt_list_by_device_id) | **GET** /device/devices/{id}/sdts | get SDTs for a device
*LMApi* | [**get_all_sdt_list_by_website_group_id**](docs/LMApi.md#get_all_sdt_list_by_website_group_id) | **GET** /website/groups/{id}/sdts | get a list of SDTs for a website group (Response may contain extra fields depending upon the type of SDT)
*LMApi* | [**get_api_token_list**](docs/LMApi.md#get_api_token_list) | **GET** /setting/admins/apitokens | get a list of api tokens across users
*LMApi* | [**get_api_token_list_by_admin_id**](docs/LMApi.md#get_api_token_list_by_admin_id) | **GET** /setting/admins/{adminId}/apitokens | get api tokens for a user
*LMApi* | [**get_applies_to_function_by_id**](docs/LMApi.md#get_applies_to_function_by_id) | **GET** /setting/functions/{id} | get applies to function
*LMApi* | [**get_applies_to_function_list**](docs/LMApi.md#get_applies_to_function_list) | **GET** /setting/functions | get applies to function list
*LMApi* | [**get_associated_device_list_by_data_source_id**](docs/LMApi.md#get_associated_device_list_by_data_source_id) | **GET** /setting/datasources/{id}/devices | get devices associated with a datasource
*LMApi* | [**get_audit_log_by_id**](docs/LMApi.md#get_audit_log_by_id) | **GET** /setting/accesslogs/{id} | Get audit log by id
*LMApi* | [**get_audit_log_list**](docs/LMApi.md#get_audit_log_list) | **GET** /setting/accesslogs | Get audit logs
*LMApi* | [**get_aws_account_id**](docs/LMApi.md#get_aws_account_id) | **GET** /aws/accountId | Get AWS account ID
*LMApi* | [**get_aws_external_id**](docs/LMApi.md#get_aws_external_id) | **GET** /aws/externalId | Get AWS external ID
*LMApi* | [**get_collector_by_id**](docs/LMApi.md#get_collector_by_id) | **GET** /setting/collector/collectors/{id} | get collector
*LMApi* | [**get_collector_group_by_id**](docs/LMApi.md#get_collector_group_by_id) | **GET** /setting/collector/groups/{id} | get collector group
*LMApi* | [**get_collector_group_list**](docs/LMApi.md#get_collector_group_list) | **GET** /setting/collector/groups | get collector group list
*LMApi* | [**get_collector_installer**](docs/LMApi.md#get_collector_installer) | **GET** /setting/collector/collectors/{collectorId}/installers/{osAndArch} | get collector installer
*LMApi* | [**get_collector_list**](docs/LMApi.md#get_collector_list) | **GET** /setting/collector/collectors | get collector list
*LMApi* | [**get_collector_version_list**](docs/LMApi.md#get_collector_version_list) | **GET** /setting/collector/collectors/versions | get collector version list
*LMApi* | [**get_config_source_by_id**](docs/LMApi.md#get_config_source_by_id) | **GET** /setting/configsources/{id} | get config source by id
*LMApi* | [**get_config_source_list**](docs/LMApi.md#get_config_source_list) | **GET** /setting/configsources | get config source list
*LMApi* | [**get_contract_info_by_company**](docs/LMApi.md#get_contract_info_by_company) | **GET** /usage/contractInfo | get contract info by company
*LMApi* | [**get_dashboard_by_id**](docs/LMApi.md#get_dashboard_by_id) | **GET** /dashboard/dashboards/{id} | get dashboard
*LMApi* | [**get_dashboard_group_by_id**](docs/LMApi.md#get_dashboard_group_by_id) | **GET** /dashboard/groups/{id} | get dashboard group
*LMApi* | [**get_dashboard_group_list**](docs/LMApi.md#get_dashboard_group_list) | **GET** /dashboard/groups | get dashboard group list
*LMApi* | [**get_dashboard_list**](docs/LMApi.md#get_dashboard_list) | **GET** /dashboard/dashboards | get dashboard list
*LMApi* | [**get_data_source_overview_graph_by_id**](docs/LMApi.md#get_data_source_overview_graph_by_id) | **GET** /setting/datasources/{dsId}/ographs/{id} | get datasource overview graph by id
*LMApi* | [**get_data_source_overview_graph_list**](docs/LMApi.md#get_data_source_overview_graph_list) | **GET** /setting/datasources/{dsId}/ographs | get datasource overview graph list
*LMApi* | [**get_datasource_by_id**](docs/LMApi.md#get_datasource_by_id) | **GET** /setting/datasources/{id} | get datasource by id
*LMApi* | [**get_datasource_list**](docs/LMApi.md#get_datasource_list) | **GET** /setting/datasources | get datasource list
*LMApi* | [**get_debug_command_result**](docs/LMApi.md#get_debug_command_result) | **GET** /debug/{id} | Get the result of a Collector debug command using sessionId
*LMApi* | [**get_delta_devices**](docs/LMApi.md#get_delta_devices) | **GET** /device/devices/delta/{deltaId} | Get delta devices using deltaId
*LMApi* | [**get_delta_id_with_devices**](docs/LMApi.md#get_delta_id_with_devices) | **GET** /device/devices/delta | Get filter matched devices with new deltaId
*LMApi* | [**get_device_by_id**](docs/LMApi.md#get_device_by_id) | **GET** /device/devices/{id} | get device by id
*LMApi* | [**get_device_config_source_config_by_id**](docs/LMApi.md#get_device_config_source_config_by_id) | **GET** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/config/{id} | get a config for a device
*LMApi* | [**get_device_config_source_config_list**](docs/LMApi.md#get_device_config_source_config_list) | **GET** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/config | get detailed config information for the instance
*LMApi* | [**get_device_datasource_by_id**](docs/LMApi.md#get_device_datasource_by_id) | **GET** /device/devices/{deviceId}/devicedatasources/{id} | get device datasource 
*LMApi* | [**get_device_datasource_data_by_id**](docs/LMApi.md#get_device_datasource_data_by_id) | **GET** /device/devices/{deviceId}/devicedatasources/{id}/data | get device datasource data 
*LMApi* | [**get_device_datasource_instance_alert_setting_by_id**](docs/LMApi.md#get_device_datasource_instance_alert_setting_by_id) | **GET** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/alertsettings/{id} | get device instance alert setting
*LMApi* | [**get_device_datasource_instance_alert_setting_list_of_device**](docs/LMApi.md#get_device_datasource_instance_alert_setting_list_of_device) | **GET** /device/devices/{deviceId}/alertsettings | get a list of alert settings for a device
*LMApi* | [**get_device_datasource_instance_alert_setting_list_of_dsi**](docs/LMApi.md#get_device_datasource_instance_alert_setting_list_of_dsi) | **GET** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/alertsettings | get a list of alert settings for a device datasource instance
*LMApi* | [**get_device_datasource_instance_by_id**](docs/LMApi.md#get_device_datasource_instance_by_id) | **GET** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{id} | get device instance 
*LMApi* | [**get_device_datasource_instance_data**](docs/LMApi.md#get_device_datasource_instance_data) | **GET** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{id}/data | get device instance data
*LMApi* | [**get_device_datasource_instance_graph_data**](docs/LMApi.md#get_device_datasource_instance_graph_data) | **GET** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{id}/graphs/{graphId}/data | get device instance graph data 
*LMApi* | [**get_device_datasource_instance_group_by_id**](docs/LMApi.md#get_device_datasource_instance_group_by_id) | **GET** /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id} | get device datasource instance group 
*LMApi* | [**get_device_datasource_instance_group_list**](docs/LMApi.md#get_device_datasource_instance_group_list) | **GET** /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups | get device datasource instance group list 
*LMApi* | [**get_device_datasource_instance_group_overview_graph_data**](docs/LMApi.md#get_device_datasource_instance_group_overview_graph_data) | **GET** /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{dsigId}/graphs/{ographId}/data | get device instance group overview graph data 
*LMApi* | [**get_device_datasource_instance_list**](docs/LMApi.md#get_device_datasource_instance_list) | **GET** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances | get device instance list
*LMApi* | [**get_device_datasource_instance_sdt_history**](docs/LMApi.md#get_device_datasource_instance_sdt_history) | **GET** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{id}/historysdts | get device instance SDT history
*LMApi* | [**get_device_datasource_list**](docs/LMApi.md#get_device_datasource_list) | **GET** /device/devices/{deviceId}/devicedatasources | get device datasource list 
*LMApi* | [**get_device_group_by_id**](docs/LMApi.md#get_device_group_by_id) | **GET** /device/groups/{id} | get device group
*LMApi* | [**get_device_group_cluster_alert_conf_by_id**](docs/LMApi.md#get_device_group_cluster_alert_conf_by_id) | **GET** /device/groups/{deviceGroupId}/clusterAlertConf/{id} | Get cluster alert configuration by id
*LMApi* | [**get_device_group_cluster_alert_conf_list**](docs/LMApi.md#get_device_group_cluster_alert_conf_list) | **GET** /device/groups/{deviceGroupId}/clusterAlertConf | get a list of cluster alert configurations for a device group
*LMApi* | [**get_device_group_datasource_alert_setting**](docs/LMApi.md#get_device_group_datasource_alert_setting) | **GET** /device/groups/{deviceGroupId}/datasources/{dsId}/alertsettings | get device group datasource alert setting 
*LMApi* | [**get_device_group_datasource_by_id**](docs/LMApi.md#get_device_group_datasource_by_id) | **GET** /device/groups/{deviceGroupId}/datasources/{id} | get device group datasource
*LMApi* | [**get_device_group_datasource_list**](docs/LMApi.md#get_device_group_datasource_list) | **GET** /device/groups/{deviceGroupId}/datasources | get device group datasource list
*LMApi* | [**get_device_group_list**](docs/LMApi.md#get_device_group_list) | **GET** /device/groups | get device group list
*LMApi* | [**get_device_group_property_by_name**](docs/LMApi.md#get_device_group_property_by_name) | **GET** /device/groups/{gid}/properties/{name} | get device group property by name
*LMApi* | [**get_device_group_property_list**](docs/LMApi.md#get_device_group_property_list) | **GET** /device/groups/{gid}/properties | get device group properties
*LMApi* | [**get_device_group_sdt_list**](docs/LMApi.md#get_device_group_sdt_list) | **GET** /device/groups/{id}/sdts | get device group SDTs
*LMApi* | [**get_device_instance_graph_data_only_by_instance_id**](docs/LMApi.md#get_device_instance_graph_data_only_by_instance_id) | **GET** /device/devicedatasourceinstances/{instanceId}/graphs/{graphId}/data | get device instance data
*LMApi* | [**get_device_instance_list**](docs/LMApi.md#get_device_instance_list) | **GET** /device/devices/{id}/instances | get device instance list
*LMApi* | [**get_device_list**](docs/LMApi.md#get_device_list) | **GET** /device/devices | get device list
*LMApi* | [**get_device_property_by_name**](docs/LMApi.md#get_device_property_by_name) | **GET** /device/devices/{deviceId}/properties/{name} | get device property by name
*LMApi* | [**get_device_property_list**](docs/LMApi.md#get_device_property_list) | **GET** /device/devices/{deviceId}/properties | get device properties
*LMApi* | [**get_escalation_chain_by_id**](docs/LMApi.md#get_escalation_chain_by_id) | **GET** /setting/alert/chains/{id} | get escalation chain by id
*LMApi* | [**get_escalation_chain_list**](docs/LMApi.md#get_escalation_chain_list) | **GET** /setting/alert/chains | get escalation chain list
*LMApi* | [**get_event_source_by_id**](docs/LMApi.md#get_event_source_by_id) | **GET** /setting/eventsources/{id} | get eventSource by id
*LMApi* | [**get_event_source_list**](docs/LMApi.md#get_event_source_list) | **GET** /setting/eventsources | get eventSource list
*LMApi* | [**get_external_api_stats**](docs/LMApi.md#get_external_api_stats) | **GET** /apiStats/externalApis | get external api stats info
*LMApi* | [**get_immediate_device_list_by_device_group_id**](docs/LMApi.md#get_immediate_device_list_by_device_group_id) | **GET** /device/groups/{id}/devices | get immediate devices under group
*LMApi* | [**get_immediate_website_list_by_website_group_id**](docs/LMApi.md#get_immediate_website_list_by_website_group_id) | **GET** /website/groups/{id}/websites | get a list of websites for a group (Response may contain extra fields depending upon the type of check { PingCheck | WebCheck} being added)
*LMApi* | [**get_integration_audit_logs**](docs/LMApi.md#get_integration_audit_logs) | **GET** /setting/integrations/auditlogs | get integration audit logs list
*LMApi* | [**get_job_monitor_by_id**](docs/LMApi.md#get_job_monitor_by_id) | **GET** /setting/batchjobs/{id} | Get JobMonitor by id
*LMApi* | [**get_job_monitor_list**](docs/LMApi.md#get_job_monitor_list) | **GET** /setting/batchjobs | Get JobMonitor List
*LMApi* | [**get_log_source_by_id**](docs/LMApi.md#get_log_source_by_id) | **GET** /setting/logsources/{id} | get log source 
*LMApi* | [**get_log_source_list**](docs/LMApi.md#get_log_source_list) | **GET** /setting/logsources | get log source list
*LMApi* | [**get_metrics_usage**](docs/LMApi.md#get_metrics_usage) | **GET** /metrics/usage | get metrics usage
*LMApi* | [**get_netflow_endpoint_list**](docs/LMApi.md#get_netflow_endpoint_list) | **GET** /device/devices/{id}/endpoints | get netflow endpoints
*LMApi* | [**get_netflow_flow_list**](docs/LMApi.md#get_netflow_flow_list) | **GET** /device/devices/{id}/flows | get netflow flows
*LMApi* | [**get_netflow_port_list**](docs/LMApi.md#get_netflow_port_list) | **GET** /device/devices/{id}/ports | get netflow ports
*LMApi* | [**get_netscan_by_id**](docs/LMApi.md#get_netscan_by_id) | **GET** /setting/netscans/{id} | get netscan by id
*LMApi* | [**get_netscan_list**](docs/LMApi.md#get_netscan_list) | **GET** /setting/netscans | get netscan list
*LMApi* | [**get_oid_by_id**](docs/LMApi.md#get_oid_by_id) | **GET** /setting/oids/{id} | get OID by id
*LMApi* | [**get_oid_list**](docs/LMApi.md#get_oid_list) | **GET** /setting/oids | get OID&#x27;s list
*LMApi* | [**get_ops_note_by_id**](docs/LMApi.md#get_ops_note_by_id) | **GET** /setting/opsnotes/{id} | get opsnote by id
*LMApi* | [**get_ops_note_list**](docs/LMApi.md#get_ops_note_list) | **GET** /setting/opsnotes | get opsnote list
*LMApi* | [**get_partition_by_id**](docs/LMApi.md#get_partition_by_id) | **GET** /log/partitions/{id} | Retrieve details of a specific log partition
*LMApi* | [**get_property_rules_by_id**](docs/LMApi.md#get_property_rules_by_id) | **GET** /setting/propertyrules/{id} | get property rules by id
*LMApi* | [**get_property_rules_list**](docs/LMApi.md#get_property_rules_list) | **GET** /setting/propertyrules | get property rules list
*LMApi* | [**get_recipient_group_by_id**](docs/LMApi.md#get_recipient_group_by_id) | **GET** /setting/recipientgroups/{id} | get recipient group by id
*LMApi* | [**get_recipient_group_list**](docs/LMApi.md#get_recipient_group_list) | **GET** /setting/recipientgroups | get recipient group List
*LMApi* | [**get_report_by_id**](docs/LMApi.md#get_report_by_id) | **GET** /report/reports/{id} | get report by id
*LMApi* | [**get_report_group_by_id**](docs/LMApi.md#get_report_group_by_id) | **GET** /report/groups/{id} | get report group by id
*LMApi* | [**get_report_group_list**](docs/LMApi.md#get_report_group_list) | **GET** /report/groups | get report group list
*LMApi* | [**get_report_list**](docs/LMApi.md#get_report_list) | **GET** /report/reports | get report list
*LMApi* | [**get_retention_list**](docs/LMApi.md#get_retention_list) | **GET** /log/partitions/retentions | Retrieve the list of log retentions
*LMApi* | [**get_role_by_id**](docs/LMApi.md#get_role_by_id) | **GET** /setting/roles/{id} | get role by id
*LMApi* | [**get_role_list**](docs/LMApi.md#get_role_list) | **GET** /setting/roles | get role list
*LMApi* | [**get_sdt_by_id**](docs/LMApi.md#get_sdt_by_id) | **GET** /sdt/sdts/{id} | get SDT by id (Response may contain extra fields depending upon the type of SDT of given id)
*LMApi* | [**get_sdt_history_by_device_data_source_id**](docs/LMApi.md#get_sdt_history_by_device_data_source_id) | **GET** /device/devices/{deviceId}/devicedatasources/{id}/historysdts | get SDT history for the device dataSource
*LMApi* | [**get_sdt_history_by_device_group_id**](docs/LMApi.md#get_sdt_history_by_device_group_id) | **GET** /device/groups/{id}/historysdts | get SDT history for the group
*LMApi* | [**get_sdt_history_by_device_id**](docs/LMApi.md#get_sdt_history_by_device_id) | **GET** /device/devices/{id}/historysdts | get SDT history for the device
*LMApi* | [**get_sdt_history_by_website_group_id**](docs/LMApi.md#get_sdt_history_by_website_group_id) | **GET** /website/groups/{id}/historysdts | get SDT history for the website group (Response may contain extra fields depending upon the type of SDT)
*LMApi* | [**get_sdt_history_by_website_id**](docs/LMApi.md#get_sdt_history_by_website_id) | **GET** /website/websites/{id}/historysdts | get SDT history for the website (Response may contain extra fields depending upon the type of SDT)
*LMApi* | [**get_sdt_list**](docs/LMApi.md#get_sdt_list) | **GET** /sdt/sdts | get SDT list
*LMApi* | [**get_site_monitor_check_point_list**](docs/LMApi.md#get_site_monitor_check_point_list) | **GET** /website/smcheckpoints | get website checkpoint list
*LMApi* | [**get_top_talkers_graph**](docs/LMApi.md#get_top_talkers_graph) | **GET** /device/devices/{id}/topTalkersGraph | get top talkers graph
*LMApi* | [**get_topology_source_by_id**](docs/LMApi.md#get_topology_source_by_id) | **GET** /setting/topologysources/{id} | Get TopologySource by id
*LMApi* | [**get_topology_source_list**](docs/LMApi.md#get_topology_source_list) | **GET** /setting/topologysources | Get TopologySource List
*LMApi* | [**get_unmonitored_device_list**](docs/LMApi.md#get_unmonitored_device_list) | **GET** /device/unmonitoreddevices | get unmonitored device list
*LMApi* | [**get_update_reason_list_by_config_source_id**](docs/LMApi.md#get_update_reason_list_by_config_source_id) | **GET** /setting/configsources/{id}/updatereasons | get update history for a configSource
*LMApi* | [**get_update_reason_list_by_data_source_id**](docs/LMApi.md#get_update_reason_list_by_data_source_id) | **GET** /setting/datasources/{id}/updatereasons | get update history for a datasource
*LMApi* | [**get_v4_metadata**](docs/LMApi.md#get_v4_metadata) | **GET** /setting/logicmodules/metadata | get metadata
*LMApi* | [**get_website_alert_list_by_website_id**](docs/LMApi.md#get_website_alert_list_by_website_id) | **GET** /website/websites/{id}/alerts | get alerts for a website
*LMApi* | [**get_website_by_id**](docs/LMApi.md#get_website_by_id) | **GET** /website/websites/{id} | get website by id
*LMApi* | [**get_website_checkpoint_data_by_id**](docs/LMApi.md#get_website_checkpoint_data_by_id) | **GET** /website/websites/{srvId}/checkpoints/{checkId}/data | get data for a website checkpoint
*LMApi* | [**get_website_data_by_graph_name**](docs/LMApi.md#get_website_data_by_graph_name) | **GET** /website/websites/{id}/graphs/{graphName}/data | get website data by graph name
*LMApi* | [**get_website_graph_data**](docs/LMApi.md#get_website_graph_data) | **GET** /website/websites/{websiteId}/checkpoints/{checkpointId}/graphs/{graphName}/data | get website graph data
*LMApi* | [**get_website_group_by_id**](docs/LMApi.md#get_website_group_by_id) | **GET** /website/groups/{id} | get website group
*LMApi* | [**get_website_group_list**](docs/LMApi.md#get_website_group_list) | **GET** /website/groups | get website group list
*LMApi* | [**get_website_list**](docs/LMApi.md#get_website_list) | **GET** /website/websites | get website list
*LMApi* | [**get_website_property_list_by_website_id**](docs/LMApi.md#get_website_property_list_by_website_id) | **GET** /website/websites/{id}/properties | get a list of properties for a website
*LMApi* | [**get_website_sdt_list_by_website_id**](docs/LMApi.md#get_website_sdt_list_by_website_id) | **GET** /website/websites/{id}/sdts | get a list of SDTs for a website
*LMApi* | [**get_widget_by_id**](docs/LMApi.md#get_widget_by_id) | **GET** /dashboard/widgets/{id} | get widget by id (Based upon widget type the response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
*LMApi* | [**get_widget_data_by_id**](docs/LMApi.md#get_widget_data_by_id) | **GET** /dashboard/widgets/{id}/data | get widget data (Based upon widget type the response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
*LMApi* | [**get_widget_list**](docs/LMApi.md#get_widget_list) | **GET** /dashboard/widgets | get widget list (Based upon widget type the response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
*LMApi* | [**get_widget_list_by_dashboard_id**](docs/LMApi.md#get_widget_list_by_dashboard_id) | **GET** /dashboard/dashboards/{id}/widgets | get widget list by DashboardId
*LMApi* | [**import_batch_job**](docs/LMApi.md#import_batch_job) | **POST** /setting/batchjobs/importxml | import batch job via xml
*LMApi* | [**import_config_source**](docs/LMApi.md#import_config_source) | **POST** /setting/configsources/importxml | import config source via xml
*LMApi* | [**import_data_source**](docs/LMApi.md#import_data_source) | **POST** /setting/datasources/importxml | import datasource via xml
*LMApi* | [**import_event_source**](docs/LMApi.md#import_event_source) | **POST** /setting/eventsources/importxml | import eventsource via xml
*LMApi* | [**map_un_map_module_to_access_group**](docs/LMApi.md#map_un_map_module_to_access_group) | **POST** /setting/accessgroup/mapunmap/modules | Create a mapping of access group &amp; module
*LMApi* | [**partition_action**](docs/LMApi.md#partition_action) | **POST** /log/partitions/{id}/{action} | Perform an action on a specified log partition
*LMApi* | [**patch_access_group**](docs/LMApi.md#patch_access_group) | **PATCH** /setting/accessgroup/{id} | Update access group
*LMApi* | [**patch_admin_by_id**](docs/LMApi.md#patch_admin_by_id) | **PATCH** /setting/admins/{id} | update user
*LMApi* | [**patch_alert_rule_by_id**](docs/LMApi.md#patch_alert_rule_by_id) | **PATCH** /setting/alert/rules/{id} | update alert rule
*LMApi* | [**patch_api_token_by_admin_id**](docs/LMApi.md#patch_api_token_by_admin_id) | **PATCH** /setting/admins/{adminId}/apitokens/{apitokenId} | update api tokens for a user
*LMApi* | [**patch_applies_to_function**](docs/LMApi.md#patch_applies_to_function) | **PATCH** /setting/functions/{id} | update applies to function
*LMApi* | [**patch_collector_by_id**](docs/LMApi.md#patch_collector_by_id) | **PATCH** /setting/collector/collectors/{id} | update collector
*LMApi* | [**patch_collector_group_by_id**](docs/LMApi.md#patch_collector_group_by_id) | **PATCH** /setting/collector/groups/{id} | update collector group
*LMApi* | [**patch_config_source_by_id**](docs/LMApi.md#patch_config_source_by_id) | **PATCH** /setting/configsources/{id} | update config source by id
*LMApi* | [**patch_dashboard_by_id**](docs/LMApi.md#patch_dashboard_by_id) | **PATCH** /dashboard/dashboards/{id} | update dashboard
*LMApi* | [**patch_dashboard_group_by_id**](docs/LMApi.md#patch_dashboard_group_by_id) | **PATCH** /dashboard/groups/{id} | update dashboard group
*LMApi* | [**patch_datasource_by_id**](docs/LMApi.md#patch_datasource_by_id) | **PATCH** /setting/datasources/{id} | update datasource
*LMApi* | [**patch_default_dashboard**](docs/LMApi.md#patch_default_dashboard) | **PATCH** /setting/userdata/{id} | update default dashboard
*LMApi* | [**patch_device**](docs/LMApi.md#patch_device) | **PATCH** /device/devices/{id} | update a device
*LMApi* | [**patch_device_datasource_instance_alert_setting_by_id**](docs/LMApi.md#patch_device_datasource_instance_alert_setting_by_id) | **PATCH** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/alertsettings/{id} | update device instance alert setting
*LMApi* | [**patch_device_datasource_instance_by_id**](docs/LMApi.md#patch_device_datasource_instance_by_id) | **PATCH** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{id} | update device instance
*LMApi* | [**patch_device_datasource_instance_group_by_id**](docs/LMApi.md#patch_device_datasource_instance_group_by_id) | **PATCH** /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id} | update device datasource instance group
*LMApi* | [**patch_device_group_by_id**](docs/LMApi.md#patch_device_group_by_id) | **PATCH** /device/groups/{id} | update device group
*LMApi* | [**patch_device_group_cluster_alert_conf_by_id**](docs/LMApi.md#patch_device_group_cluster_alert_conf_by_id) | **PATCH** /device/groups/{deviceGroupId}/clusterAlertConf/{id} | Update cluster alert configuration
*LMApi* | [**patch_device_group_datasource_alert_setting**](docs/LMApi.md#patch_device_group_datasource_alert_setting) | **PATCH** /device/groups/{deviceGroupId}/datasources/{dsId}/alertsettings | update device group datasource alert setting
*LMApi* | [**patch_device_group_datasource_by_id**](docs/LMApi.md#patch_device_group_datasource_by_id) | **PATCH** /device/groups/{deviceGroupId}/datasources/{id} | update device group datasource
*LMApi* | [**patch_device_group_property_by_name**](docs/LMApi.md#patch_device_group_property_by_name) | **PATCH** /device/groups/{gid}/properties/{name} | update device group property
*LMApi* | [**patch_device_property_by_name**](docs/LMApi.md#patch_device_property_by_name) | **PATCH** /device/devices/{deviceId}/properties/{name} | update device property
*LMApi* | [**patch_escalation_chain_by_id**](docs/LMApi.md#patch_escalation_chain_by_id) | **PATCH** /setting/alert/chains/{id} | update escalation chain
*LMApi* | [**patch_event_source_by_id**](docs/LMApi.md#patch_event_source_by_id) | **PATCH** /setting/eventsources/{id} | update eventSource by id
*LMApi* | [**patch_job_monitor**](docs/LMApi.md#patch_job_monitor) | **PATCH** /setting/batchjobs/{id} | Update JobMonitor
*LMApi* | [**patch_log_partition**](docs/LMApi.md#patch_log_partition) | **PATCH** /log/partitions | Update an existing log partition
*LMApi* | [**patch_log_source**](docs/LMApi.md#patch_log_source) | **PATCH** /setting/logsources/{id} | update log source 
*LMApi* | [**patch_netscan**](docs/LMApi.md#patch_netscan) | **PATCH** /setting/netscans/{id} | update a netscan
*LMApi* | [**patch_oid**](docs/LMApi.md#patch_oid) | **PATCH** /setting/oids/{id} | update a OID
*LMApi* | [**patch_ops_note_by_id**](docs/LMApi.md#patch_ops_note_by_id) | **PATCH** /setting/opsnotes/{id} | update opsnote
*LMApi* | [**patch_property_rule**](docs/LMApi.md#patch_property_rule) | **PATCH** /setting/propertyrules/{id} | update a property rule
*LMApi* | [**patch_recipient_group_by_id**](docs/LMApi.md#patch_recipient_group_by_id) | **PATCH** /setting/recipientgroups/{id} | update recipient group
*LMApi* | [**patch_report_by_id**](docs/LMApi.md#patch_report_by_id) | **PATCH** /report/reports/{id} | update report
*LMApi* | [**patch_report_group_by_id**](docs/LMApi.md#patch_report_group_by_id) | **PATCH** /report/groups/{id} | update report group
*LMApi* | [**patch_role_by_id**](docs/LMApi.md#patch_role_by_id) | **PATCH** /setting/roles/{id} | update role
*LMApi* | [**patch_sdt_by_id**](docs/LMApi.md#patch_sdt_by_id) | **PATCH** /sdt/sdts/{id} | update SDT (Response may contain extra fields depending upon the type of SDT being updated)
*LMApi* | [**patch_topology_source**](docs/LMApi.md#patch_topology_source) | **PATCH** /setting/topologysources/{id} | Update TopologySource
*LMApi* | [**patch_website_by_id**](docs/LMApi.md#patch_website_by_id) | **PATCH** /website/websites/{id} | update website
*LMApi* | [**patch_website_group_by_id**](docs/LMApi.md#patch_website_group_by_id) | **PATCH** /website/groups/{id} | update website group
*LMApi* | [**patch_widget_by_id**](docs/LMApi.md#patch_widget_by_id) | **PATCH** /dashboard/widgets/{id} | update widget (Based upon widget type the request and response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
*LMApi* | [**schedule_auto_discovery_by_device_id**](docs/LMApi.md#schedule_auto_discovery_by_device_id) | **POST** /device/devices/{id}/scheduleAutoDiscovery | schedule active discovery for a device
*LMApi* | [**test_aws_account**](docs/LMApi.md#test_aws_account) | **POST** /aws/functions/testAccount | test AWS account
*LMApi* | [**test_azure_account**](docs/LMApi.md#test_azure_account) | **POST** /azure/functions/testAccount | test Azure account
*LMApi* | [**test_gcp_account**](docs/LMApi.md#test_gcp_account) | **POST** /gcp/functions/testAccount | test GCP account
*LMApi* | [**test_saa_s_account**](docs/LMApi.md#test_saa_s_account) | **POST** /saas/functions/testAccount | test SaaS account
*LMApi* | [**update_access_group**](docs/LMApi.md#update_access_group) | **PUT** /setting/accessgroup/{id} | Update access group
*LMApi* | [**update_admin_by_id**](docs/LMApi.md#update_admin_by_id) | **PUT** /setting/admins/{id} | update user
*LMApi* | [**update_alert_rule_by_id**](docs/LMApi.md#update_alert_rule_by_id) | **PUT** /setting/alert/rules/{id} | update alert rule
*LMApi* | [**update_api_token_by_admin_id**](docs/LMApi.md#update_api_token_by_admin_id) | **PUT** /setting/admins/{adminId}/apitokens/{apitokenId} | update api tokens for a user
*LMApi* | [**update_applies_to_function**](docs/LMApi.md#update_applies_to_function) | **PUT** /setting/functions/{id} | update applies to function
*LMApi* | [**update_collector_by_id**](docs/LMApi.md#update_collector_by_id) | **PUT** /setting/collector/collectors/{id} | update collector
*LMApi* | [**update_collector_group_by_id**](docs/LMApi.md#update_collector_group_by_id) | **PUT** /setting/collector/groups/{id} | update collector group
*LMApi* | [**update_config_source_by_id**](docs/LMApi.md#update_config_source_by_id) | **PUT** /setting/configsources/{id} | update config source by id
*LMApi* | [**update_dashboard_by_id**](docs/LMApi.md#update_dashboard_by_id) | **PUT** /dashboard/dashboards/{id} | update dashboard
*LMApi* | [**update_dashboard_group_by_id**](docs/LMApi.md#update_dashboard_group_by_id) | **PUT** /dashboard/groups/{id} | update dashboard group
*LMApi* | [**update_datasource_by_id**](docs/LMApi.md#update_datasource_by_id) | **PUT** /setting/datasources/{id} | update datasource
*LMApi* | [**update_default_dashboard**](docs/LMApi.md#update_default_dashboard) | **PUT** /setting/userdata/{id} | update default dashboard
*LMApi* | [**update_device**](docs/LMApi.md#update_device) | **PUT** /device/devices/{id} | update a device
*LMApi* | [**update_device_datasource_instance_alert_setting_by_id**](docs/LMApi.md#update_device_datasource_instance_alert_setting_by_id) | **PUT** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/alertsettings/{id} | update device instance alert setting
*LMApi* | [**update_device_datasource_instance_by_id**](docs/LMApi.md#update_device_datasource_instance_by_id) | **PUT** /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{id} | update device instance
*LMApi* | [**update_device_datasource_instance_group_by_id**](docs/LMApi.md#update_device_datasource_instance_group_by_id) | **PUT** /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id} | update device datasource instance group
*LMApi* | [**update_device_group_by_id**](docs/LMApi.md#update_device_group_by_id) | **PUT** /device/groups/{id} | update device group
*LMApi* | [**update_device_group_cluster_alert_conf_by_id**](docs/LMApi.md#update_device_group_cluster_alert_conf_by_id) | **PUT** /device/groups/{deviceGroupId}/clusterAlertConf/{id} | Update cluster alert configuration
*LMApi* | [**update_device_group_datasource_alert_setting**](docs/LMApi.md#update_device_group_datasource_alert_setting) | **PUT** /device/groups/{deviceGroupId}/datasources/{dsId}/alertsettings | update device group datasource alert setting
*LMApi* | [**update_device_group_datasource_by_id**](docs/LMApi.md#update_device_group_datasource_by_id) | **PUT** /device/groups/{deviceGroupId}/datasources/{id} | update device group datasource
*LMApi* | [**update_device_group_property_by_name**](docs/LMApi.md#update_device_group_property_by_name) | **PUT** /device/groups/{gid}/properties/{name} | update device group property
*LMApi* | [**update_device_property_by_name**](docs/LMApi.md#update_device_property_by_name) | **PUT** /device/devices/{deviceId}/properties/{name} | update device property
*LMApi* | [**update_escalation_chain_by_id**](docs/LMApi.md#update_escalation_chain_by_id) | **PUT** /setting/alert/chains/{id} | update escalation chain
*LMApi* | [**update_event_source_by_id**](docs/LMApi.md#update_event_source_by_id) | **PUT** /setting/eventsources/{id} | update eventSource by id
*LMApi* | [**update_instance_group_alert_threshold**](docs/LMApi.md#update_instance_group_alert_threshold) | **PUT** /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{dsigId}/datapoints/{dpId}/alertconfig | update instance group alert threshold (Setting the threshold at default group is not allowed)
*LMApi* | [**update_job_monitor**](docs/LMApi.md#update_job_monitor) | **PUT** /setting/batchjobs/{id} | Update JobMonitor
*LMApi* | [**update_log_partition**](docs/LMApi.md#update_log_partition) | **PUT** /log/partitions | Update an existing log partition
*LMApi* | [**update_log_source**](docs/LMApi.md#update_log_source) | **PUT** /setting/logsources/{id} | update log source 
*LMApi* | [**update_netscan**](docs/LMApi.md#update_netscan) | **PUT** /setting/netscans/{id} | update a netscan
*LMApi* | [**update_oid**](docs/LMApi.md#update_oid) | **PUT** /setting/oids/{id} | update a OID
*LMApi* | [**update_ops_note_by_id**](docs/LMApi.md#update_ops_note_by_id) | **PUT** /setting/opsnotes/{id} | update opsnote
*LMApi* | [**update_property_rule**](docs/LMApi.md#update_property_rule) | **PUT** /setting/propertyrules/{id} | update a property rule
*LMApi* | [**update_recipient_group_by_id**](docs/LMApi.md#update_recipient_group_by_id) | **PUT** /setting/recipientgroups/{id} | update recipient group
*LMApi* | [**update_report_by_id**](docs/LMApi.md#update_report_by_id) | **PUT** /report/reports/{id} | update report
*LMApi* | [**update_report_group_by_id**](docs/LMApi.md#update_report_group_by_id) | **PUT** /report/groups/{id} | update report group
*LMApi* | [**update_role_by_id**](docs/LMApi.md#update_role_by_id) | **PUT** /setting/roles/{id} | update role
*LMApi* | [**update_sdt_by_id**](docs/LMApi.md#update_sdt_by_id) | **PUT** /sdt/sdts/{id} | update SDT (Response may contain extra fields depending upon the type of SDT being updated)
*LMApi* | [**update_topology_source**](docs/LMApi.md#update_topology_source) | **PUT** /setting/topologysources/{id} | Update TopologySource
*LMApi* | [**update_website_by_id**](docs/LMApi.md#update_website_by_id) | **PUT** /website/websites/{id} | update website
*LMApi* | [**update_website_group_by_id**](docs/LMApi.md#update_website_group_by_id) | **PUT** /website/groups/{id} | update website group
*LMApi* | [**update_widget_by_id**](docs/LMApi.md#update_widget_by_id) | **PUT** /dashboard/widgets/{id} | update widget (Based upon widget type the request and response may contain additional attributes. Please refer models corresponding to specific widget type at the bottom of this page to check the attributes)
*LMApi* | [**verify_aws_billing_permissions**](docs/LMApi.md#verify_aws_billing_permissions) | **POST** /aws/functions/verifyBillingPermissions | verify AWS Billing Permissions
*LMApi* | [**verify_storage_accounts_permissions**](docs/LMApi.md#verify_storage_accounts_permissions) | **POST** /azure/functions/verifyStorageAccountsPermissions | view storage accounts

## Documentation For Models

 - [APIToken](docs/APIToken.md)
 - [AccessGroup](docs/AccessGroup.md)
 - [AccessGroupPaginationResponse](docs/AccessGroupPaginationResponse.md)
 - [AccessLogPaginationResponse](docs/AccessLogPaginationResponse.md)
 - [AckCollectorDown](docs/AckCollectorDown.md)
 - [Admin](docs/Admin.md)
 - [AdminPaginationResponse](docs/AdminPaginationResponse.md)
 - [AggregateCollectorAttribute](docs/AggregateCollectorAttribute.md)
 - [Alert](docs/Alert.md)
 - [AlertAck](docs/AlertAck.md)
 - [AlertFilters](docs/AlertFilters.md)
 - [AlertForecastingReport](docs/AlertForecastingReport.md)
 - [AlertListPaginationResponse](docs/AlertListPaginationResponse.md)
 - [AlertPaginationResponse](docs/AlertPaginationResponse.md)
 - [AlertReport](docs/AlertReport.md)
 - [AlertResponse](docs/AlertResponse.md)
 - [AlertRule](docs/AlertRule.md)
 - [AlertRulePaginationResponse](docs/AlertRulePaginationResponse.md)
 - [AlertSlaReport](docs/AlertSlaReport.md)
 - [AlertThresholdReport](docs/AlertThresholdReport.md)
 - [AlertTrendsMetric](docs/AlertTrendsMetric.md)
 - [AlertTrendsReport](docs/AlertTrendsReport.md)
 - [AlertWidget](docs/AlertWidget.md)
 - [AlertWidgetData](docs/AlertWidgetData.md)
 - [ApiPerfMetrics](docs/ApiPerfMetrics.md)
 - [ApiTokenPaginationResponse](docs/ApiTokenPaginationResponse.md)
 - [AppliesToFunction](docs/AppliesToFunction.md)
 - [ArrayNode](docs/ArrayNode.md)
 - [ArubaCentralCollectorAttribute](docs/ArubaCentralCollectorAttribute.md)
 - [ArubaCentralIAPInterfaceDiscoveryMethod](docs/ArubaCentralIAPInterfaceDiscoveryMethod.md)
 - [ArubaCentralIAPNetworkDiscoveryMethod](docs/ArubaCentralIAPNetworkDiscoveryMethod.md)
 - [ArubaCentralIAPRadioDiscoveryMethod](docs/ArubaCentralIAPRadioDiscoveryMethod.md)
 - [Assignment](docs/Assignment.md)
 - [AuditLog](docs/AuditLog.md)
 - [AuditLogReport](docs/AuditLogReport.md)
 - [Authentication](docs/Authentication.md)
 - [AutoDiscoveryConfiguration](docs/AutoDiscoveryConfiguration.md)
 - [AutoDiscoveryFilter](docs/AutoDiscoveryFilter.md)
 - [AutoDiscoveryMethod](docs/AutoDiscoveryMethod.md)
 - [AutomaticUpgradeInfo](docs/AutomaticUpgradeInfo.md)
 - [AwsAccountId](docs/AwsAccountId.md)
 - [AwsAccountTestResult](docs/AwsAccountTestResult.md)
 - [AwsApiGatewayStageDiscoveryMethod](docs/AwsApiGatewayStageDiscoveryMethod.md)
 - [AwsAutoScalingServiceLimitsCollectorAttribute](docs/AwsAutoScalingServiceLimitsCollectorAttribute.md)
 - [AwsBillingCollectorAttribute](docs/AwsBillingCollectorAttribute.md)
 - [AwsBillingReportCollectorAttribute](docs/AwsBillingReportCollectorAttribute.md)
 - [AwsBillingReportDiscoveryMethod](docs/AwsBillingReportDiscoveryMethod.md)
 - [AwsClassicElbServiceLimitsCollectorAttribute](docs/AwsClassicElbServiceLimitsCollectorAttribute.md)
 - [AwsCloudWatchCollectorAttribute](docs/AwsCloudWatchCollectorAttribute.md)
 - [AwsCognitoIdentityProvidersDiscoveryMethodV3](docs/AwsCognitoIdentityProvidersDiscoveryMethodV3.md)
 - [AwsEC2ReservedInstanceCollectorAttribute](docs/AwsEC2ReservedInstanceCollectorAttribute.md)
 - [AwsEC2ReservedInstanceDiscoveryMethod](docs/AwsEC2ReservedInstanceDiscoveryMethod.md)
 - [AwsEC2ScheduledEventsCollectorAttribute](docs/AwsEC2ScheduledEventsCollectorAttribute.md)
 - [AwsEbsVolumeSnapshotCollectorAttributeV3](docs/AwsEbsVolumeSnapshotCollectorAttributeV3.md)
 - [AwsEc2ServiceLimitsCollectorAttribute](docs/AwsEc2ServiceLimitsCollectorAttribute.md)
 - [AwsEcsServiceDetailsCollectorAttribute](docs/AwsEcsServiceDetailsCollectorAttribute.md)
 - [AwsEcsServiceDiscoveryMethod](docs/AwsEcsServiceDiscoveryMethod.md)
 - [AwsElastiCacheDiscoveryMethod](docs/AwsElastiCacheDiscoveryMethod.md)
 - [AwsExternalId](docs/AwsExternalId.md)
 - [AwsGlobalNetworkAttachmentMethod](docs/AwsGlobalNetworkAttachmentMethod.md)
 - [AwsGlobalNetworkDeviceMethod](docs/AwsGlobalNetworkDeviceMethod.md)
 - [AwsGlobalNetworkEdgeMethod](docs/AwsGlobalNetworkEdgeMethod.md)
 - [AwsGlobalNetworkLinkMethod](docs/AwsGlobalNetworkLinkMethod.md)
 - [AwsGlobalWebACLDiscoveryMethodV3](docs/AwsGlobalWebACLDiscoveryMethodV3.md)
 - [AwsLBTargetGroupDiscoveryMethod](docs/AwsLBTargetGroupDiscoveryMethod.md)
 - [AwsMediaConnectOutputDiscoveryMethod](docs/AwsMediaConnectOutputDiscoveryMethod.md)
 - [AwsMediaConnectSourceDiscoveryMethod](docs/AwsMediaConnectSourceDiscoveryMethod.md)
 - [AwsRdsPerformanceInsightsCollectorAttribute](docs/AwsRdsPerformanceInsightsCollectorAttribute.md)
 - [AwsRdsServiceLimitsCollectorAttributeV3](docs/AwsRdsServiceLimitsCollectorAttributeV3.md)
 - [AwsRedShiftDiscoveryMethod](docs/AwsRedShiftDiscoveryMethod.md)
 - [AwsRoute53ResolverIPAddressCollectorAttribute](docs/AwsRoute53ResolverIPAddressCollectorAttribute.md)
 - [AwsRoute53ResolverIPAddressDiscoveryMethod](docs/AwsRoute53ResolverIPAddressDiscoveryMethod.md)
 - [AwsRssEventSource](docs/AwsRssEventSource.md)
 - [AwsSageMakerEndpointVariantMethod](docs/AwsSageMakerEndpointVariantMethod.md)
 - [AwsServiceLimitsFromTrustedAdvisorCollectorAttribute](docs/AwsServiceLimitsFromTrustedAdvisorCollectorAttribute.md)
 - [AwsServiceRegionDiscoveryMethod](docs/AwsServiceRegionDiscoveryMethod.md)
 - [AwsSesServiceLimitsCollectorAttribute](docs/AwsSesServiceLimitsCollectorAttribute.md)
 - [AwsVpnTunnelDiscoveryMethodV3](docs/AwsVpnTunnelDiscoveryMethodV3.md)
 - [AwsWebACLWafV2DiscoveryMethod](docs/AwsWebACLWafV2DiscoveryMethod.md)
 - [AzureAccountTestResult](docs/AzureAccountTestResult.md)
 - [AzureActiveDirectoryAppSecretCollectorAttribute](docs/AzureActiveDirectoryAppSecretCollectorAttribute.md)
 - [AzureActiveDirectoryAppSecretDiscoveryMethod](docs/AzureActiveDirectoryAppSecretDiscoveryMethod.md)
 - [AzureActiveDirectorySyncCollectorAttribute](docs/AzureActiveDirectorySyncCollectorAttribute.md)
 - [AzureActiveDirectoryUsersCollectorAttribute](docs/AzureActiveDirectoryUsersCollectorAttribute.md)
 - [AzureAppServiceEnvironmentMultiRolePoolCollectorAttributeV3](docs/AzureAppServiceEnvironmentMultiRolePoolCollectorAttributeV3.md)
 - [AzureAppServiceEnvironmentMultiRolePoolDiscoverMethod](docs/AzureAppServiceEnvironmentMultiRolePoolDiscoverMethod.md)
 - [AzureAuthenticationAttribute](docs/AzureAuthenticationAttribute.md)
 - [AzureAutomationAccountCertificateCollectorAttributeV3](docs/AzureAutomationAccountCertificateCollectorAttributeV3.md)
 - [AzureAutomationAccountCertificateDiscoveryMethod](docs/AzureAutomationAccountCertificateDiscoveryMethod.md)
 - [AzureBackupJobCollectorAttributeV3](docs/AzureBackupJobCollectorAttributeV3.md)
 - [AzureBackupJobDiscoveryMethod](docs/AzureBackupJobDiscoveryMethod.md)
 - [AzureBackupProtectedItemBackupJobCollectorAttribute](docs/AzureBackupProtectedItemBackupJobCollectorAttribute.md)
 - [AzureBackupProtectedItemBackupJobDiscoveryMethod](docs/AzureBackupProtectedItemBackupJobDiscoveryMethod.md)
 - [AzureBackupProtectedItemHealthCollectorAttribute](docs/AzureBackupProtectedItemHealthCollectorAttribute.md)
 - [AzureBillingCollectorAttribute](docs/AzureBillingCollectorAttribute.md)
 - [AzureBillingDiscoveryMethod](docs/AzureBillingDiscoveryMethod.md)
 - [AzureCostManagementCollectorAttribute](docs/AzureCostManagementCollectorAttribute.md)
 - [AzureCostManagementDimensionsDiscoveryMethod](docs/AzureCostManagementDimensionsDiscoveryMethod.md)
 - [AzureCostManagementSubscriptionsDiscoveryMethod](docs/AzureCostManagementSubscriptionsDiscoveryMethod.md)
 - [AzureCostManagementTagsDiscoveryMethod](docs/AzureCostManagementTagsDiscoveryMethod.md)
 - [AzureDimensionDiscoveryMethod](docs/AzureDimensionDiscoveryMethod.md)
 - [AzureEABillingCollectorAttribute](docs/AzureEABillingCollectorAttribute.md)
 - [AzureEABillingDiscoveryMethodV3](docs/AzureEABillingDiscoveryMethodV3.md)
 - [AzureEmergingIssueEventSource](docs/AzureEmergingIssueEventSource.md)
 - [AzureExpressRouteCircuitPeeringCollectorAttributeV3](docs/AzureExpressRouteCircuitPeeringCollectorAttributeV3.md)
 - [AzureExpressRouteCircuitPeeringDiscoveryMethod](docs/AzureExpressRouteCircuitPeeringDiscoveryMethod.md)
 - [AzureInsightsCollectorAttribute](docs/AzureInsightsCollectorAttribute.md)
 - [AzureLogAnalyticsReplicationJobCollectorAttribute](docs/AzureLogAnalyticsReplicationJobCollectorAttribute.md)
 - [AzureLogAnalyticsReplicationJobDiscoveryMethod](docs/AzureLogAnalyticsReplicationJobDiscoveryMethod.md)
 - [AzureLogAnalyticsWorkspacesCollectorAttribute](docs/AzureLogAnalyticsWorkspacesCollectorAttribute.md)
 - [AzureLogAnalyticsWorkspacesDiscoveryMethod](docs/AzureLogAnalyticsWorkspacesDiscoveryMethod.md)
 - [AzureNetAppVolumesDiscoveryMethod](docs/AzureNetAppVolumesDiscoveryMethod.md)
 - [AzureNetworkServiceLimitsCollectorAttribute](docs/AzureNetworkServiceLimitsCollectorAttribute.md)
 - [AzureRecoveryServiceRTOCollectorAttribute](docs/AzureRecoveryServiceRTOCollectorAttribute.md)
 - [AzureRecoveryServiceRTODiscoveryMethod](docs/AzureRecoveryServiceRTODiscoveryMethod.md)
 - [AzureRecoveryServiceVaultSRCollectorAttribute](docs/AzureRecoveryServiceVaultSRCollectorAttribute.md)
 - [AzureRecoveryServicesVaultAgentsCollectorAttribute](docs/AzureRecoveryServicesVaultAgentsCollectorAttribute.md)
 - [AzureRedisCacheDiscoveryMethod](docs/AzureRedisCacheDiscoveryMethod.md)
 - [AzureReplicationDisasterRecoveryCollectorAttribute](docs/AzureReplicationDisasterRecoveryCollectorAttribute.md)
 - [AzureReplicationJobCollectorAttributeV3](docs/AzureReplicationJobCollectorAttributeV3.md)
 - [AzureReplicationJobDiscoveryMethod](docs/AzureReplicationJobDiscoveryMethod.md)
 - [AzureResourceHealthCollectorAttribute](docs/AzureResourceHealthCollectorAttribute.md)
 - [AzureResourceUsageCollectorAttribute](docs/AzureResourceUsageCollectorAttribute.md)
 - [AzureRssEventSource](docs/AzureRssEventSource.md)
 - [AzureServiceBusQueue](docs/AzureServiceBusQueue.md)
 - [AzureServiceBusTopic](docs/AzureServiceBusTopic.md)
 - [AzureServiceRegionDiscoveryMethod](docs/AzureServiceRegionDiscoveryMethod.md)
 - [AzureStorageServiceLimitsCollectorAttribute](docs/AzureStorageServiceLimitsCollectorAttribute.md)
 - [AzureSubscriptionDiscoveryMethod](docs/AzureSubscriptionDiscoveryMethod.md)
 - [AzureSubscriptionIdPaginationResponse](docs/AzureSubscriptionIdPaginationResponse.md)
 - [AzureSynapseDiscoveryMethodV3](docs/AzureSynapseDiscoveryMethodV3.md)
 - [AzureUpdateManagerCollectorAttribute](docs/AzureUpdateManagerCollectorAttribute.md)
 - [AzureVMBackupStatusCollectorAttributeV3](docs/AzureVMBackupStatusCollectorAttributeV3.md)
 - [AzureVMBackupStatusLogAnalyticsCollectorAttribute](docs/AzureVMBackupStatusLogAnalyticsCollectorAttribute.md)
 - [AzureVMServiceLimitsCollectorAttribute](docs/AzureVMServiceLimitsCollectorAttribute.md)
 - [AzureVNGConnectionCollectorAttributeV3](docs/AzureVNGConnectionCollectorAttributeV3.md)
 - [AzureVNGConnectionDiscoveryMethod](docs/AzureVNGConnectionDiscoveryMethod.md)
 - [AzureVirtualDesktopHostPoolsCollectorAttributeV3](docs/AzureVirtualDesktopHostPoolsCollectorAttributeV3.md)
 - [AzureVirtualDesktopSessionHostsCollectorAttributeV3](docs/AzureVirtualDesktopSessionHostsCollectorAttributeV3.md)
 - [AzureVirtualDesktopSessionHostsDiscoveryMethod](docs/AzureVirtualDesktopSessionHostsDiscoveryMethod.md)
 - [AzureVwanVpnConnectionCollectorAttribute](docs/AzureVwanVpnConnectionCollectorAttribute.md)
 - [AzureVwanVpnConnectionMethod](docs/AzureVwanVpnConnectionMethod.md)
 - [AzureWebAppInstanceDiscoveryMethod](docs/AzureWebAppInstanceDiscoveryMethod.md)
 - [AzureWebJobCollectorAttributeV3](docs/AzureWebJobCollectorAttributeV3.md)
 - [AzureWebJobDiscoveryMethod](docs/AzureWebJobDiscoveryMethod.md)
 - [BasicAuthentication](docs/BasicAuthentication.md)
 - [BatchJob](docs/BatchJob.md)
 - [BatchJobExecutionItem](docs/BatchJobExecutionItem.md)
 - [BatchJobPaginationResponse](docs/BatchJobPaginationResponse.md)
 - [BatchJobWidget](docs/BatchJobWidget.md)
 - [BatchJobWidgetData](docs/BatchJobWidgetData.md)
 - [BatchScriptCollectorAttribute](docs/BatchScriptCollectorAttribute.md)
 - [BatchjobsImportxmlBody](docs/BatchjobsImportxmlBody.md)
 - [BigNumberData](docs/BigNumberData.md)
 - [BigNumberDataPoint](docs/BigNumberDataPoint.md)
 - [BigNumberInfo](docs/BigNumberInfo.md)
 - [BigNumberItem](docs/BigNumberItem.md)
 - [BigNumberWidget](docs/BigNumberWidget.md)
 - [BigNumberWidgetData](docs/BigNumberWidgetData.md)
 - [CIMAutoDiscoveryMethod](docs/CIMAutoDiscoveryMethod.md)
 - [CIMCollectorAttribute](docs/CIMCollectorAttribute.md)
 - [CellData](docs/CellData.md)
 - [Chain](docs/Chain.md)
 - [CloudRecommendation](docs/CloudRecommendation.md)
 - [CloudWatchAutoDiscoveryMethod](docs/CloudWatchAutoDiscoveryMethod.md)
 - [Collector](docs/Collector.md)
 - [CollectorAttribute](docs/CollectorAttribute.md)
 - [CollectorAutoDiscoveryMethod](docs/CollectorAutoDiscoveryMethod.md)
 - [CollectorBase](docs/CollectorBase.md)
 - [CollectorGroup](docs/CollectorGroup.md)
 - [CollectorGroupPaginationResponse](docs/CollectorGroupPaginationResponse.md)
 - [CollectorPaginationResponse](docs/CollectorPaginationResponse.md)
 - [CollectorSDT](docs/CollectorSDT.md)
 - [CollectorVersion](docs/CollectorVersion.md)
 - [CollectorVersionPaginationResponse](docs/CollectorVersionPaginationResponse.md)
 - [ColorThreshold](docs/ColorThreshold.md)
 - [ColumnHeader](docs/ColumnHeader.md)
 - [ConfigCheck](docs/ConfigCheck.md)
 - [ConfigSource](docs/ConfigSource.md)
 - [ConfigSourceUpdateReasonsPaginationResponse](docs/ConfigSourceUpdateReasonsPaginationResponse.md)
 - [ConfigsourcePaginationResponse](docs/ConfigsourcePaginationResponse.md)
 - [ConfigsourcesImportxmlBody](docs/ConfigsourcesImportxmlBody.md)
 - [ConversationFilter](docs/ConversationFilter.md)
 - [Counter](docs/Counter.md)
 - [CustomFlexibleVirtualDataSourceEx](docs/CustomFlexibleVirtualDataSourceEx.md)
 - [CustomGraph](docs/CustomGraph.md)
 - [CustomGraphWidget](docs/CustomGraphWidget.md)
 - [CustomReport](docs/CustomReport.md)
 - [CustomVirtualDataPoint](docs/CustomVirtualDataPoint.md)
 - [DNSCollectorAttribute](docs/DNSCollectorAttribute.md)
 - [Dashboard](docs/Dashboard.md)
 - [DashboardData](docs/DashboardData.md)
 - [DashboardGroup](docs/DashboardGroup.md)
 - [DashboardGroupPaginationResponse](docs/DashboardGroupPaginationResponse.md)
 - [DashboardPaginationResponse](docs/DashboardPaginationResponse.md)
 - [DashboardReport](docs/DashboardReport.md)
 - [DataPoint](docs/DataPoint.md)
 - [DataPumpCollectorAttribute](docs/DataPumpCollectorAttribute.md)
 - [DataSource](docs/DataSource.md)
 - [DataSourceAttribute](docs/DataSourceAttribute.md)
 - [DataSourceOverviewGraph](docs/DataSourceOverviewGraph.md)
 - [DataSourceUpdateReasonsPaginationResponse](docs/DataSourceUpdateReasonsPaginationResponse.md)
 - [DatapointFilterItem](docs/DatapointFilterItem.md)
 - [DatasourceOverviewGraphPaginationResponse](docs/DatasourceOverviewGraphPaginationResponse.md)
 - [DatasourcePaginationResponse](docs/DatasourcePaginationResponse.md)
 - [DatasourcesImportxmlBody](docs/DatasourcesImportxmlBody.md)
 - [DaysUntilAlert](docs/DaysUntilAlert.md)
 - [Debug](docs/Debug.md)
 - [Device](docs/Device.md)
 - [DeviceBatchJobSDT](docs/DeviceBatchJobSDT.md)
 - [DeviceClusterAlertConfig](docs/DeviceClusterAlertConfig.md)
 - [DeviceClusterAlertConfigPaginationResponse](docs/DeviceClusterAlertConfigPaginationResponse.md)
 - [DeviceClusterAlertDefSDT](docs/DeviceClusterAlertDefSDT.md)
 - [DeviceDataSource](docs/DeviceDataSource.md)
 - [DeviceDataSourceAssociated](docs/DeviceDataSourceAssociated.md)
 - [DeviceDataSourceAssociatedInstance](docs/DeviceDataSourceAssociatedInstance.md)
 - [DeviceDataSourceAssociatedPaginationResponse](docs/DeviceDataSourceAssociatedPaginationResponse.md)
 - [DeviceDataSourceData](docs/DeviceDataSourceData.md)
 - [DeviceDataSourceInstance](docs/DeviceDataSourceInstance.md)
 - [DeviceDataSourceInstanceAlertSetting](docs/DeviceDataSourceInstanceAlertSetting.md)
 - [DeviceDataSourceInstanceAlertSettingPaginationResponse](docs/DeviceDataSourceInstanceAlertSettingPaginationResponse.md)
 - [DeviceDataSourceInstanceConfig](docs/DeviceDataSourceInstanceConfig.md)
 - [DeviceDataSourceInstanceConfigAlert](docs/DeviceDataSourceInstanceConfigAlert.md)
 - [DeviceDataSourceInstanceConfigDiff](docs/DeviceDataSourceInstanceConfigDiff.md)
 - [DeviceDataSourceInstanceData](docs/DeviceDataSourceInstanceData.md)
 - [DeviceDataSourceInstanceGroup](docs/DeviceDataSourceInstanceGroup.md)
 - [DeviceDataSourceInstanceGroupSDT](docs/DeviceDataSourceInstanceGroupSDT.md)
 - [DeviceDataSourceInstanceSDT](docs/DeviceDataSourceInstanceSDT.md)
 - [DeviceDataSourceSDT](docs/DeviceDataSourceSDT.md)
 - [DeviceDataSourceSDTHistoryPaginationResponse](docs/DeviceDataSourceSDTHistoryPaginationResponse.md)
 - [DeviceDatasourceGraph](docs/DeviceDatasourceGraph.md)
 - [DeviceDatasourceInstanceConfigPaginationResponse](docs/DeviceDatasourceInstanceConfigPaginationResponse.md)
 - [DeviceDatasourceInstanceGroupPaginationResponse](docs/DeviceDatasourceInstanceGroupPaginationResponse.md)
 - [DeviceDatasourceInstancePaginationResponse](docs/DeviceDatasourceInstancePaginationResponse.md)
 - [DeviceDatasourcePaginationResponse](docs/DeviceDatasourcePaginationResponse.md)
 - [DeviceDeltaPaginationResponse](docs/DeviceDeltaPaginationResponse.md)
 - [DeviceEventSourceSDT](docs/DeviceEventSourceSDT.md)
 - [DeviceFilter](docs/DeviceFilter.md)
 - [DeviceGroup](docs/DeviceGroup.md)
 - [DeviceGroupAlertThresholdInfo](docs/DeviceGroupAlertThresholdInfo.md)
 - [DeviceGroupData](docs/DeviceGroupData.md)
 - [DeviceGroupDataSource](docs/DeviceGroupDataSource.md)
 - [DeviceGroupDataSourceAlertConfig](docs/DeviceGroupDataSourceAlertConfig.md)
 - [DeviceGroupDataSourceDataPointConfig](docs/DeviceGroupDataSourceDataPointConfig.md)
 - [DeviceGroupDatasourcePaginationResponse](docs/DeviceGroupDatasourcePaginationResponse.md)
 - [DeviceGroupPaginationResponse](docs/DeviceGroupPaginationResponse.md)
 - [DeviceGroupSDTHistoryPaginationResponse](docs/DeviceGroupSDTHistoryPaginationResponse.md)
 - [DeviceInstanceData](docs/DeviceInstanceData.md)
 - [DeviceInstanceDataPaginationResponse](docs/DeviceInstanceDataPaginationResponse.md)
 - [DeviceInstances](docs/DeviceInstances.md)
 - [DeviceLogPipeLineResourceSDT](docs/DeviceLogPipeLineResourceSDT.md)
 - [DeviceNOCItem](docs/DeviceNOCItem.md)
 - [DevicePaginationResponse](docs/DevicePaginationResponse.md)
 - [DeviceProperty](docs/DeviceProperty.md)
 - [DeviceSDTHistoryPaginationResponse](docs/DeviceSDTHistoryPaginationResponse.md)
 - [DeviceSLAWidget](docs/DeviceSLAWidget.md)
 - [DeviceSLAWidgetData](docs/DeviceSLAWidgetData.md)
 - [DeviceStatus](docs/DeviceStatus.md)
 - [DummyAutoDiscoveryMethod](docs/DummyAutoDiscoveryMethod.md)
 - [Duration](docs/Duration.md)
 - [DynamicColumn](docs/DynamicColumn.md)
 - [DynamicTableWidget](docs/DynamicTableWidget.md)
 - [DynamicTableWidgetColumn](docs/DynamicTableWidgetColumn.md)
 - [DynamicTableWidgetData](docs/DynamicTableWidgetData.md)
 - [DynamicTableWidgetRow](docs/DynamicTableWidgetRow.md)
 - [EC2AutoDiscoveryMethod](docs/EC2AutoDiscoveryMethod.md)
 - [EC2NetscanPolicyCredential](docs/EC2NetscanPolicyCredential.md)
 - [EC2ScheduledEventAutoDiscoveryMethod](docs/EC2ScheduledEventAutoDiscoveryMethod.md)
 - [ESXAutoDiscoveryMethod](docs/ESXAutoDiscoveryMethod.md)
 - [ESXCollectorAttribute](docs/ESXCollectorAttribute.md)
 - [Ec2DDR](docs/Ec2DDR.md)
 - [Ec2Netscan](docs/Ec2Netscan.md)
 - [EchoEventSource](docs/EchoEventSource.md)
 - [EndpointPaginationResponse](docs/EndpointPaginationResponse.md)
 - [EnhancedScriptNetscan](docs/EnhancedScriptNetscan.md)
 - [EntityProperty](docs/EntityProperty.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [EscalatingChain](docs/EscalatingChain.md)
 - [EscalationChainPaginationResponse](docs/EscalationChainPaginationResponse.md)
 - [EventSource](docs/EventSource.md)
 - [EventSourcePaginationResponse](docs/EventSourcePaginationResponse.md)
 - [EventsourcesImportxmlBody](docs/EventsourcesImportxmlBody.md)
 - [ExcludeDuplicateIps](docs/ExcludeDuplicateIps.md)
 - [FilterBy](docs/FilterBy.md)
 - [FlashWidget](docs/FlashWidget.md)
 - [FlowRecordPaginationResponse](docs/FlowRecordPaginationResponse.md)
 - [GaugeDataPoint](docs/GaugeDataPoint.md)
 - [GaugeWidget](docs/GaugeWidget.md)
 - [GaugeWidgetData](docs/GaugeWidgetData.md)
 - [GcpAccountTestResult](docs/GcpAccountTestResult.md)
 - [GcpAppEngineDiscoveryMethod](docs/GcpAppEngineDiscoveryMethod.md)
 - [GcpAtomEventSource](docs/GcpAtomEventSource.md)
 - [GcpBackendServiceHealthCollectorAttributeV3](docs/GcpBackendServiceHealthCollectorAttributeV3.md)
 - [GcpBillingBigQuerySourceCollectorAttribute](docs/GcpBillingBigQuerySourceCollectorAttribute.md)
 - [GcpBillingBigQuerySourceDiscoveryMethodV3](docs/GcpBillingBigQuerySourceDiscoveryMethodV3.md)
 - [GcpBillingCollectorAttribute](docs/GcpBillingCollectorAttribute.md)
 - [GcpBillingDiscoveryMethodV3](docs/GcpBillingDiscoveryMethodV3.md)
 - [GcpComputeServiceLimitsCollectorAttributeV3](docs/GcpComputeServiceLimitsCollectorAttributeV3.md)
 - [GcpLBBackendServiceDiscoveryMethodV3](docs/GcpLBBackendServiceDiscoveryMethodV3.md)
 - [GcpPubSubSnapshotDiscoveryMethodV3](docs/GcpPubSubSnapshotDiscoveryMethodV3.md)
 - [GcpPubSubSubscriptionDiscoveryMethodV3](docs/GcpPubSubSubscriptionDiscoveryMethodV3.md)
 - [GcpStackDriverCollectorAttributeV3](docs/GcpStackDriverCollectorAttributeV3.md)
 - [GcpVpnTunnelDiscoveryMethodV3](docs/GcpVpnTunnelDiscoveryMethodV3.md)
 - [GenerateReportRequest](docs/GenerateReportRequest.md)
 - [GenerateReportResult](docs/GenerateReportResult.md)
 - [GlobMatchToggle](docs/GlobMatchToggle.md)
 - [GoogleMapWidget](docs/GoogleMapWidget.md)
 - [GoogleMapWidgetData](docs/GoogleMapWidgetData.md)
 - [GraphDisplay](docs/GraphDisplay.md)
 - [GraphLine](docs/GraphLine.md)
 - [GraphOpsNoteScope](docs/GraphOpsNoteScope.md)
 - [GraphPlot](docs/GraphPlot.md)
 - [GraphPlotLine](docs/GraphPlotLine.md)
 - [GraphVirtualDataPoint](docs/GraphVirtualDataPoint.md)
 - [GroupByItems](docs/GroupByItems.md)
 - [GroupNetFlowRecord](docs/GroupNetFlowRecord.md)
 - [HostCpuReport](docs/HostCpuReport.md)
 - [HostGroupInventoryReport](docs/HostGroupInventoryReport.md)
 - [HostInventoryMetric](docs/HostInventoryMetric.md)
 - [HostInventoryReport](docs/HostInventoryReport.md)
 - [HostMetricsReport](docs/HostMetricsReport.md)
 - [HtmlWidget](docs/HtmlWidget.md)
 - [HttpAutoDiscoveryMethod](docs/HttpAutoDiscoveryMethod.md)
 - [ILP](docs/ILP.md)
 - [IPMIAutoDiscoveryMethod](docs/IPMIAutoDiscoveryMethod.md)
 - [IPMICollectorAttribute](docs/IPMICollectorAttribute.md)
 - [IPMIEventSource](docs/IPMIEventSource.md)
 - [InheritanceProp](docs/InheritanceProp.md)
 - [InstanceGroupAlertThresholdInfo](docs/InstanceGroupAlertThresholdInfo.md)
 - [IntegrationAuditLog](docs/IntegrationAuditLog.md)
 - [IntegrationAuditLogPaginationResponse](docs/IntegrationAuditLogPaginationResponse.md)
 - [IntegrationMetadata](docs/IntegrationMetadata.md)
 - [InterfBandwidthReport](docs/InterfBandwidthReport.md)
 - [InterfaceType](docs/InterfaceType.md)
 - [InterfacesFilter](docs/InterfacesFilter.md)
 - [InternalCollectorAttribute](docs/InternalCollectorAttribute.md)
 - [ItemData](docs/ItemData.md)
 - [JDBCAutoDiscoveryMethod](docs/JDBCAutoDiscoveryMethod.md)
 - [JDBCCollectorAttribute](docs/JDBCCollectorAttribute.md)
 - [JMXAutoDiscoveryMethod](docs/JMXAutoDiscoveryMethod.md)
 - [JMXCollectorAttribute](docs/JMXCollectorAttribute.md)
 - [JSONObject](docs/JSONObject.md)
 - [LabelValuePair](docs/LabelValuePair.md)
 - [LinkedWmiClass](docs/LinkedWmiClass.md)
 - [LocationData](docs/LocationData.md)
 - [LogFile](docs/LogFile.md)
 - [LogFileEventSource](docs/LogFileEventSource.md)
 - [LogPartition](docs/LogPartition.md)
 - [LogPartitionChangelog](docs/LogPartitionChangelog.md)
 - [LogSource](docs/LogSource.md)
 - [LogSourceLogField](docs/LogSourceLogField.md)
 - [LogSourcePaginationResponse](docs/LogSourcePaginationResponse.md)
 - [LogsInfo](docs/LogsInfo.md)
 - [LogsWidget](docs/LogsWidget.md)
 - [Macro](docs/Macro.md)
 - [MapItemInfo](docs/MapItemInfo.md)
 - [MapModuleToAccessGroup](docs/MapModuleToAccessGroup.md)
 - [MatchPattern](docs/MatchPattern.md)
 - [MemcachedCollectorAttribute](docs/MemcachedCollectorAttribute.md)
 - [Metric](docs/Metric.md)
 - [NMapDDR](docs/NMapDDR.md)
 - [NMapNetscan](docs/NMapNetscan.md)
 - [NOCItemBase](docs/NOCItemBase.md)
 - [NOCWidget](docs/NOCWidget.md)
 - [NOCWidgetData](docs/NOCWidgetData.md)
 - [NTLMAuthentication](docs/NTLMAuthentication.md)
 - [NameAndValue](docs/NameAndValue.md)
 - [NbarApplicationNames](docs/NbarApplicationNames.md)
 - [NetAppAutoDiscoveryMethod](docs/NetAppAutoDiscoveryMethod.md)
 - [NetAppCollectorAttribute](docs/NetAppCollectorAttribute.md)
 - [NetFlowRecord](docs/NetFlowRecord.md)
 - [NetflowAlertModulesCollectorAttributeV3](docs/NetflowAlertModulesCollectorAttributeV3.md)
 - [NetflowApplication](docs/NetflowApplication.md)
 - [NetflowBandwidth](docs/NetflowBandwidth.md)
 - [NetflowBgpTable](docs/NetflowBgpTable.md)
 - [NetflowDataBase](docs/NetflowDataBase.md)
 - [NetflowDeviceInfo](docs/NetflowDeviceInfo.md)
 - [NetflowEndpoint](docs/NetflowEndpoint.md)
 - [NetflowFilters](docs/NetflowFilters.md)
 - [NetflowGraphWidget](docs/NetflowGraphWidget.md)
 - [NetflowGroupGraphWidget](docs/NetflowGroupGraphWidget.md)
 - [NetflowGroupWidget](docs/NetflowGroupWidget.md)
 - [NetflowGroupWidgetData](docs/NetflowGroupWidgetData.md)
 - [NetflowNbarApplication](docs/NetflowNbarApplication.md)
 - [NetflowPort](docs/NetflowPort.md)
 - [NetflowQoSReportTableRow](docs/NetflowQoSReportTableRow.md)
 - [NetflowReport](docs/NetflowReport.md)
 - [NetflowWidget](docs/NetflowWidget.md)
 - [NetflowWidgetData](docs/NetflowWidgetData.md)
 - [Netscan](docs/Netscan.md)
 - [NetscanPaginationResponse](docs/NetscanPaginationResponse.md)
 - [NextUpgradeInfo](docs/NextUpgradeInfo.md)
 - [NormalGraphWidget](docs/NormalGraphWidget.md)
 - [ObjectNode](docs/ObjectNode.md)
 - [OidSourcePaginationResponse](docs/OidSourcePaginationResponse.md)
 - [OnetimeUpgradeInfo](docs/OnetimeUpgradeInfo.md)
 - [OpenMetricCollectorAttributeV3](docs/OpenMetricCollectorAttributeV3.md)
 - [OpenMetricDiscoveryMethod](docs/OpenMetricDiscoveryMethod.md)
 - [OpsNote](docs/OpsNote.md)
 - [OpsNoteDeviceGroupScope](docs/OpsNoteDeviceGroupScope.md)
 - [OpsNoteDeviceScope](docs/OpsNoteDeviceScope.md)
 - [OpsNoteGroupAllScope](docs/OpsNoteGroupAllScope.md)
 - [OpsNotePaginationResponse](docs/OpsNotePaginationResponse.md)
 - [OpsNoteScope](docs/OpsNoteScope.md)
 - [OpsNoteTagBase](docs/OpsNoteTagBase.md)
 - [OpsNoteWebsiteGroupScope](docs/OpsNoteWebsiteGroupScope.md)
 - [OpsNoteWebsiteScope](docs/OpsNoteWebsiteScope.md)
 - [OverviewGraphDataPoint](docs/OverviewGraphDataPoint.md)
 - [OverviewGraphWidget](docs/OverviewGraphWidget.md)
 - [PDHAutoDiscoveryMethod](docs/PDHAutoDiscoveryMethod.md)
 - [PaaSJsonPathDiscoveryMethod](docs/PaaSJsonPathDiscoveryMethod.md)
 - [PaaSMongoDbCollectorAttribute](docs/PaaSMongoDbCollectorAttribute.md)
 - [Pagination](docs/Pagination.md)
 - [PerfmonCollectorAttribute](docs/PerfmonCollectorAttribute.md)
 - [PerfmonCounter](docs/PerfmonCounter.md)
 - [Period](docs/Period.md)
 - [PieChartData](docs/PieChartData.md)
 - [PieChartDataPoint](docs/PieChartDataPoint.md)
 - [PieChartInfo](docs/PieChartInfo.md)
 - [PieChartItem](docs/PieChartItem.md)
 - [PieChartWidget](docs/PieChartWidget.md)
 - [PieChartWidgetData](docs/PieChartWidgetData.md)
 - [PingCheck](docs/PingCheck.md)
 - [PingCollectorAttribute](docs/PingCollectorAttribute.md)
 - [PointSource](docs/PointSource.md)
 - [PortAutoDiscoveryMethod](docs/PortAutoDiscoveryMethod.md)
 - [PortPaginationResponse](docs/PortPaginationResponse.md)
 - [Privilege](docs/Privilege.md)
 - [PropertyMatchRule](docs/PropertyMatchRule.md)
 - [PropertyPaginationResponse](docs/PropertyPaginationResponse.md)
 - [PropertyRule](docs/PropertyRule.md)
 - [PropertyRulePaginationResponse](docs/PropertyRulePaginationResponse.md)
 - [PushModulesCollectorAttribute](docs/PushModulesCollectorAttribute.md)
 - [RabbitMQQueueAutoDiscoveryMethod](docs/RabbitMQQueueAutoDiscoveryMethod.md)
 - [RawDataValues](docs/RawDataValues.md)
 - [Recipient](docs/Recipient.md)
 - [RecipientGroup](docs/RecipientGroup.md)
 - [RecipientGroupPaginationResponse](docs/RecipientGroupPaginationResponse.md)
 - [ReportBase](docs/ReportBase.md)
 - [ReportGroup](docs/ReportGroup.md)
 - [ReportGroupPaginationResponse](docs/ReportGroupPaginationResponse.md)
 - [ReportPaginationResponse](docs/ReportPaginationResponse.md)
 - [ReportRecipient](docs/ReportRecipient.md)
 - [ResourceDataSourceAlertThresholdInfo](docs/ResourceDataSourceAlertThresholdInfo.md)
 - [ResourceGroupSDT](docs/ResourceGroupSDT.md)
 - [ResourceSDT](docs/ResourceSDT.md)
 - [Response](docs/Response.md)
 - [RestAWSVerifyBillingPermissionsV3](docs/RestAWSVerifyBillingPermissionsV3.md)
 - [RestAppliesToFunctionPaginationResponse](docs/RestAppliesToFunctionPaginationResponse.md)
 - [RestAwsAccountTestV3](docs/RestAwsAccountTestV3.md)
 - [RestAwsHealthEventSource](docs/RestAwsHealthEventSource.md)
 - [RestAwsOrganizationalHealthEventSource](docs/RestAwsOrganizationalHealthEventSource.md)
 - [RestAwsRdsPerformanceInsightsEventSource](docs/RestAwsRdsPerformanceInsightsEventSource.md)
 - [RestAwsTrustedAdvisorEventSource](docs/RestAwsTrustedAdvisorEventSource.md)
 - [RestAzureAccountTestV3](docs/RestAzureAccountTestV3.md)
 - [RestAzureAdvisorEventSource](docs/RestAzureAdvisorEventSource.md)
 - [RestAzureResourceHealthEventSource](docs/RestAzureResourceHealthEventSource.md)
 - [RestAzureResourceLogAnalyticsWorkspacesSource](docs/RestAzureResourceLogAnalyticsWorkspacesSource.md)
 - [RestAzureStorageAccountVerify](docs/RestAzureStorageAccountVerify.md)
 - [RestAzureSubscriptionV3](docs/RestAzureSubscriptionV3.md)
 - [RestAzureSubscriptionsDiscoverV3](docs/RestAzureSubscriptionsDiscoverV3.md)
 - [RestCloudOkPermissionsV3](docs/RestCloudOkPermissionsV3.md)
 - [RestContractInfoBaseV3](docs/RestContractInfoBaseV3.md)
 - [RestDNSMappingV3](docs/RestDNSMappingV3.md)
 - [RestDashboardGroupAsyncCloneResponse](docs/RestDashboardGroupAsyncCloneResponse.md)
 - [RestDeviceInstanceGroupAlertConfigV3](docs/RestDeviceInstanceGroupAlertConfigV3.md)
 - [RestEventSourceFilter](docs/RestEventSourceFilter.md)
 - [RestGcpAccountTestV3](docs/RestGcpAccountTestV3.md)
 - [RestHighestPriorityCollectorStatus](docs/RestHighestPriorityCollectorStatus.md)
 - [RestLogSourceFilterV3](docs/RestLogSourceFilterV3.md)
 - [RestLogSourceResourceMappingV3](docs/RestLogSourceResourceMappingV3.md)
 - [RestMapModuleV3](docs/RestMapModuleV3.md)
 - [RestNMapNetscanPolicyCredential](docs/RestNMapNetscanPolicyCredential.md)
 - [RestNetscanPorts](docs/RestNetscanPorts.md)
 - [RestOidV3](docs/RestOidV3.md)
 - [RestResponse](docs/RestResponse.md)
 - [RestResponseMetaBlock](docs/RestResponseMetaBlock.md)
 - [RestSaaSAccountTestV3](docs/RestSaaSAccountTestV3.md)
 - [RestSavedMapWidgetV3](docs/RestSavedMapWidgetV3.md)
 - [RestSchedule](docs/RestSchedule.md)
 - [RestUsageContractInfoV4](docs/RestUsageContractInfoV4.md)
 - [RestUserCustomizedDataV3](docs/RestUserCustomizedDataV3.md)
 - [RestVizWidgetDataV3](docs/RestVizWidgetDataV3.md)
 - [ResultItem](docs/ResultItem.md)
 - [Role](docs/Role.md)
 - [RolePaginationResponse](docs/RolePaginationResponse.md)
 - [RoleReport](docs/RoleReport.md)
 - [RowData](docs/RowData.md)
 - [SDKScriptCollectorAttribute](docs/SDKScriptCollectorAttribute.md)
 - [SDKScriptDiscoveryMethod](docs/SDKScriptDiscoveryMethod.md)
 - [SDT](docs/SDT.md)
 - [SDTHistory](docs/SDTHistory.md)
 - [SDTPaginationResponse](docs/SDTPaginationResponse.md)
 - [SLAReport](docs/SLAReport.md)
 - [SNMPAutoDiscoveryMethod](docs/SNMPAutoDiscoveryMethod.md)
 - [SNMPCollectorAttribute](docs/SNMPCollectorAttribute.md)
 - [SNMPILP](docs/SNMPILP.md)
 - [SaaSO365SharePointSiteDiscoveryMethod](docs/SaaSO365SharePointSiteDiscoveryMethod.md)
 - [SaaSSlackHealthDiscoveryMethod](docs/SaaSSlackHealthDiscoveryMethod.md)
 - [SaaSWebexLicenseDiscoveryMethod](docs/SaaSWebexLicenseDiscoveryMethod.md)
 - [SaaSZoomPlanUsageDiscoveryMethod](docs/SaaSZoomPlanUsageDiscoveryMethod.md)
 - [SaaSZoomStatusDiscoveryMethod](docs/SaaSZoomStatusDiscoveryMethod.md)
 - [SaasAccountTestResult](docs/SaasAccountTestResult.md)
 - [SaasAirbrakeCollectorAttribute](docs/SaasAirbrakeCollectorAttribute.md)
 - [SaasAirbrakeDiscoveryMethod](docs/SaasAirbrakeDiscoveryMethod.md)
 - [SaasO365MailboxDiscoveryMethod](docs/SaasO365MailboxDiscoveryMethod.md)
 - [SaasO365ServiceHealthDiscoveryMethod](docs/SaasO365ServiceHealthDiscoveryMethod.md)
 - [SaasO365SkusDiscoveryMethod](docs/SaasO365SkusDiscoveryMethod.md)
 - [SaasOffice365CsvReportCollectorAttributeV3](docs/SaasOffice365CsvReportCollectorAttributeV3.md)
 - [SaasOffice365HealthCollectorAttributeV3](docs/SaasOffice365HealthCollectorAttributeV3.md)
 - [SaasOffice365SharepointReportCollectorAttributeV3](docs/SaasOffice365SharepointReportCollectorAttributeV3.md)
 - [SaasOffice365SkusCollectorAttribute](docs/SaasOffice365SkusCollectorAttribute.md)
 - [SaasOffice365TeamsCallsQosCollectorAttributeV3](docs/SaasOffice365TeamsCallsQosCollectorAttributeV3.md)
 - [SaasSalesforceInstanceStatusCollectorAttributeV3](docs/SaasSalesforceInstanceStatusCollectorAttributeV3.md)
 - [SaasSalesforceJsonCollectorAttributeV3](docs/SaasSalesforceJsonCollectorAttributeV3.md)
 - [SaasSalesforceLicenseDiscoveryMethod](docs/SaasSalesforceLicenseDiscoveryMethod.md)
 - [SaasSalesforceSOQLQueryCollectorAttributeV3](docs/SaasSalesforceSOQLQueryCollectorAttributeV3.md)
 - [SaasSlackHealthCollectorAttribute](docs/SaasSlackHealthCollectorAttribute.md)
 - [SaasStatusCollectorAttribute](docs/SaasStatusCollectorAttribute.md)
 - [SaasStatusDiscoveryMethod](docs/SaasStatusDiscoveryMethod.md)
 - [SaasWebexCollectorAttribute](docs/SaasWebexCollectorAttribute.md)
 - [SaasZoomJsonCollectorAttributeV3](docs/SaasZoomJsonCollectorAttributeV3.md)
 - [SaasZoomPlanUsageCollectorAttributeV3](docs/SaasZoomPlanUsageCollectorAttributeV3.md)
 - [SaasZoomRoomDiscoveryMethod](docs/SaasZoomRoomDiscoveryMethod.md)
 - [ScriptAutoDiscoveryMethod](docs/ScriptAutoDiscoveryMethod.md)
 - [ScriptCollectorAttribute](docs/ScriptCollectorAttribute.md)
 - [ScriptERIDiscoveryAttributeV3](docs/ScriptERIDiscoveryAttributeV3.md)
 - [ScriptEventSource](docs/ScriptEventSource.md)
 - [ScriptNetscan](docs/ScriptNetscan.md)
 - [ServiceAlert](docs/ServiceAlert.md)
 - [SeverityFilters](docs/SeverityFilters.md)
 - [SiteMonitorCheckPointPaginationResponse](docs/SiteMonitorCheckPointPaginationResponse.md)
 - [SiteMonitorCheckpoint](docs/SiteMonitorCheckpoint.md)
 - [SlaMetric](docs/SlaMetric.md)
 - [SnmpTrapEventSource](docs/SnmpTrapEventSource.md)
 - [StatsDGraph](docs/StatsDGraph.md)
 - [StatsDGraphDisplay](docs/StatsDGraphDisplay.md)
 - [StatsDMetricDefinition](docs/StatsDMetricDefinition.md)
 - [StatsDWidget](docs/StatsDWidget.md)
 - [SyntheticsSeleniumAutoDiscoveryMethodV3](docs/SyntheticsSeleniumAutoDiscoveryMethodV3.md)
 - [SyntheticsSeleniumCollectorAttribute](docs/SyntheticsSeleniumCollectorAttribute.md)
 - [SysLogEventSource](docs/SysLogEventSource.md)
 - [TCPCollectorAttribute](docs/TCPCollectorAttribute.md)
 - [TableWidget](docs/TableWidget.md)
 - [TableWidgetColumn](docs/TableWidgetColumn.md)
 - [TableWidgetData](docs/TableWidgetData.md)
 - [TableWidgetDataPoint](docs/TableWidgetDataPoint.md)
 - [TableWidgetForecastConfiguration](docs/TableWidgetForecastConfiguration.md)
 - [TableWidgetInstanceCell](docs/TableWidgetInstanceCell.md)
 - [TableWidgetRow](docs/TableWidgetRow.md)
 - [TextWidget](docs/TextWidget.md)
 - [TopologySource](docs/TopologySource.md)
 - [TopologySourcePaginationResponse](docs/TopologySourcePaginationResponse.md)
 - [TreeNode](docs/TreeNode.md)
 - [UDPCollectorAttribute](docs/UDPCollectorAttribute.md)
 - [UnmonitoredDevicePaginationResponse](docs/UnmonitoredDevicePaginationResponse.md)
 - [UnmonitoredDevices](docs/UnmonitoredDevices.md)
 - [UpdateReason](docs/UpdateReason.md)
 - [UpdateReasons](docs/UpdateReasons.md)
 - [Usage](docs/Usage.md)
 - [UserFilter](docs/UserFilter.md)
 - [UserReport](docs/UserReport.md)
 - [VirtualDataPoint](docs/VirtualDataPoint.md)
 - [Viz](docs/Viz.md)
 - [VizFilterItem](docs/VizFilterItem.md)
 - [WMIAutoDiscoveryMethod](docs/WMIAutoDiscoveryMethod.md)
 - [WMICollectorAttribute](docs/WMICollectorAttribute.md)
 - [WebCheck](docs/WebCheck.md)
 - [WebCheckStep](docs/WebCheckStep.md)
 - [WebPageCollectorAttribute](docs/WebPageCollectorAttribute.md)
 - [WebResource](docs/WebResource.md)
 - [Website](docs/Website.md)
 - [WebsiteCheckPoint](docs/WebsiteCheckPoint.md)
 - [WebsiteCheckpointRawData](docs/WebsiteCheckpointRawData.md)
 - [WebsiteCheckpointSDT](docs/WebsiteCheckpointSDT.md)
 - [WebsiteCollectorInfo](docs/WebsiteCollectorInfo.md)
 - [WebsiteGraphWidget](docs/WebsiteGraphWidget.md)
 - [WebsiteGroup](docs/WebsiteGroup.md)
 - [WebsiteGroupData](docs/WebsiteGroupData.md)
 - [WebsiteGroupPaginationResponse](docs/WebsiteGroupPaginationResponse.md)
 - [WebsiteGroupSDT](docs/WebsiteGroupSDT.md)
 - [WebsiteGroupSDTHistoryPaginationResponse](docs/WebsiteGroupSDTHistoryPaginationResponse.md)
 - [WebsiteIndividualsStatusWidget](docs/WebsiteIndividualsStatusWidget.md)
 - [WebsiteItemConfig](docs/WebsiteItemConfig.md)
 - [WebsiteLocation](docs/WebsiteLocation.md)
 - [WebsiteNOCItem](docs/WebsiteNOCItem.md)
 - [WebsiteOverallStatusWidget](docs/WebsiteOverallStatusWidget.md)
 - [WebsiteOverviewReport](docs/WebsiteOverviewReport.md)
 - [WebsiteOverviewWidget](docs/WebsiteOverviewWidget.md)
 - [WebsitePaginationResponse](docs/WebsitePaginationResponse.md)
 - [WebsiteSDT](docs/WebsiteSDT.md)
 - [WebsiteSDTHistoryPaginationResponse](docs/WebsiteSDTHistoryPaginationResponse.md)
 - [WebsiteSLAReport](docs/WebsiteSLAReport.md)
 - [WebsiteSLAWidget](docs/WebsiteSLAWidget.md)
 - [WebsiteSLAWidgetData](docs/WebsiteSLAWidgetData.md)
 - [Widget](docs/Widget.md)
 - [WidgetData](docs/WidgetData.md)
 - [WidgetPaginationResponse](docs/WidgetPaginationResponse.md)
 - [WidgetToken](docs/WidgetToken.md)
 - [WidgetTokenInheritance](docs/WidgetTokenInheritance.md)
 - [WindowsEventLogEventSource](docs/WindowsEventLogEventSource.md)
 - [XENAutoDiscoveryMethod](docs/XENAutoDiscoveryMethod.md)
 - [XENCollectorAttribute](docs/XENCollectorAttribute.md)

## Documentation For Authorization


## LMv1

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author


